//***********************************************************
//  HPCI-CTR520F series
//  Library function for C#.NET2003
//      file name:spct5204.cs
//      date     :2010/06/11
//      version  :1.00
//***********************************************************
using System;

namespace spct5204
{
	/// <summary>
	/// spct5203 ̊Tv̐łB
	/// </summary>
	public class spct5204
	{
		// foCXnhl
		public const uint NO_DEVICE_HNDL = 0xFFFFFFFF;

	    public const byte ZTM_PORT = 0x20;		// yACxg^C}j^|[g
		public const byte INP_PORT = 0x28;		// ėp̓|[g
		public const byte OUT_PORT = 0x2C;		// ėpo̓|[g
		public const byte CMP_PORT = 0x30;		// Rp[^o͐ݒ|[g
		public const byte TMR_PORT = 0x32;		// Cxg^C}o͐ݒ|[g

		// vo͐ݒ|[g
		// XY/ZUOUT1`4ٽ104msec
		// XY/ZUOUT1,2o͑I
		public const byte CIN_PORT = 0x34;

		public const byte CLR_PORT = 0x36;		// JE^NAݒ|[g
		public const byte LTC_PORT = 0x38;		// b`ݒ|[g
		public const byte INT_PORT = 0x50;		// }XNݒ|[g
		public const byte PCI_PORT = 0x52;		// PCIoXւ̊}XNݒ|[g
	
		public const ushort M_CH = 4;			// ch ő吔(ftHg4)
		public const ushort X_CH = 0;			// Xch
		public const ushort Y_CH = 1;			// Ych
		public const ushort Z_CH = 2;			// Zch
		public const ushort U_CH = 3;			// Uch
	
		public const ushort MLT1_NO = 0;		// JEg͌`(ʑ {w1)
		public const ushort MLT2_NO = 1;		// JEg͌`(ʑ {w2)
		public const ushort MLT4_NO = 2;		// JEg͌`(ʑ {w4)
		public const ushort UPDN_NO = 3;		// JEg͌`(UP/DOWNpX)
		public const ushort DIRC_NO = 5;		// JEg͌`(ƃpX)
	
		public const uint CNTMAX = 16;			// {[hő喇 16
		public const uint ILL_PARAM = 0x100;	// ֐N̈G[
	
		public const uint BRD_ID = 0;			// {[hhc
	
		public static uint hDev;						// foCXnh
		public static uint gBrdID;						// {[hhc

		public spct5204()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		public static uint sct520_OpenID( ref uint hDevID, ref uint brdid )
		{
			uint hDev = NO_DEVICE_HNDL;
			uint n;
			uint ret;
			uint cnt = 0;
			hictr520.HPCDEVICEINFO[] hInf = new hictr520.HPCDEVICEINFO[CNTMAX];
			hictr520.HPCDEVICEINFO hInf2;

			hInf2.nBusNumber = 0;			// oXԍ
			hInf2.nDeviceNumber = 0;		// foCXԍ
			hInf2.dwIoPortAddress = 0;		// I/O|[gAhX
			hInf2.dwIrqNo = 0;				// IRQԍ
			hInf2.dwNumber = 0;				// Ǘԍ(Windows 95/98/Meł͖)
			hInf2.dwBoardID = 0;			// {[hID
		
			//{[h擾
			ret = hictr520.ct520_GetDeviceCount(ref cnt);
		
			//{[h 0,17ȏ ܂ ߂l "0" ̎G[
			if ((cnt == 0) || (cnt > CNTMAX) || (ret != 0))
			{
			    return( 0x1000 );
			}
		
			//foCX擾
			ret = hictr520.ct520_GetDeviceInfo(ref cnt, ref hInf[0]);
			if (ret != 0)
			{
				return( 0x2000 );
			}
		
			// {[hIDw
			for ( n=0; n<cnt; n++ )
			{
				if (hInf[n].dwBoardID == brdid)
				{
					hInf2 = hInf[n];
					break;
				}
				else
				{
					hInf2.dwBoardID = hInf[n].dwBoardID;
				}
			} 
		
			if ( hInf2.dwBoardID != brdid )
			{
				return( 0x4000 );
			}
		
			ret = hictr520.ct520_OpenDevice(ref hDev, ref hInf2);
			if ( ret!= 0)
			{
				ret = hictr520.ct520_CloseDevice(hDev);
				hDev = NO_DEVICE_HNDL;
				return( 0x8000 );
			}
			else
			{
				hDevID = hDev;
				return ( 0 );
			}
		}

		//***********************************************************
		//  {[h̏
		//     HPCI-CTR520F̏܂B
		//     gpɍ킹ēKXf[^ύXĂB
		//***********************************************************
		public static uint sct520_InitCtr(ref uint hDevID)
		{
			uint ret;
			uint reg = 0;

			// 1. #1CCLWX^ݒ
			// 1.1 \tgEFAZbg : ĳؾĎw߂őSĂڼ޽͂Oر
			ret = hictr520.ct520_wXYCmd(hDevID, 0x40);	// ȍ~̊eڼ޽̏͊mF
		
			// 1.2 #1CCL WX^P(͎dl,̑)
			const uint RENV1 = 0xACC3012;		// WX^Pݒl
			// b31   (0   ):ϒ[qo:_(ްގd:Œ)
			// b30-28( 000):Ϗo͎FȂ
			// b27   (1   ):ڰ4:YCTR
			// b26   ( 0  ):ڰ3:XCTR
			// b25   (  1 ):ڰ2:YCTR
			// b24   (   0):ڰ1:XCTR
			// b23-21(110 ):DSBnͶĒ~:  (ްގdl:Œ)
			// b20   (   0):LTCn͘_=贯(ްގdl:Œ)
			// b19   (1   ):YZͶر:
			// b18   ( 1  ):XZͶر:
			// b17-16(  00):YZ,XZ͸ر:贯
			// b15   (0   ):YCTRǏo̎ر:Ȃ
			// b14   ( 0  ):XCTRǏo̎ر:Ȃ
			// b13   (  1 ):YCTR~
			// b12   (   1):XCTR~
			// b11-10(00  ):YCTRފԑI(`)
			// b 9- 8(  00):YCTRފԑJn(`)
			// b 7   (0   ):YCTR:޳ݶ
			// b 6   ( 0  ):YCTR=YA,YB
			// b 5- 3( 010):YA,YB=90߈ʑS{
			// b 2- 0( 010):XA,XB=90߈ʑS{
			ret = hictr520.ct520_wXYReg(hDevID, 0x87, RENV1);
			ret = hictr520.ct520_rXYReg(hDevID, 0xC7, ref reg);	// ƍǍ
			if (reg != RENV1)  { return( 1 ); }
		
			// 1.3 #1CCL WX^Q(ڰ,̑)
			const uint RENV2 = 0x1005FF00;		// WX^Qݒl
			// b31-30(00  ):(CCLdl)
			// b29   (  0 ):XA,XB,YA,YB̨nm
			// b28   (   1):CMPOUT1,2o:Ͻ()
			// b27-24(0000):P0-3[q=ėp(ްގdl:Œ)
			// b23   (0   ):CMPOUT3,4[qo͘_=_
			// b22   ( 0  ):CMPOUT1,2[qo͘_=_
			// b21   (  0 ):CMPOUT2o͂"="r=Ȃ
			// b20   (   0):CMPOUT1o͂"="r=Ȃ
			// b19-18(01  ):CMPOUT3,4o͐Mٽ=ݼ50us
			// b17-16(  01):CMPOUT1,2o͐Mٽ=ݼ50us
			// b15-12(1111):CMPOUT4o͂̔r@=ɕs
			// b11- 8(1111):CMPOUT3o͂̔r@=ɕs
			// b 7- 4(0000):CMPOUT2o͂̔r@=RCMP1<r
			// b 3- 0(0000):CMPOUT1o͂̔r@=RCMP1<r
			ret = hictr520.ct520_wXYReg(hDevID, 0x88, RENV2);
			ret = hictr520.ct520_rXYReg(hDevID, 0xC8, ref reg);		// ƍǍ
			if (reg != RENV2) { return( 1 ); }
		
			// 1.4 #1CCL JE^P
			ret = hictr520.ct520_wXYReg(hDevID, 0x80, 0);		// JE^PO
			ret = hictr520.ct520_rXYReg(hDevID, 0xC0, ref reg);		//  ƍǍ
			if ( reg != 0 ) { return( 1 ); }
		
			// 1.5 #1CCL JE^Q
			ret = hictr520.ct520_wXYReg(hDevID, 0x81, 0);		// JE^QO
			ret = hictr520.ct520_rXYReg(hDevID, 0xC1, ref reg);	// ƍǍ
			if ( reg != 0 ) { return( 1 ); }
		
			// 1.6 #1CCL rf[^WX^P
			const uint WIND_N = unchecked((uint)(-5000));			// ޺ڰ:RCMP1
			ret = hictr520.ct520_wXYReg(hDevID, 0x82, WIND_N);	// rf[^WX^P= WIND_N
			ret = hictr520.ct520_rXYReg(hDevID, 0xC2, ref reg);	// ƍǍ
			if ( reg != WIND_N) { return( 1 ); }
		
			// 1.7 #1CCL rf[^WX^Q
			const uint WIND_P = 5000;			// ޺ڰ:RCMP2
			ret = hictr520.ct520_wXYReg(hDevID, 0x83, WIND_P);	// rf[^WX^Q= WIND_P
			ret = hictr520.ct520_rXYReg(hDevID, 0xC3, ref reg);		// ƍǍ
			if ( reg != WIND_P ) { return( 1 ); }
		
			// 1.8 #1CCL rf[^WX^R
			ret = hictr520.ct520_wXYReg(hDevID, 0x84, 0);		// rf[^WX^RO
			ret = hictr520.ct520_rXYReg(hDevID, 0xC4, ref reg);		// ƍǍ
			if ( reg != 0 ) { return( 1 ); }
		
			// 1.9 #1CCL rf[^WX^S
			ret = hictr520.ct520_wXYReg(hDevID, 0x85, 0);		// rf[^WX^SO
			ret = hictr520.ct520_rXYReg(hDevID, 0xC5, ref reg);		// ƍǍ
			if ( reg != 0 ) { return( 1 ); }
		
			// 1.10 #1CCL Cxg^C}WX^
			ret = hictr520.ct520_wXYReg(hDevID, 0x86, 0);		// Cxg^C}WX^O
			ret = hictr520.ct520_rXYReg(hDevID, 0xC6, ref reg);		// ƍǍ
			if ( reg != 0 ) { return( 1 ); }
		
			// 1.11 #1CCL vݒ背WX^
			// b31-28(0000):sgp
			// b27   (0   ):sgp
			// b26   ( 0  ):(ITM):gpJnƎw莞Ԍoߖ
			// b25   (  0 ):YCTR:MaxMin蒆(=0x4a)ɑIތo(RENV1:b11-10)
			// b24   (   0):߼߰ēׯ(0x18)ݒɂ铯ׯ
			// b23   (0   ):YCTR -ް۰
			// b22   ( 0  ):YCTR +ް۰
			// b21   (  0 ):XCTR -ް۰
			// b20   (   0):XCTR +ް۰
			// b19   (0   ):YAYB͐Mُ픭(ω)
			// b18   ( 0  ):XAXB͐Mُ픭(ω)
			// b17   (  0 ):YCTR<>0 ==> YCTR=0
			// b16   (   0):XCTR<>0 ==> XCTR=0
			// b15-12(0000):sgp(\)
			// b11-10(00  ):sgp(\)
			// b 9   (  0 ):߼߰YZر(0x19:b1)ݒɂ鶳ر
			// b 8   (   0):߼߰XZر(0x19:b0)ݒɂ鶳ر
			// b 7   (0   ):CMPOUT4o͏  ==>s
			// b 6   ( 0  ):CMPOUT4o͏s==>  
			// b 5   (  0 ):CMPOUT3o͏  ==>s
			// b 4   (   0):CMPOUT3o͏s==>  
			// b 3   (0   ):CMPOUT2o͏  ==>s
			// b 2   ( 0  ):CMPOUT2o͏s==>  
			// b 1   (  0 ):CMPOUT1o͏  ==>s
			// b 0   (   0):CMPOUT1o͏s==>  
			ret = hictr520.ct520_wXYReg(hDevID, 0x89, 0);		// all off
			ret = hictr520.ct520_rXYReg(hDevID, 0xC9, ref reg);	// ƍǍ
			if ( reg != 0 ) { return( 1 ); }
		
			ret = hictr520.ct520_wZUReg(hDevID, 0x87, 0x1000);
			ret = hictr520.ct520_rZUReg(hDevID, 0xC7, ref reg);	// ƍǍ
			if ( reg == 0x1000 )	// SȂ
			{

				// 2. #2CCLWX^ݒ
				// 2.1 \tgEFAZbg : ĳؾĎw߂őSĂڼ޽͂Oر
				ret = hictr520.ct520_wZUCmd(hDevID, 0x40);		// ȍ~̊eڼ޽̏͊mF
			
				// 2.2 #2CCL WX^P(͎dl,̑)
				// #1CCLƓl̐ݒ
				ret = hictr520.ct520_wZUReg(hDevID, 0x87, RENV1);
				ret = hictr520.ct520_rZUReg(hDevID, 0xC7, ref reg);	// ƍǍ
				if ( reg !=  RENV1 ) { return( 1 ); }
			
				// 2.3 #2CCL WX^Q(ڰ,̑)
				// #1CCLƓl̐ݒ
				ret = hictr520.ct520_wZUReg(hDevID, 0x88, RENV2);
				ret = hictr520.ct520_rZUReg(hDevID, 0xC8, ref reg);	// ƍǍ
				if ( reg != RENV2 ) { return( 1 ); }
			
				// 2.4 #2CCL JE^P
				ret = hictr520.ct520_wZUReg(hDevID, 0x80, 0);		// JE^PO
				ret = hictr520.ct520_rZUReg(hDevID, 0xC0, ref reg);	// ƍǍ
				if ( reg != 0 ) { return( 1 ); }
			
				// 2.5 #2CCL JE^Q
				ret = hictr520.ct520_wZUReg(hDevID, 0x81, 0);		// JE^QO
				ret = hictr520.ct520_rZUReg(hDevID, 0xC1, ref reg);	// ƍǍ
				if ( reg != 0 ) { return( 1 ); }
			
				// 2.6 #2CCL rf[^WX^P
				// #1CCLƓl̐ݒ
				ret = hictr520.ct520_wZUReg(hDevID, 0x82, WIND_N);	// rf[^WX^P= WIND_N
				ret = hictr520.ct520_rZUReg(hDevID, 0xC2, ref reg);	// ƍǍ
				if ( reg != WIND_N ) { return( 1 ); }
			
				// 2.7 #2CCL rf[^WX^Q
				// #1CCLƓl̐ݒ
				ret = hictr520.ct520_wZUReg(hDevID, 0x83, WIND_P);	// rf[^WX^Q= WIND_P
				ret = hictr520.ct520_rZUReg(hDevID, 0xC3, ref reg);	// ƍǍ
				if ( reg != WIND_P ) { return( 1 ); }
			
				// 2.8 #2CCL rf[^WX^R
				ret = hictr520.ct520_wZUReg(hDevID, 0x84, 0);		// rf[^WX^RO
				ret = hictr520.ct520_rZUReg(hDevID, 0xC4, ref reg);	// ƍǍ
				if ( reg != 0 ) { return( 1 ); }
			
				// 2.9 #2CCL rf[^WX^S
				ret = hictr520.ct520_wZUReg(hDevID, 0x85, 0);		// rf[^WX^SO
				ret = hictr520.ct520_rZUReg(hDevID, 0xC5, ref reg);	// ƍǍ
				if ( reg != 0 ) { return( 1 ); }
			
				// 2.10 #2CCL Cxg^C}WX^
				ret = hictr520.ct520_wZUReg(hDevID, 0x86, 0);		// Cxg^C}WX^O
				ret = hictr520.ct520_rZUReg(hDevID, 0xC6, ref reg);	// ƍǍ
				if ( reg != 0 ) { return( 1 ); }
			
				// 2.11 #2CCL vݒ背WX^
				ret = hictr520.ct520_wZUReg(hDevID, 0x89, 0);		// all off
				ret = hictr520.ct520_rZUReg(hDevID, (ushort)(0xC9), ref reg);				// ƍǍ
				if ( reg != 0 ) { return( 1 ); }
			}
		
			// 3. o̓|[g & IvV|[gݒ
			ret = sct520_InitOpt(ref hDevID);
			if ( ret != 0 )		return( 1 );	// G[
			else				return( 0 );	// I
		}

		//*********************************************************
		//  o̓|[gƃIvV|[g̏
		//      HPCI-CTR520F̃IvV|[g̏܂B
		//      gpɍ킹ēKXf[^ύXĂB
		//*********************************************************
		public static uint sct520_InitOpt(ref uint hDevID)
		{
			byte bdt = 0;
			ushort wdt = 0;
			uint ret;
		
			// o̓|[g & IvV|[gݒ
			// 1 ėpo̓|[gNA
			ret = hictr520.ct520_wPortB(hDevID, OUT_PORT, 0);	// write(0)
			ret = hictr520.ct520_rPortB(hDevID, OUT_PORT, ref bdt);	// ƍǍ
			bdt = (byte)(bdt & 0xF);							// mask
			if ( bdt != 0 ) { return( 1 ); }			// verify error
		
			// 2 CMPo͐ݒ|[gFo͂Ȃ
			ret = hictr520.ct520_wPortW(hDevID, CMP_PORT, 0);	// write(0)
			ret = hictr520.ct520_rPortW(hDevID, CMP_PORT, ref wdt);	// ƍǍ
			wdt = (ushort)(wdt & 0xFF);							// mask
			if ( wdt != 0 ) { return( 1 ); }			// verify error
		
			// 3 TMRo͐ݒ|[gFo͂Ȃ
			ret = hictr520.ct520_wPortW(hDevID, TMR_PORT, 0);	// write(0)
			ret = hictr520.ct520_rPortW(hDevID, TMR_PORT, ref wdt);	// ƍǍ
			wdt = (ushort)(wdt & 0x33);							// mask
			if ( wdt != 0 ) { return( 1 ); }			// verify error
		
			// 4 vo͐ݒ|[g(XYOUT1, ZUOUT1o͕104msec)
			ret = hictr520.ct520_wPortW(hDevID, CIN_PORT, 0x30);	// write
			ret = hictr520.ct520_rPortW(hDevID, CIN_PORT, ref wdt);	// ƍǍ
			wdt = (ushort)(wdt & 0xFF);							// mask
			if ( wdt !=  0x30 ) { return( 1 ); }		// verify error
		
			// 5 JE^NAݒ|[gݒFy͂ɂJE^NAȂ
			ret = hictr520.ct520_wPortW(hDevID, CLR_PORT, 0);	// write
			ret = hictr520.ct520_rPortW(hDevID, CLR_PORT, ref wdt);	// ƍǍ
			wdt = (ushort)(wdt & 0xF);							// mask
			if ( wdt != 0 ) { return( 1 ); }			// verify error
		
			// 6 b`ݒ|[gݒFb`Ȃ
			ret = hictr520.ct520_wPortW(hDevID, LTC_PORT, 0);	// write
			ret = hictr520.ct520_rPortW(hDevID, LTC_PORT, ref wdt);	// ƍǍ
			wdt = (ushort)(wdt & 0xFF);							// mask
			if ( wdt != 0 ) { return( 1 ); }			// verify error
		
			// 7 }XN()
			ret = hictr520.ct520_wPortW(hDevID, INT_PORT, 0);	// write
			ret = hictr520.ct520_rPortW(hDevID, INT_PORT, ref wdt);	// ƍǍ
			wdt = (ushort)(wdt & 0x7);							// mask
			if ( wdt != 0 ) { return( 1 ); }			// verify error
		
			// 8 }XN(PCI)
			ret = hictr520.ct520_wPortW(hDevID, PCI_PORT, 0);	// write
			ret = hictr520.ct520_rPortW(hDevID, PCI_PORT, ref wdt);	// ƍǍ
			wdt = (ushort)(wdt & 0x1);							// mask
			if ( wdt != 0 ) { return( 1 ); }			// verify error

			return( 0 );
		}
	
		//**************************************************
		// JE^͌`̑I
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//   md   FJE^͌`(O`T)
		//           0:x1, 1:x2, 2:x4, 3:U/D, 5:ٽ
		//      ڼ޽P: Ych(Uch)=b5-b3,Xch(Zch)=b2-b0
		//**************************************************
		public static void sct520_SelCtrMode(ref uint hDevID, ref ushort ch, ref ushort md)
		{
			uint reg = 0;
			uint ret;
		
			if ( ch < 2 ) 
			{
				ret = hictr520.ct520_rXYReg(hDevID, 0xC7, ref reg);		// WX^P
				if ( ch == X_CH ) 
				{
					reg = reg & unchecked((uint)(~0x7));
					reg = reg | md;			// b2-b0
				}
				else
				{
					reg = reg & unchecked((uint)(~0x38));
					reg = reg | (uint)(md * 8);		// b5-b3
				}
				ret = hictr520.ct520_wXYReg(hDevID, 0x87, reg);		// WX^P
			}
			else if ( ch < 4 )
			{
				ret = hictr520.ct520_rZUReg(hDevID, 0xC7, ref reg);		// WX^P
				if ( ch == Z_CH )
				{
					reg = reg & unchecked((uint)(~0x7));
					reg = reg | md;			// b2-b0
				}
				else
				{
					reg = reg & unchecked((uint)(~0x38));
					reg = reg | (uint)(md * 8);		// b5-b3
				}
				ret = hictr520.ct520_wZUReg(hDevID, 0x87, reg);		// WX^P
			}
		}
	
		//**************************************************
		// JE^ǏõJE^NAݒ
		//   @\ FJE^Ǐo, JE^NA܂B
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//   sel  FJE^NA(1) / Ȃ(0)
		//      ڼ޽P: Ych,Uch=b15,Xch,Zch=b14
		//**************************************************
		public static void sct520_SetAutoClr(ref uint hDevID, ref ushort ch, ref ushort sel)
		{
			uint reg = 0;
			uint ret;
		
			if ( ch < 2 )
			{
				ret = hictr520.ct520_rXYReg(hDevID, 0xC7, ref reg);		// WX^P
				if ( ch == X_CH )
				{
					if ( sel == 1 )
						reg = reg | 0x4000;			// b14=1
					else
						reg = reg & unchecked((uint)(~0x4000));		// b14=0
				}				
				else
				{
					if ( sel == 1 )
						reg = reg | 32768;			// b15=1
					else
						reg = reg & unchecked((uint)(~32768));		// b15=0
				}
				ret = hictr520.ct520_wXYReg(hDevID, 0x87, reg);		// WX^P
			}
			else if ( ch < 4 )
			{ 
				ret = hictr520.ct520_rZUReg(hDevID, 0xC7, ref reg);		// WX^P
				if ( ch == Z_CH )
				{
					if ( sel == 1 )
						reg = reg | 0x4000;			// b14=1
					else
						reg = reg & unchecked((uint)(~0x4000));		// b14=0
				}
				else
				{
					if ( sel == 1 )
						reg = reg | 32768;			// b15=1
					else
						reg = reg & unchecked((uint)(~32768));		// b15=0
				}
				ret = hictr520.ct520_wZUReg(hDevID, 0x87, reg);		// WX^P
			}
		}
	
		//**************************************************
		// JEgX^[g
		//   @\ FJEgJn܂B
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//      ڼ޽P: Ych(Uch):b13=0, Xch(Zch):b12=0
		//**************************************************
		public static void sct520_StrtCtr(ref uint hDevID, ref ushort ch)
		{
			uint reg = 0;
			uint ret;
		
			if ( ch < 2 )
			{
				ret = hictr520.ct520_rXYReg(hDevID, 0xC7, ref reg);		// WX^P
				if ( ch == X_CH )
					reg = reg & unchecked((uint)(~0x1000));		// b12=0
				else
					reg = reg & unchecked((uint)(~0x2000));		// b13=0
				ret = hictr520.ct520_wXYReg(hDevID, 0x87, reg);			// WX^P
			}	
			else if ( ch < 4 )
			{	 
				ret = hictr520.ct520_rZUReg(hDevID, 0xC7, ref reg);	// WX^P
				if ( ch == Z_CH )
					reg = reg & unchecked((uint)(~0x1000));	// b12=0
				else
					reg = reg & unchecked((uint)(~0x2000));	// b13=0
				ret = hictr520.ct520_wZUReg(hDevID, 0x87, reg);			// WX^P
			}
		}
	
		//**************************************************
		// JEgXgbv
		//   @\ FJEg~܂B
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//      ڼ޽P: Ych,Uch=b13,Xch,Zch=b12
		//**************************************************
		public static void sct520_StopCtr(ref uint hDevID, ref ushort ch)
		{
			uint reg = 0;
			uint ret;
		
			if ( ch < 2 )
			{
				ret = hictr520.ct520_rXYReg(hDevID, 0xC7, ref reg);		// WX^P
				if ( ch == X_CH )
					reg = reg | 0x1000;		// b12=1
				else
					reg = reg | 0x2000;		// b13=1
				ret = hictr520.ct520_wXYReg(hDevID, 0x87, reg);			// WX^P
			}
			else if ( ch < 4 )
			{ 
				ret = hictr520.ct520_rZUReg(hDevID, 0xC7, ref reg);		// WX^P
				if ( ch == Z_CH )
					reg = reg | 0x1000;		// b12=1
				else
					reg = reg | 0x2000;		// b13=1
				ret = hictr520.ct520_wZUReg(hDevID, 0x87, reg);			// WX^P
			}
		}
	
		//**************************************************
		// JE^Ǎ
		//   @\ FJEgǍ݂܂B
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//   ctr  FJE^̒l
		//    Ǎ Xch,Zch=0xC0, Ych,Uch=0xC1
		//**************************************************
		public static void sct520_ReadCtr(ref uint hDevID, ref ushort ch, ref uint ctr)
		{
			uint ret;
		
			if ( ch < 2 )
				ret = hictr520.ct520_rXYReg(hDevID, (ushort)(0xC0 + ch), ref ctr);		// ڼ޽Ǎ
			else if ( ch < 4 ) 
				ret = hictr520.ct520_rZUReg(hDevID, (ushort)(0xC0 + (ch - 2)), ref ctr);	// ڼ޽Ǎ
		}
	
		//**************************************************
		// b`f[^Ǎ
		//   @\ Fb`f[^Ǎ݂܂B
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//   ltc  Fb`f[^̒l
		//   Ǎ Xch,Zch=0xCA, Ych,Uch=0xCB
		//**************************************************
		public static void sct520_ReadLtc(ref uint hDevID, ref ushort ch, ref uint ltc)
		{
			uint ret;

			if ( ch < 2 )
				ret = hictr520.ct520_rXYReg(hDevID, (ushort)(0xCA + ch), ref ltc);		// ڼ޽Ǎ
			else if ( ch < 4 ) 
				ret = hictr520.ct520_rZUReg(hDevID, (ushort)(0xCA + (ch - 2)), ref ltc);	// ڼ޽Ǎ
		}	
	
		//**************************************************
		// őlf[^Ǎ
		//   @\ Főlf[^Ǎ݂܂B
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//   max  Főlf[^̒l
		//    Ǎ Xch,Zch=0xCC, Ych,Uch=0xCE
		//**************************************************
		public static void sct520_ReadMax(ref uint hDevID, ref ushort ch, ref uint max)
		{
			uint ret;
		
			if ( ch < 2 )
				ret = hictr520.ct520_rXYReg(hDevID, (ushort)(0xCC + (ch * 2)), ref max);	// ڼ޽Ǎ
			else if ( ch < 4 ) 
				ret = hictr520.ct520_rZUReg(hDevID, (ushort)(0xCC + ((ch - 2) * 2)), ref max);	// ڼ޽Ǎ
		}
	
		//**************************************************
		// ŏlf[^Ǎ
		//   @\ Fŏlf[^Ǎ݂܂B
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//   min  Fŏlf[^̒l
		//    Ǎ Xch,Zch=0xCD, Ych,Uch=0xCF
		//**************************************************
		public static void sct520_ReadMin(ref uint hDevID, ref ushort ch, ref uint min)
		{
			uint ret;
		
			if ( ch < 2 )
				ret = hictr520.ct520_rXYReg(hDevID, (ushort)(0xCD + (ch * 2)), ref min);		// ڼ޽Ǎ
			else if ( ch < 4 ) 
				ret = hictr520.ct520_rZUReg(hDevID, (ushort)(0xCD + ((ch - 2) * 2)), ref min);	// ڼ޽Ǎ
		}
	
		//**************************************************
		// JE^NA
		//   @\ FJE^NA(=0)܂B
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//     Xch,Zch=0x1, Ych,Uch=0x2
		//**************************************************
		public static void sct520_ClrCtr(ref uint hDevID, ref ushort ch)
		{
			uint ret;
		
			if ( ch < 2 )
				ret = hictr520.ct520_wXYCmd(hDevID, (ushort)(ch + 1));		// Pƺޏ
			else if ( ch < 4 ) 
				ret = hictr520.ct520_wZUCmd(hDevID, (ushort)(ch - 1));		// Pƺޏ
		}
	
		//**************************************************
		// MaxMin
		//   @\ Főlŏl(=݂̃JEgl)
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//     Xch,Zch=0x4, Ych,Uch=0x8
		//**************************************************
		public static void sct520_InitMM(ref uint hDevID, ref ushort ch)
		{
			uint ret;
		
			if ( ch < 2 )
				ret = hictr520.ct520_wXYCmd(hDevID, (ushort)(4 + (ch * 4)));		// Pƺޏ
			else if ( ch < 4 ) 
				ret = hictr520.ct520_wZUCmd(hDevID, (ushort)(4 + ((ch - 2) * 4)));	// Pƺޏ
		}
	
		//**************************************************
		// MaxMinJn
		//   @\ FMaxMinJn܂B
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//     Xch,Zch=0x48, Ych,Uch=0x4A
		//**************************************************
		public static void sct520_StrtMM(ref uint hDevID, ref ushort ch)
		{
			uint ret;
		
			if ( ch < 2 )
				ret = hictr520.ct520_wXYCmd(hDevID, (ushort)(0x48 + (ch * 2)));		// Pƺޏ
			else if ( ch < 4 ) 
				ret = hictr520.ct520_wZUCmd(hDevID, (ushort)(0x48 + ((ch - 2) * 2)));	// Pƺޏ
		}
	
		//**************************************************
		// MaxMinI
		//   @\ FMaxMinI܂B
		//   hDevID FfoCXnh
		//   ch   F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)
		//     Xch,Zch=0x49, Ych,Uch=0x4B
		//**************************************************
		public static void sct520_StopMM(ref uint hDevID, ref ushort ch)
		{
			uint ret;
		
			if ( ch < 2 )
				ret = hictr520.ct520_wXYCmd(hDevID, (ushort)(0x49 + (ch * 2)));		// Pƺޏ
			else if ( ch < 4 ) 
				ret = hictr520.ct520_wZUCmd(hDevID, (ushort)(0x49 + ((ch - 2) * 2)));	// Pƺޏ
		}

	}
}
