/********************************/
/*  CTR520 Series				*/
/*  UGOKASHITEMIRU(VisualC 5.0)	*/
/*	    file name:tpct5200.c	*/
/*      date     :2003/02/20	*/
/*      version  :1.0.0.0 		*/
/********************************/

#include	<windows.h>
#include	"resource.h"
#include	"hictr520.h"
#include	"tpct5200.h"

/* Windows ̃C֐ */
int APIENTRY WinMain(HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lqszArgs, int nWinMode)
{
	HWND		hwnd;
	MSG			msg;
	WNDCLASSEX	wc;
	char        szAppName[] = "MainDlg", *dummy;
	
	dummy = lqszArgs;

	if(!hPrevInst)	{
		/* EBhENX` */
		wc.style		 =	CS_HREDRAW | CS_VREDRAW;			/* EBhE̎(TCYύXĕ`) */
		wc.lpfnWndProc	 =	(WNDPROC)WndProc;					/* EChE֐̃AhX */
		wc.cbClsExtra	 =	0;									/* ̑̃NX */
		wc.cbWndExtra	 =	DLGWINDOWEXTRA;						/* ̑̃EBhE */
		wc.hInstance	 =	hThisInst;							/* ̃CX^X̃nh */
		wc.hIcon		 =	LoadIcon(NULL, IDI_APPLICATION);	/* WACR̃nh */
		wc.hCursor		 =	LoadCursor(NULL, IDC_ARROW);		/* }EXJ[\̃nh */
		wc.hbrBackground =	(HBRUSH)(COLOR_BTNFACE + 1);		/* EBhE̔wiF({^̕\ʂ̉e) */
		wc.lpszMenuName	 =	NULL;								/* Cj[̖O */
		wc.lpszClassName =	szAppName;							/* EBhENX̖O */
		wc.cbSize		 =	sizeof(WNDCLASSEX);					/* WNDCLASSEX\̂̃TCYݒ */
		wc.hIconSm		 =	LoadIcon(NULL, IDI_WINLOGO);		/* X[ACR */
		if(!RegisterClassEx(&wc))	return 0;					/* EBhENXo^ */
	}

	hInst = hThisInst;											/* ݂̃CX^Xnhۑ */		

	/* EBhENX̓o^ł̂ŁAC̃_CAO{bNX𐶐 */
 	hwnd = CreateDialog(hInst, "IDD_DIALOG0", 0, (DLGPROC)WndProc);
	if(!hwnd)						return 0;

	/* EBhE\ */
	ShowWindow  (hwnd, nWinMode);
	UpdateWindow(hwnd);

	/* bZ[W[v𐶐 */
	while(GetMessage(&msg, NULL, 0, 0)) {
		if(!IsDialogMessage(hwnd, &msg)) {
			TranslateMessage(&msg);		/* L[{[hp\ɂ */
			DispatchMessage (&msg);		/* Windowsɖ߂ */
		}
	}
	return msg.wParam;
}

/* Windows ĂяoāAbZ[WL[烁bZ[Ẅn󂯂鏈 */
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{	
	char	szBuf[255];
	
	switch (message) {
		/* vOJn */
		case WM_INITDIALOG:	FormLoad(hwnd);						break;

		/* {^NbN̏ */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* foCXI & \ */
				case IDC_CMB_INF1:
				case IDC_CMB_INF2:	CmbInf_Click(hwnd, wParam);	break;

				case IDC_BTN_XSTRT:	BtnStrt_Click(hwnd, X_CH);	break;
				case IDC_BTN_YSTRT:	BtnStrt_Click(hwnd, Y_CH);	break;
				case IDC_BTN_ZSTRT:	BtnStrt_Click(hwnd, Z_CH);	break;
				case IDC_BTN_USTRT:	BtnStrt_Click(hwnd, U_CH);	break;

				case IDC_BTN_XSTOP:	BtnStop_Click(hwnd, X_CH);	break;
				case IDC_BTN_YSTOP:	BtnStop_Click(hwnd, Y_CH);	break;
				case IDC_BTN_ZSTOP:	BtnStop_Click(hwnd, Z_CH);	break;
				case IDC_BTN_USTOP:	BtnStop_Click(hwnd, U_CH);	break;

				/* JE^NA */
				case IDC_BTN_XCCLR:	BtnClr_Click (hwnd, X_CH);	break;
				case IDC_BTN_YCCLR:	BtnClr_Click (hwnd, Y_CH);	break;
				case IDC_BTN_ZCCLR:	BtnClr_Click (hwnd, Z_CH);	break;
				case IDC_BTN_UCCLR:	BtnClr_Click (hwnd, U_CH);	break;

				/* b` */
				case IDC_BTN_XLTCH:	BtnLtch_Click(hwnd, X_CH);	break;
				case IDC_BTN_YLTCH:	BtnLtch_Click(hwnd, Y_CH);	break;
				case IDC_BTN_ZLTCH:	BtnLtch_Click(hwnd, Z_CH);	break;
				case IDC_BTN_ULTCH:	BtnLtch_Click(hwnd, U_CH);	break;

				/* f[^Ǎ */
				case IDC_BTN_XREAD:	BtnRead_Click(hwnd, X_CH);	break;
				case IDC_BTN_YREAD:	BtnRead_Click(hwnd, Y_CH);	break;
				case IDC_BTN_ZREAD:	BtnRead_Click(hwnd, Z_CH);	break;
				case IDC_BTN_UREAD:	BtnRead_Click(hwnd, U_CH);	break;

				/* ėpo */
				case IDC_BTN_OUT1:	tct520_Outp(hDev, OUT1_NO);	break;
				case IDC_BTN_OUT2:	tct520_Outp(hDev, OUT2_NO);	break;
				case IDC_BTN_OUT3:	tct520_Outp(hDev, OUT3_NO);	break;
				case IDC_BTN_OUT4:	tct520_Outp(hDev, OUT4_NO);	break;

				case IDC_RAD_MANU:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_MANU) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), TRUE);
						if(gCh == M_CH)	{
							EnableWindow(GetDlgItem(hwnd, IDC_BTN_ZREAD), TRUE);
							EnableWindow(GetDlgItem(hwnd, IDC_BTN_UREAD), TRUE);
						}
					}
																break;
				case IDC_RAD_AUTO:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
						if(gCh == M_CH)	{
							EnableWindow(GetDlgItem(hwnd, IDC_BTN_ZREAD), FALSE);
							EnableWindow(GetDlgItem(hwnd, IDC_BTN_UREAD), FALSE);
						}
					}
																break;
				case IDC_RAD_XCTR:
					SetDlgItemText(hwnd, IDC_CHK_XYCLR, "XYCMP1 XCTR CLR");
					gCtr[XYCH] = 0;
																break;
				case IDC_RAD_YCTR:
					SetDlgItemText(hwnd, IDC_CHK_XYCLR, "XYCMP1 YCTR CLR");
					gCtr[XYCH] = 1;
																break;
				case IDC_RAD_ZCTR:
					SetDlgItemText(hwnd, IDC_CHK_ZUCLR, "ZUCMP1 ZCTR CLR");
					gCtr[ZUCH] = 0;
																break;
				case IDC_RAD_UCTR:
					SetDlgItemText(hwnd, IDC_CHK_ZUCLR, "ZUCMP1 UCTR CLR");
					gCtr[ZUCH] = 1;
																break;
				case IDC_RAD_XYW1:	gWdt[XYCH] = 0;				break;
				case IDC_RAD_XYW2:	gWdt[XYCH] = 1;				break;
				case IDC_RAD_ZUW1:	gWdt[ZUCH] = 0;				break;
				case IDC_RAD_ZUW2:	gWdt[ZUCH] = 1;				break;
				case IDC_RAD_TMW1:	gWdt[ETMR] = 0;				break;
				case IDC_RAD_TMW2:	gWdt[ETMR] = 1;				break;
				case IDC_RAD_TMW3:	gWdt[ETMR] = 2;				break;
				
				case IDC_CHK_XZLTC:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_XZLTC) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZCLR), FALSE);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZCLR), TRUE);
					}																
																break;
				case IDC_CHK_YZLTC:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_YZLTC) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZCLR), FALSE);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZCLR), TRUE);
					}																
																break;
				case IDC_CHK_ZZLTC:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_ZZLTC) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZCLR), FALSE);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZCLR), TRUE);
					}																
																break;
				case IDC_CHK_UZLTC:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_UZLTC) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZCLR), FALSE);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZCLR), TRUE);
					}																
																break;
				case IDC_CHK_TMLTC:
					if(IsDlgButtonChecked(hwnd, IDC_CHK_TMLTC) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRG), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  TRUE);
						_ltoa(gTmr, szBuf, 10);
						SetDlgItemText(hwnd, IDC_EDT_ETMR, szBuf);
						SendDlgItemMessage(hwnd, IDC_EDT_ETMR, EM_SETLIMITTEXT, 9l, 0l);
					} else if(IsDlgButtonChecked(hwnd, IDC_CHK_ETMR) == BST_UNCHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRG), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRS), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  FALSE);
						GetDlgItemText(hwnd, IDC_EDT_ETMR, szBuf, 10l);		/* ETMR擾 */
						if(szBuf[0] != 0x00)	gTmr = atol(szBuf);			/* ETMRۑ */		
						SetDlgItemText(hwnd, IDC_EDT_ETMR, "");
					}
																break;
				case IDC_CHK_XYLTC:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_XYLTC) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYCLR),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPG), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPS), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_YCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_XYCMP),  TRUE);
						CheckDlgButton(hwnd, IDC_CHK_XYCMP,  BST_CHECKED);
						if(gCtr[XYCH] == 0) CheckDlgButton(hwnd, IDC_RAD_XCTR,  BST_CHECKED);
						if(gCtr[XYCH] == 1) CheckDlgButton(hwnd, IDC_RAD_YCTR,  BST_CHECKED);
						if(gWdt[XYCH] == 0) CheckDlgButton(hwnd, IDC_RAD_XYW1,  BST_CHECKED);
						if(gWdt[XYCH] == 1) CheckDlgButton(hwnd, IDC_RAD_XYW2,  BST_CHECKED);
						_ltoa(gCmp[XYCH], szBuf, 10);
						SetDlgItemText(hwnd, IDC_EDT_XYCMP, szBuf);
						SendDlgItemMessage(hwnd, IDC_EDT_XYCMP, EM_SETLIMITTEXT, 9l, 0l);
					} else if(IsDlgButtonChecked(hwnd, IDC_CHK_XYCMP) == BST_UNCHECKED){
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYCLR),  TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPG), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPS), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_YCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_XYCMP),  FALSE);
						CheckDlgButton(hwnd, IDC_RAD_XCTR,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_YCTR,  BST_UNCHECKED);
						GetDlgItemText(hwnd, IDC_EDT_XYCMP, szBuf, 10l);	/* RCMP1f[^擾 */
						if(!(isNum(&szBuf[0]))) gCmp[XYCH] = atol(szBuf);	/* XYchRp[^rf[^ۑ */	
						SetDlgItemText(hwnd, IDC_EDT_XYCMP, "");
					}																
																break;
				case IDC_CHK_ZULTC:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_ZULTC) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZUCLR),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPG), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPS), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_UCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ZUCMP),  TRUE);
						CheckDlgButton(hwnd, IDC_CHK_ZUCMP,  BST_CHECKED);
						if(gCtr[ZUCH] == 0) CheckDlgButton(hwnd, IDC_RAD_ZCTR,  BST_CHECKED);
						if(gCtr[ZUCH] == 1) CheckDlgButton(hwnd, IDC_RAD_UCTR,  BST_CHECKED);
						if(gWdt[ZUCH] == 0) CheckDlgButton(hwnd, IDC_RAD_ZUW1,  BST_CHECKED);
						if(gWdt[ZUCH] == 1) CheckDlgButton(hwnd, IDC_RAD_ZUW2,  BST_CHECKED);
						_ltoa(gCmp[ZUCH], szBuf, 10);
						SetDlgItemText(hwnd, IDC_EDT_ZUCMP, szBuf);
						SendDlgItemMessage(hwnd, IDC_EDT_ZUCMP, EM_SETLIMITTEXT, 9l, 0l);
					} else if(IsDlgButtonChecked(hwnd, IDC_CHK_ZUCMP) == BST_UNCHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZUCLR),  TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPG), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPS), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_UCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ZUCMP),  FALSE);
						CheckDlgButton(hwnd, IDC_RAD_ZCTR,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_UCTR,  BST_UNCHECKED);
						GetDlgItemText(hwnd, IDC_EDT_ZUCMP, szBuf, 10l);	/* RCMP1f[^擾 */
						if(!(isNum(&szBuf[0]))) gCmp[ZUCH] = atol(szBuf);	/* ZUchRp[^rf[^ۑ */	
						SetDlgItemText(hwnd, IDC_EDT_ZUCMP, "");
					}																
																break;
				case IDC_CHK_XZCLR:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_XZCLR) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZLTC), FALSE);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZLTC), TRUE);
					}																
																break;
				case IDC_CHK_YZCLR:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_YZCLR) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZLTC), FALSE);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZLTC), TRUE);
					}																
																break;
				case IDC_CHK_ZZCLR:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_ZZCLR) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZLTC), FALSE);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZLTC), TRUE);
					}																
																break;
				case IDC_CHK_UZCLR:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_UZCLR) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZLTC), FALSE);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZLTC), TRUE);
					}																
																break;
				case IDC_CHK_XYCLR:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_XYCLR) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYLTC),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPG), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPS), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_YCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_XYCMP),  TRUE);
						if(gCtr[XYCH] == 0) CheckDlgButton(hwnd, IDC_RAD_XCTR,  BST_CHECKED);
						if(gCtr[XYCH] == 1) CheckDlgButton(hwnd, IDC_RAD_YCTR,  BST_CHECKED);
						CheckDlgButton(hwnd, IDC_RAD_XCTR,  BST_CHECKED);
						_ltoa(gCmp[XYCH], szBuf, 10);
						SetDlgItemText(hwnd, IDC_EDT_XYCMP, szBuf);
						SendDlgItemMessage(hwnd, IDC_EDT_XYCMP, EM_SETLIMITTEXT, 9l, 0l);
					} else if(IsDlgButtonChecked(hwnd, IDC_CHK_XYCMP) == BST_UNCHECKED){
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYLTC),  TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPG), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPS), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_YCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_XYCMP),  FALSE);
						CheckDlgButton(hwnd, IDC_RAD_XCTR,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_YCTR,  BST_UNCHECKED);
						GetDlgItemText(hwnd, IDC_EDT_XYCMP, szBuf, 10l);	/* RCMP1f[^擾 */
						if(!(isNum(&szBuf[0]))) gCmp[XYCH] = atol(szBuf);	/* XYchRp[^rf[^ۑ */							SetDlgItemText(hwnd, IDC_EDT_XYCMP, "");
					}																
																break;
				case IDC_CHK_ZUCLR:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_ZUCLR) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZULTC),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPG), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPS), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_UCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ZUCMP),  TRUE);
						if(gCtr[ZUCH] == 0) CheckDlgButton(hwnd, IDC_RAD_ZCTR,  BST_CHECKED);
						if(gCtr[ZUCH] == 1) CheckDlgButton(hwnd, IDC_RAD_UCTR,  BST_CHECKED);
						_ltoa(gCmp[ZUCH], szBuf, 10);
						SetDlgItemText(hwnd, IDC_EDT_ZUCMP, szBuf);
						SendDlgItemMessage(hwnd, IDC_EDT_ZUCMP, EM_SETLIMITTEXT, 9l, 0l);
					} else if(IsDlgButtonChecked(hwnd, IDC_CHK_ZUCMP) == BST_UNCHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZULTC),  TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPG), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPS), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_UCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ZUCMP),  FALSE);
						CheckDlgButton(hwnd, IDC_RAD_ZCTR,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_UCTR,  BST_UNCHECKED);
						GetDlgItemText(hwnd, IDC_EDT_ZUCMP, szBuf, 10l);	/* RCMP1f[^擾 */
						if(!(isNum(&szBuf[0]))) gCmp[ZUCH] = atol(szBuf);	/* ZUchRp[^rf[^ۑ */							SetDlgItemText(hwnd, IDC_EDT_ZUCMP, "");
					}	
																break;
				case IDC_CHK_XYCMP:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_XYCMP) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPG), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPS), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_YCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_XYCMP),  TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYOUT),  TRUE);
						_ltoa(gCmp[XYCH], szBuf, 10);
						SetDlgItemText(hwnd, IDC_EDT_XYCMP, szBuf);
						SendDlgItemMessage(hwnd, IDC_EDT_XYCMP, EM_SETLIMITTEXT, 9l, 0l);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW1),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW2),   TRUE);
						if(gCtr[XYCH] == 0) CheckDlgButton(hwnd, IDC_RAD_XCTR,  BST_CHECKED);
						if(gCtr[XYCH] == 1) CheckDlgButton(hwnd, IDC_RAD_YCTR,  BST_CHECKED);
						if(gWdt[XYCH] == 0) CheckDlgButton(hwnd, IDC_RAD_XYW1,  BST_CHECKED);
						if(gWdt[XYCH] == 1) CheckDlgButton(hwnd, IDC_RAD_XYW2,  BST_CHECKED);
					} else if((IsDlgButtonChecked(hwnd, IDC_CHK_XYLTC) == BST_CHECKED)
						   || (IsDlgButtonChecked(hwnd, IDC_CHK_XYCLR) == BST_CHECKED)){
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYOUT),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW1),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW2),   FALSE);
						CheckDlgButton(hwnd, IDC_CHK_XYLTC, BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_XYW1,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_XYW2,  BST_UNCHECKED);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPG), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPS), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_YCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_XYCMP),  FALSE);
						GetDlgItemText(hwnd, IDC_EDT_XYCMP, szBuf, 10l);	/* RCMP1f[^擾 */
						if(!(isNum(&szBuf[0]))) gCmp[XYCH] = atol(szBuf);	/* XYchRp[^rf[^ۑ */							SetDlgItemText(hwnd, IDC_EDT_XYCMP, "");
						EnableWindow(GetDlgItem(hwnd, IDC_STA_XYOUT),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW1),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW2),   FALSE);
						CheckDlgButton(hwnd, IDC_RAD_XCTR,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_YCTR,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_XYW1,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_XYW2,  BST_UNCHECKED);
					}		
																break;
				case IDC_CHK_ZUCMP:								
					if(IsDlgButtonChecked(hwnd, IDC_CHK_ZUCMP) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPG), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPS), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_UCTR),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ZUCMP),  TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUOUT),  TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW1),   TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW2),   TRUE);
						_ltoa(gCmp[ZUCH], szBuf, 10);
						SetDlgItemText(hwnd, IDC_EDT_ZUCMP, szBuf);
						SendDlgItemMessage(hwnd, IDC_EDT_ZUCMP, EM_SETLIMITTEXT, 9l, 0l);
						if(gCtr[ZUCH] == 0) CheckDlgButton(hwnd, IDC_RAD_ZCTR,  BST_CHECKED);
						if(gCtr[ZUCH] == 1) CheckDlgButton(hwnd, IDC_RAD_UCTR,  BST_CHECKED);
						if(gWdt[ZUCH] == 0) CheckDlgButton(hwnd, IDC_RAD_ZUW1,  BST_CHECKED);
						if(gWdt[ZUCH] == 1) CheckDlgButton(hwnd, IDC_RAD_ZUW2,  BST_CHECKED);
					} else if((IsDlgButtonChecked(hwnd, IDC_CHK_ZULTC) == BST_CHECKED)
						   || (IsDlgButtonChecked(hwnd, IDC_CHK_ZUCLR) == BST_CHECKED)){
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUOUT),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW1),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW2),   FALSE);
						CheckDlgButton(hwnd, IDC_CHK_ZULTC, BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_ZUW1,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_ZUW2,  BST_UNCHECKED);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPG), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPS), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_UCTR),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ZUCMP),  FALSE);
						GetDlgItemText(hwnd, IDC_EDT_ZUCMP, szBuf, 10l);	/* RCMP1f[^擾 */
						if(!(isNum(&szBuf[0]))) gCmp[ZUCH] = atol(szBuf);	/* ZUchRp[^rf[^ۑ */							SetDlgItemText(hwnd, IDC_EDT_ZUCMP, "");
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUOUT),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW1),   FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW2),   FALSE);
						CheckDlgButton(hwnd, IDC_RAD_ZCTR,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_UCTR,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_ZUW1,  BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_ZUW2,  BST_UNCHECKED);
					}		
																break;
				case IDC_CHK_ETMR:
					if(IsDlgButtonChecked(hwnd, IDC_CHK_ETMR) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRG), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRS), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  TRUE);
						_ltoa(gTmr, szBuf, 10);
						SetDlgItemText(hwnd, IDC_EDT_ETMR, szBuf);
						SendDlgItemMessage(hwnd, IDC_EDT_ETMR, EM_SETLIMITTEXT, 9l, 0l);
						EnableWindow(GetDlgItem(hwnd, IDC_STA_TMOUT), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW1),  TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW2),  TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW3),  TRUE);
						if(gWdt[ETMR] == 0)	CheckDlgButton(hwnd, IDC_RAD_TMW1, BST_CHECKED);
						if(gWdt[ETMR] == 1)	CheckDlgButton(hwnd, IDC_RAD_TMW2, BST_CHECKED);
						if(gWdt[ETMR] == 2)	CheckDlgButton(hwnd, IDC_RAD_TMW3, BST_CHECKED);
					} else if(IsDlgButtonChecked(hwnd, IDC_CHK_TMLTC) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_STA_TMOUT), FALSE);	  
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW1),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW2),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW3),  FALSE);
						CheckDlgButton(hwnd, IDC_RAD_TMW1, BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_TMW2, BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_TMW3, BST_UNCHECKED);
					} else {
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRG), FALSE);						
						EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRS), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  FALSE);
						GetDlgItemText(hwnd, IDC_EDT_ETMR, szBuf, 10l);		/* ETMR擾 */
						if(szBuf[0] != 0x00)	gTmr = atol(szBuf);			/* ETMRۑ */		
						SetDlgItemText(hwnd, IDC_EDT_ETMR, "");
						EnableWindow(GetDlgItem(hwnd, IDC_STA_TMOUT), FALSE);	  
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW1),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW2),  FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW3),  FALSE);
						CheckDlgButton(hwnd, IDC_RAD_TMW1, BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_TMW2, BST_UNCHECKED);
						CheckDlgButton(hwnd, IDC_RAD_TMW3, BST_UNCHECKED);
					}
			}
			break;

		/* ^C} */
		case WM_TIMER:
			switch(LOWORD(wParam)) {
				case IDM_TMR_READ:	TmrRead(hwnd);				break;	/* AǍ^C} */
			}
			break;

		/* EBhE鎞̏ */
		case WM_CLOSE:	FormUnload(hwnd);  						break;

		/* vOI */
		case WM_DESTROY:PostQuitMessage(0);						break;

		/* LȊÕbZ[WWindows ɏ */
		default:return DefWindowProc(hwnd, message, wParam, lParam);
	}
	return 0;
}

/* ʏ */
WORD FormLoad(HWND hwnd)
{
	HDC		hDC;
	RECT	rct;
	int		w, h;
	WORD	i, j;
	DWORD	ret;
    char	szBuf[255];
	
	/* ʍW擾 */
	w = GetSystemMetrics(SM_CXSCREEN);		/* ʂ̕ */
	h = GetSystemMetrics(SM_CYSCREEN);		/* ʂ̍ */

	/* EBhE̋E`̐@擾 */
	GetWindowRect(hwnd, &rct);
	rct.right  = rct.right  - rct.left;
	rct.bottom = rct.bottom - rct.top;

	/* (fXNgbv̈)̓vOI */
	if((h <= (rct.bottom + 15)) || (w <= rct.right)) {
		wsprintf(szBuf, "%s\n%s\n%s", "̃AvP[V́Aʂ̗̈",
			                          "WOO~UOOitHgjȏ", 
								      "Ăgp");	
		MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK );
		FormUnload(hwnd);
		return 1;
	}

	/* EBhE𒆉Ɉړ(͒菭) */
	rct.top  = (h - rct.bottom) / 2 - 15;
	rct.left = (w - rct.right ) / 2;
	MoveWindow(hwnd, rct.left, rct.top, rct.right, rct.bottom, TRUE);

	/* w肳ꂽEBhẼNCAg̈ɑ΂ */
	/* foCXReLXg̃nh擾 */
	hDC = GetDC(hwnd);

	/* foCXReLXg */
	ReleaseDC(hwnd, hDC);
	
	// {[h擾
	ret = ct520_GetDeviceCount(&gCnt);
	if(ret) {
		wsprintf(szBuf, "%s\n%s\n%s\n%s", 
			"{[h̎擾ł܂łB", 
			"{[hobhoXXbgɑ}ĂȂA", 
			"܂̓foCXhCoCXg[", 
			"ĂȂ\܂B");	
		MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
		FormUnload(hwnd);
		return 0;
	}

	// {[h17ȏ̎G[
	if(gCnt > CNTMAX) {
		wsprintf(szBuf, "%s%ld%s", 
			"Ɏgpł{[h", CNTMAX, "܂łł");	
		MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
		FormUnload(hwnd);
		return 0;
	}

	// foCX擾
	ret = ct520_GetDeviceInfo(&gCnt, &HpcDevInfo[0]);
	if(ret) {
		wsprintf(szBuf, "%s\n%s\n%s", 
			"foCX̎擾Ɏs܂B",
			"foCXhCoCXg[",
			"ĂȂ\܂B");	
		MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
		FormUnload(hwnd);
		return 0;
	}

	// {[hIDdꍇAR{{bNX(BRDID)gps
	for(i = 0; i < gCnt; i++) {
		for(j = 0; j < gCnt; j++) {
			if(i != j) {
				if(HpcDevInfo[i].dwBoardID == HpcDevInfo[j].dwBoardID) {
					wsprintf(szBuf, "%s\n%s", 
						"{[hIDdĂ܂B", 
						"{[hIDł̃{[hʂ͂ł܂");	
					MessageBox(hwnd, szBuf, "", MB_OK);
					wBrdId = 1;
					goto For_End;
				}
			}
		}
	}

For_End:	
	/* rbg}bṽ[h */
	hWht  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_WHITE));
	hGrn  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_GREEN));
	
	/// \[Xt@Cō쐬R{{bNXRg[̃nh擾
	hCmb[BRDID] = GetDlgItem(hwnd, IDC_CMB_INF1);
	hCmb[DEVNO] = GetDlgItem(hwnd, IDC_CMB_INF2);

	/// R{{bNX̓eZbg
	SendMessage(hCmb[BRDID], CB_RESETCONTENT, 0l, 0l);
	SendMessage(hCmb[DEVNO], CB_RESETCONTENT, 0l, 0l);

	/// R{{bNXɃeLXgACeǉ
	for(i = 0; i < gCnt; i++) {
		wsprintf(szBuf, "%d", HpcDevInfo[i].dwBoardID );
		SendMessage(hCmb[BRDID], CB_ADDSTRING, 0L, (LPARAM)szBuf);
		wsprintf(szBuf, "%d", HpcDevInfo[i].nDeviceNumber );
		SendMessage(hCmb[DEVNO], CB_ADDSTRING, 0L, (LPARAM)szBuf);
	}

    /// foCXI[ṽftHgݒ({[hhcA1)
    SendMessage(hCmb[BRDID], CB_SETCURSEL, 0l, 0l);
	CmbInf_Click(hwnd, MAKEWPARAM(IDC_CMB_INF1, CBN_SELCHANGE));
	return 1;
}

/* foCXI[v */
WORD DevOpen(HWND hwnd)
{
    char	szBuf[255];
	WORD	n, ch;	
	DWORD	ret, reg;
	
	/* Ch(̏ꍇSCh) */
	gCh = M_CH;
	
	/* O[oϐ */
	gCmp[XYCH] = DEF_RCM1;		/* XYchRp[^Prf[^	*/		
	gCmp[ZUCH] = DEF_RCM1;		/* ZUchRp[^Prf[^	*/		
	gTmr = DEF_ETMR;			/* ETMR */	
	gCtr[XYCH] = 0;				/* XYchJE^tO */
	gCtr[ZUCH] = 0;				/* ZUchJE^tO */	
	gWdt[XYCH] = 0;				/* XYcho̓pXtO */
	gWdt[ZUCH] = 0;				/* ZUcho̓pXtO */
	gWdt[ETMR] = 0;				/* ETMRo̓pXtO */
	
	/* foCXI[v */
	ret = ct520_OpenDevice(&hDev, &HpcDevInfo2);
	if(ret) {
		wsprintf(szBuf, "%s\n%s%08lxh", 
			"foCXI[vɎs܂B",
			"G[߂lF",ret);	
		MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
		return 1;
	}

	/* \tgEFAZbg */
	ct520_wXYCmd(hDev, 0x40);
	ct520_wZUCmd(hDev, 0x40);

	ct520_rZUReg(hDev, 0xc0, &reg);	/* #2 CCL(ZUch)̃WX^"0"œǂ߂Ȃ */
	if(reg)	{						/* HPCI-CTR522F{[hƔf */
		DevClose(hwnd);				/* foCXN[Y */
		gCh = 2;		/* Ch(̏ꍇQCh) */
		
		/* foCXI[v */
		ret = ct520_OpenDevice(&hDev, &HpcDevInfo2);
		if(ret) {
			wsprintf(szBuf, "%s\n%s%08lxh", 
				"foCXI[vɎs܂B",
				"G[߂lF",ret);	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return 1;
		}
	}
	
	/* foCXI[v̏ */
	ret = tct520_InitCtr(hDev);
	if(ret)	{
		MessageBox(hwnd, "{[hs", "ErrorMessage", MB_OK);
		DevClose(hwnd);
		return 1;
	}

	/* {^\ */
	for(ch = 0; ch < gCh; ch++) {
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XLTCH + ch), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XCCLR + ch), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTRT + ch), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_01    + ch), TRUE);
	}

	for(n = 0; n < 4; n++) 	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OUT1 + n), TRUE);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_UD),    TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIR),   TRUE);
	CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_CHECKED);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  TRUE);
	CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_CHECKED);

	EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  TRUE);

	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZLTC), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZLTC), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_TMLTC), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_INLTC), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYLTC), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZCLR), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZCLR), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYCLR), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYCMP), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_ETMR),  TRUE);
	SetDlgItemText(hwnd, IDC_CHK_XYCLR, "XYCMP1 XCTR CLR");

	EnableWindow(GetDlgItem(hwnd, IDC_STA_MLT),     TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_INP),     TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_LTC),     TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_CLR),     TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP),     TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_SELREAD), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_05),		TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_06),		TRUE);

	if(gCh == M_CH) {
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZLTC), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZLTC), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZCLR), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZCLR), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZULTC), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZUCLR), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZUCMP), TRUE);
		SetDlgItemText(hwnd, IDC_CHK_ZUCLR, "ZUCMP1 ZCTR CLR");
	}	

	/* JE^\NA	*/
	for(ch = X_CH; ch < gCh; ch++) {
		SetDlgItemText(hwnd, IDC_STA_XCTR + ch, "");
		SetDlgItemText(hwnd, IDC_STA_XLTC + ch, "");
	}

	SetTimer(hwnd, IDM_TMR_READ, 100, NULL);	/* AǍ^C}Jn(0.1b) */

	return 0;
}

/* EBhE鏈 */
void FormUnload(HWND hwnd)
{
	DevClose(hwnd);			/* foCXN[Y */

	/* foCXReLXg폜 */
	DeleteObject(hGrn);
	DeleteObject(hWht);

	DestroyWindow(hwnd);	/* C̃_CAO{bNX */
}

/* R{{bNXNbNꂽ̏	*/
/* foCXI & \					*/
void CmbInf_Click(HWND hwnd, WPARAM wParam)
{
	DWORD	di;
	char	szBuf[255];

	/* R{{bNX̃Xg{bNXNbNꂽȊÓAȂ */
	if(HIWORD(wParam) != CBN_SELCHANGE) return;

	/* I[vufoCXԍ/{[hIDvۑĂ */
	if(LOWORD(wParam) == IDC_CMB_INF1)	wOpen = BRDID;
	else								wOpen = DEVNO;

    /* gpfoCXڂۑĂ */
	di = SendMessage(hCmb[wOpen], CB_GETCURSEL, 0l, 0l);

	if((di >= 0) && (di < gCnt)) {
		dwCmbIx = di;
	} else {
		di = dwCmbIx;
		SendMessage(hCmb[wOpen], CB_SETCURSEL, di, 0l);
	}

    /* w肳ꂽfoCXAfoCXI[vpfoCẌɃRs[ */
    HpcDevInfo2 = HpcDevInfo[di];

    /* {[hIDŃfoCXI[v鎞 */
	if(wOpen == BRDID) {
        /* foCXԍ̃R{{bNXăZbg */
		SendMessage(hCmb[DEVNO], CB_RESETCONTENT, 0l, 0l);
		for(di = 0; di < gCnt; di++) {
			wsprintf(szBuf, "%d", HpcDevInfo[di].nDeviceNumber);
			SendMessage(hCmb[DEVNO], CB_ADDSTRING, 0l, (LPARAM)szBuf);
		}
	} else {
		/* {[hIDȊOŃfoCXI[v鎞 */
        /* {[hID̃R{{bNXăZbg */
		SendMessage(hCmb[BRDID], CB_RESETCONTENT, 0l, 0l);
		for(di = 0; di < gCnt; di++) {
			wsprintf(szBuf, "%d", HpcDevInfo[di].dwBoardID);
			SendMessage(hCmb[BRDID], CB_ADDSTRING, 0l, (LPARAM)szBuf);
		}
	}

	/* foCX\ */
	wsprintf(szBuf, "%s%ld\n%s%lXh\n%s%ld",	
			 "oXԍ   F", HpcDevInfo2.nBusNumber,
			 "I/OAhXF", HpcDevInfo2.dwIoPortAddress,
			 "Ǘԍ   F", HpcDevInfo2.dwNumber);
	SetDlgItemText(hwnd, IDC_STA_INF1, szBuf);

	wsprintf(szBuf, "%s%ld\n%s%ld\n%s%ld",	
			 "foCXԍF", HpcDevInfo2.nDeviceNumber,
			 "hqpԍ  F", HpcDevInfo2.dwIrqNo,
			 "{[hhc  F", HpcDevInfo2.dwBoardID);
	SetDlgItemText(hwnd, IDC_STA_INF2, szBuf);

	/* OƃfoCX񂪕ςĂ鎞 */
	if((wOpen2 != wOpen) || (dwCmbIx2 != dwCmbIx))	{
		wOpen2 = wOpen;
		dwCmbIx2 = dwCmbIx;
		if(!DevClose(hwnd))		return;		/* foCXN[Y */
		if(!DevOpen (hwnd))		return;		/* foCXI[v */
	}
}

/* foCXN[Y */
WORD DevClose(HWND hwnd)
{
	char	szBuf[255];
	WORD	n, ch;

	if(hDev == -1)	return 1;
	
	KillTimer(hwnd, IDM_TMR_READ);		/* AǍ^C}I */

	/* ėpo͂̃rbg}bvNA */
	for(n = X_CH; n < 4; n++) {
		SendDlgItemMessage(hwnd, IDC_STA_IN1  + n, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
		SendDlgItemMessage(hwnd, IDC_BTN_OUT1 + n, BM_SETIMAGE,  (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);		
	}

	/* \tgEFAZbg */
	ct520_wXYCmd(hDev, 0x40);
	if(gCh == M_CH)	ct520_wZUCmd(hDev, 0x40);

	ct520_CloseDevice(hDev);			/* foCXN[Y */

	for(ch = 0; ch < gCh; ch++) {
		/* JE^\NA */
		SetDlgItemText(hwnd, IDC_STA_XCTR + ch, "");
		SetDlgItemText(hwnd, IDC_STA_XLTC + ch, "");

		/* {^\ */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD + ch), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XLTCH + ch), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XCCLR + ch), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTRT + ch), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTOP + ch), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_01    + ch), FALSE);
	}

	EnableWindow(GetDlgItem(hwnd, IDC_STA_INP),   FALSE);
	for(n = 0; n < 4; n++)	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OUT1 + n),  FALSE);
	
	EnableWindow(GetDlgItem(hwnd, IDC_STA_MLT), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_UD),    FALSE);
	CheckDlgButton(hwnd, IDC_RAD_UD, BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  FALSE);
	CheckDlgButton(hwnd, IDC_RAD_MLT1, BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  FALSE);
	CheckDlgButton(hwnd, IDC_RAD_MLT2, BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  FALSE);
	CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIR),   FALSE);
	CheckDlgButton(hwnd, IDC_RAD_DIR, BST_UNCHECKED);
	
	EnableWindow(GetDlgItem(hwnd, IDC_STA_SELREAD), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  FALSE);
	CheckDlgButton(hwnd, IDC_RAD_MANU,  BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  FALSE);
	CheckDlgButton(hwnd, IDC_RAD_AUTO,  BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  FALSE);
	CheckDlgButton(hwnd, IDC_CHK_AUTO,  BST_UNCHECKED);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_LTC),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_CLR),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZLTC), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZLTC), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_TMLTC), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_INLTC), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYLTC), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZCLR), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZCLR), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYCLR), FALSE);

	CheckDlgButton(hwnd, IDC_CHK_XZLTC, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_YZLTC, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_INLTC, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_TMLTC, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_XZCLR, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_YZCLR, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_XYLTC, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_XYCLR, BST_UNCHECKED);
	SetDlgItemText(hwnd, IDC_CHK_XYCLR, "XYCMP1 XCTR CLR");
	SetDlgItemText(hwnd, IDC_CHK_ZUCLR, "ZUCMP1 ZCTR CLR");

	CheckDlgButton(hwnd, IDC_CHK_XYCMP, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_ETMR,	BST_UNCHECKED);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPG), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPS), FALSE);
	GetDlgItemText(hwnd, IDC_EDT_XYCMP, szBuf, 10l);		/* RCMP1f[^擾 */
	if(!(isNum(&szBuf[0]))) gCmp[XYCH] = atol(szBuf);		/* XYchRp[^rf[^ۑ */		
	SetDlgItemText(hwnd, IDC_EDT_XYCMP, "");
	EnableWindow(GetDlgItem(hwnd, IDC_EDT_XYCMP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_XCTR),   FALSE);
	CheckDlgButton(hwnd, IDC_RAD_XCTR,  BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_YCTR),   FALSE);
	CheckDlgButton(hwnd, IDC_RAD_YCTR,  BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW1),   FALSE);
	CheckDlgButton(hwnd, IDC_RAD_XYW1,  BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW2),   FALSE);
	CheckDlgButton(hwnd, IDC_RAD_XYW2,  BST_UNCHECKED);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRG),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRS),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_TMOUT),  FALSE);
	GetDlgItemText(hwnd, IDC_EDT_ETMR, szBuf, 10l);			/* ETMR擾 */
	if(szBuf[0] != 0x00)	gTmr = atol(szBuf);				/* ETMRۑ */		
	SetDlgItemText(hwnd, IDC_EDT_ETMR, "");
	EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW1),  FALSE);
	CheckDlgButton(hwnd, IDC_RAD_TMW1,  BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW2),  FALSE);
	CheckDlgButton(hwnd, IDC_RAD_TMW2,  BST_UNCHECKED);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW3),  FALSE);
	CheckDlgButton(hwnd, IDC_RAD_TMW3,  BST_UNCHECKED);

	if(gCh == M_CH) {
		EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPG), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPS), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_ZUCMP),  FALSE);
		GetDlgItemText(hwnd, IDC_EDT_ZUCMP, szBuf, 10l);	/* RCMP1f[^擾 */
		if(!(isNum(&szBuf[0]))) gCmp[ZUCH] = atol(szBuf);	/* ZUchRp[^rf[^ۑ */			
		SetDlgItemText(hwnd, IDC_EDT_ZUCMP, "");
		CheckDlgButton(hwnd, IDC_RAD_ZCTR,  BST_UNCHECKED);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZCTR),  FALSE);
		CheckDlgButton(hwnd, IDC_RAD_UCTR,  BST_UNCHECKED);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UCTR),  FALSE);
		CheckDlgButton(hwnd, IDC_RAD_ZUW1,  BST_UNCHECKED);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW1),  FALSE);
		CheckDlgButton(hwnd, IDC_RAD_ZUW2,  BST_UNCHECKED);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW2),  FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZLTC), FALSE);
		CheckDlgButton(hwnd, IDC_CHK_ZZLTC, BST_UNCHECKED);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZLTC), FALSE);
		CheckDlgButton(hwnd, IDC_CHK_UZLTC, BST_UNCHECKED);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZCLR), FALSE);
		CheckDlgButton(hwnd, IDC_CHK_ZZCLR, BST_UNCHECKED);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZCLR), FALSE);
		CheckDlgButton(hwnd, IDC_CHK_UZCLR, BST_UNCHECKED);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZULTC), FALSE);
		CheckDlgButton(hwnd, IDC_CHK_ZULTC, BST_UNCHECKED);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZUCLR), FALSE);
		CheckDlgButton(hwnd, IDC_CHK_ZUCLR, BST_UNCHECKED);
		CheckDlgButton(hwnd, IDC_CHK_ZUCMP, BST_UNCHECKED);
	}	
	/* foCXN[YςȂhDev=INVALID_HANDLE(foCXI[v^N[YԔf̈) */
	hDev = INVALID_HANDLE;

	return 1;
}

/* X^[g{^NbNꂽƂ̏ */
void BtnStrt_Click(HWND hwnd, WORD ch)
{
	WORD	xysts;
	WORD	zusts = 0xffff;
	WORD	ret;
	char	szBuf[255];	
	
	ct520_rXYSts(hDev, &xysts);
	if(gCh == M_CH)	ct520_rZUSts(hDev, &zusts);
	/* ׂẴJE^~Ȃ */
	if((xysts & 0x10) && (xysts & 0x20) && (zusts & 0x10) && (zusts & 0x20)) {
		ret = SetData(hwnd);
		if(ret & ILL_XYCP) {
			wsprintf(szBuf, "%s", "Rp[^rf[^͐lݒ肵Ă");
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			SetFocus(GetDlgItem(hwnd, IDC_EDT_XYCMP));
			return;
		}
		if(ret & ILL_ZUCP) {
			wsprintf(szBuf, "%s", "Rp[^rf[^͐lݒ肵Ă");
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			SetFocus(GetDlgItem(hwnd, IDC_EDT_ZUCMP));
			return;
		}
		if(ret & ILL_ETMR) {
			wsprintf(szBuf, "%s\n%s", "XYOUT2o͕104msecɐݒ肵́A",
									  "ETMR105msecȉɐݒł܂");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			SetFocus(GetDlgItem(hwnd, IDC_EDT_ETMR));
			return;
		}
		if(ret & ILL_NULL) {
			wsprintf(szBuf, "%s", "ETMRݒ肵Ă");
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			SetFocus(GetDlgItem(hwnd, IDC_EDT_ETMR));
			return;
		}
	}

	/* JEgX^[g */
	tct520_StrtCtr(hDev, ch);
	
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTOP + ch), TRUE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTRT + ch), FALSE);
	
	EnableWindow(GetDlgItem(hwnd, IDC_STA_MLT),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_UD),    FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIR),   FALSE);
	
	EnableWindow(GetDlgItem(hwnd, IDC_STA_SELREAD), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),    FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),    FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),    FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_RAD_XCTR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_YCTR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRG), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRS), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW3),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_EDT_XYCMP), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_LTC),    FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_CLR),    FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZLTC),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZLTC),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_TMLTC),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_INLTC),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYLTC),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPG), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPS), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP),    FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYCMP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_ETMR),   FALSE);

	if(gCh == M_CH) {
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZCTR),   FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UCTR),   FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW1),   FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW2),   FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_ZUCMP),  FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZLTC),  FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZLTC),  FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZULTC),  FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZCLR),  FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZCLR),  FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZUCLR),  FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPG), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPS), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZUCMP),  FALSE);
	}	
}

/* Xgbv{^NbNꂽƂ̏ */
void BtnStop_Click(HWND hwnd, WORD ch)
{
	tct520_StopCtr(hDev, ch);	/* JEgXgbv */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTOP + ch), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTRT + ch), TRUE);
}

/* JE^NA{^NbNꂽƂ̏ */
void BtnClr_Click (HWND hwnd, WORD ch)
{
	char	szBuf[255];
	long	ldt;

	tct520_ClrCtr(hDev, ch);			/* JE^lNA */
	tct520_ReadCtr(hDev, ch, &ldt);		/* JE^lǍ */

	/* \ */
	wsprintf(szBuf, "%ld ", ldt);
	SetDlgItemText(hwnd, IDC_STA_XCTR + ch, szBuf);
}

/* b`{^NbNꂽƂ̏ */
void BtnLtch_Click(HWND hwnd, WORD ch)
{
	char	szBuf[255];
	long	ldt;

	tct520_SoftLtc(hDev, ch);		/* b` */
	tct520_ReadLtc(hDev, ch, &ldt);	/* b`f[^Ǎ */

	/* \ */
	wsprintf(szBuf, "%ld ", ldt);
	SetDlgItemText(hwnd, IDC_STA_XLTC + ch, szBuf);
}

/* [h{^NbNꂽƂ̏ */
void BtnRead_Click(HWND hwnd, WORD ch)
{
	char	szBuf[255];
	long	ldt;

	tct520_ReadCtr(hDev, ch, &ldt);		/* JE^lǍ */

	/* \ */
	wsprintf(szBuf, "%ld ", ldt);
	SetDlgItemText(hwnd, IDC_STA_XCTR + ch, szBuf);

	tct520_ReadLtc(hDev, ch, &ldt);		/* b`f[^Ǎ */

	/* \ */
	wsprintf(szBuf, "%ld ", ldt);
	SetDlgItemText(hwnd, IDC_STA_XLTC + ch, szBuf);
}

/* JE^,ėpo̓|[gǍ */
void TmrRead(HWND hwnd)
{
	char	szBuf[255];
	WORD	wdt;
	WORD	ch;
	WORD	xysts;
	WORD	zusts = 0xffff;
	long	ldt;
	
	/* SCh~Ȃ΃{^gp */
	ct520_rXYSts(hDev, &xysts);
	if(gCh == M_CH)	ct520_rZUSts(hDev, &zusts);
	if((xysts & 0x10) && (xysts & 0x20) && (zusts & 0x10) && (zusts & 0x20)) {
		ct520_wXYReg(hDev, 0x86, 0);					/* ETMR~ */
		
		EnableWindow(GetDlgItem(hwnd, IDC_STA_MLT),     TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UD),      TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),    TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),    TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),    TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIR),     TRUE);
		
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SELREAD), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),    TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),    TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),    TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_LTC),     TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_CLR),     TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYCMP),	TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ETMR),	TRUE);
		
		if((IsDlgButtonChecked(hwnd, IDC_CHK_XZLTC) == BST_CHECKED) ||
		  ((IsDlgButtonChecked(hwnd, IDC_CHK_XZLTC) == BST_UNCHECKED) &&
		   (IsDlgButtonChecked(hwnd, IDC_CHK_XZCLR) == BST_UNCHECKED))) {	
			EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZLTC), TRUE);
		}

		if((IsDlgButtonChecked(hwnd, IDC_CHK_YZLTC) == BST_CHECKED) ||
		  ((IsDlgButtonChecked(hwnd, IDC_CHK_YZLTC) == BST_UNCHECKED) &&
		   (IsDlgButtonChecked(hwnd, IDC_CHK_YZCLR) == BST_UNCHECKED))) {	
			EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZLTC), TRUE);
		}
		
		if((IsDlgButtonChecked(hwnd, IDC_CHK_XYLTC) == BST_CHECKED) ||
		  ((IsDlgButtonChecked(hwnd, IDC_CHK_XYLTC) == BST_UNCHECKED) &&
		   (IsDlgButtonChecked(hwnd, IDC_CHK_XYCLR) == BST_UNCHECKED))) {	
			EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYLTC), TRUE);
		}

		if((IsDlgButtonChecked(hwnd, IDC_CHK_XZCLR) == BST_CHECKED) ||
		  ((IsDlgButtonChecked(hwnd, IDC_CHK_XZLTC) == BST_UNCHECKED) &&
		   (IsDlgButtonChecked(hwnd, IDC_CHK_XZCLR) == BST_UNCHECKED))) {
			EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZCLR), TRUE);
		}

		if((IsDlgButtonChecked(hwnd, IDC_CHK_YZCLR) == BST_CHECKED) ||
		  ((IsDlgButtonChecked(hwnd, IDC_CHK_YZLTC) == BST_UNCHECKED) &&
		   (IsDlgButtonChecked(hwnd, IDC_CHK_YZCLR) == BST_UNCHECKED))) {
			EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZCLR), TRUE);
		}
		
		if((IsDlgButtonChecked(hwnd, IDC_CHK_XYCLR) == BST_CHECKED) ||
		  ((IsDlgButtonChecked(hwnd, IDC_CHK_XYLTC) == BST_UNCHECKED) &&
		   (IsDlgButtonChecked(hwnd, IDC_CHK_XYCLR) == BST_UNCHECKED))) {
			EnableWindow(GetDlgItem(hwnd, IDC_CHK_XYCLR), TRUE);
		}

		if(IsDlgButtonChecked(hwnd, IDC_CHK_XYCMP) == BST_CHECKED) {
			EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPG), TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPS), TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_STA_XYOUT),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_XCTR),   TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_YCTR),   TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_EDT_XYCMP),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW1),   TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_XYW2),   TRUE);
		} else if((IsDlgButtonChecked(hwnd, IDC_CHK_XYCLR) == BST_CHECKED) ||
		          (IsDlgButtonChecked(hwnd, IDC_CHK_XYLTC) == BST_CHECKED)) {
			EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPG), TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_STA_XYCMPS), TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_XCTR),   TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_YCTR),   TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_EDT_XYCMP),  TRUE);
		}

		if(IsDlgButtonChecked(hwnd, IDC_CHK_ETMR) == BST_CHECKED) {
			EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRG), TRUE);	
			EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRS), TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_STA_TMOUT), TRUE);			
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW1),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW2),  TRUE);
			EnableWindow(GetDlgItem(hwnd, IDC_RAD_TMW3),  TRUE);
		} else if(IsDlgButtonChecked(hwnd, IDC_CHK_TMLTC) == BST_CHECKED) {
			EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRG), TRUE);	
			EnableWindow(GetDlgItem(hwnd, IDC_STA_ETMRS), TRUE);	
			EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  TRUE);
		}

		EnableWindow(GetDlgItem(hwnd, IDC_CHK_TMLTC), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_INLTC), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_CMP),   TRUE);
		
		if(gCh == M_CH) {
			if((IsDlgButtonChecked(hwnd, IDC_CHK_ZZLTC) == BST_CHECKED) ||
			  ((IsDlgButtonChecked(hwnd, IDC_CHK_ZZLTC) == BST_UNCHECKED) &&
			   (IsDlgButtonChecked(hwnd, IDC_CHK_ZZCLR) == BST_UNCHECKED))) {
				EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZLTC), TRUE);
			}
			
			if((IsDlgButtonChecked(hwnd, IDC_CHK_UZLTC) == BST_CHECKED) ||
			  ((IsDlgButtonChecked(hwnd, IDC_CHK_UZLTC) == BST_UNCHECKED) &&
			   (IsDlgButtonChecked(hwnd, IDC_CHK_UZCLR) == BST_UNCHECKED))) {
				EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZLTC), TRUE);
			}
			
			if((IsDlgButtonChecked(hwnd, IDC_CHK_ZULTC) == BST_CHECKED) ||
			  ((IsDlgButtonChecked(hwnd, IDC_CHK_ZULTC) == BST_UNCHECKED) &&
			   (IsDlgButtonChecked(hwnd, IDC_CHK_ZUCLR) == BST_UNCHECKED))) {
				EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZULTC), TRUE);
			}

			if((IsDlgButtonChecked(hwnd, IDC_CHK_ZZCLR) == BST_CHECKED) ||
			  ((IsDlgButtonChecked(hwnd, IDC_CHK_ZZLTC) == BST_UNCHECKED) &&
			   (IsDlgButtonChecked(hwnd, IDC_CHK_ZZCLR) == BST_UNCHECKED))) {
				EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZZCLR), TRUE);
			}

			if((IsDlgButtonChecked(hwnd, IDC_CHK_UZCLR) == BST_CHECKED) ||
			  ((IsDlgButtonChecked(hwnd, IDC_CHK_UZLTC) == BST_UNCHECKED) &&
			   (IsDlgButtonChecked(hwnd, IDC_CHK_UZCLR) == BST_UNCHECKED))) {
				EnableWindow(GetDlgItem(hwnd, IDC_CHK_UZCLR), TRUE);
			}
			
			if((IsDlgButtonChecked(hwnd, IDC_CHK_ZUCLR) == BST_CHECKED) ||
			  ((IsDlgButtonChecked(hwnd, IDC_CHK_ZULTC) == BST_UNCHECKED) &&
			   (IsDlgButtonChecked(hwnd, IDC_CHK_ZUCLR) == BST_UNCHECKED))) {
				EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZUCLR), TRUE);
			}
		
			EnableWindow(GetDlgItem(hwnd, IDC_CHK_ZUCMP),	TRUE);

			if(IsDlgButtonChecked(hwnd, IDC_CHK_ZUCMP) == BST_CHECKED) {
				EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPG), TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPS), TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUOUT),  TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZCTR),   TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_RAD_UCTR),   TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_EDT_ZUCMP),  TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW1),   TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZUW2),   TRUE);
			} else if((IsDlgButtonChecked(hwnd, IDC_CHK_ZUCLR) == BST_CHECKED) ||
					  (IsDlgButtonChecked(hwnd, IDC_CHK_ZULTC) == BST_CHECKED)) {
				EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPG), TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_STA_ZUCMPS), TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_RAD_ZCTR),   TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_RAD_UCTR),   TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_EDT_ZUCMP),  TRUE);
			}
		}	
	}

	if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
		for(ch = X_CH; ch < gCh; ch++) {
			tct520_ReadCtr(hDev, ch, &ldt);		/* JE^lǍ */
			/* \ */
			wsprintf(szBuf, "%ld ", ldt);
			SetDlgItemText(hwnd, IDC_STA_XCTR + ch, szBuf);
			tct520_ReadLtc(hDev, ch, &ldt);		/* b`f[^Ǎ */
			/* \ */
			wsprintf(szBuf, "%ld ", ldt);
			SetDlgItemText(hwnd, IDC_STA_XLTC + ch, szBuf);
		}
	}

	ct520_rPortW(hDev, INP_PORT, &wdt);	/* ėp̓|[gǍ */

	/* ėp̓|[g\ */
	if(wdt & 1)	SendDlgItemMessage(hwnd, IDC_STA_IN1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_STA_IN1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	if(wdt & 2)	SendDlgItemMessage(hwnd, IDC_STA_IN2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_STA_IN2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	if(wdt & 4)	SendDlgItemMessage(hwnd, IDC_STA_IN3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_STA_IN3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	if(wdt & 8)	SendDlgItemMessage(hwnd, IDC_STA_IN4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_STA_IN4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);

	ct520_rPortW(hDev, OUT_PORT, &wdt);	/* ėpo̓|[gǍ */

	/* ėpo̓|[g\ */
	if(wdt & 1)	SendDlgItemMessage(hwnd, IDC_BTN_OUT1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_BTN_OUT1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	if(wdt & 2)	SendDlgItemMessage(hwnd, IDC_BTN_OUT2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_BTN_OUT2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	if(wdt & 4)	SendDlgItemMessage(hwnd, IDC_BTN_OUT3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_BTN_OUT3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	if(wdt & 8)	SendDlgItemMessage(hwnd, IDC_BTN_OUT4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	else		SendDlgItemMessage(hwnd, IDC_BTN_OUT4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
}

/* eݒ */
WORD SetData(HWND hwnd)
{
#define	CMP		0		/* Rp[^o͐ݒ */
#define	TMR		1		/* ETMRo͐ݒ */
#define	CIN		2		/* vo͐ݒ */
#define	CLR		3		/* JE^NAݒ */
#define	LTC		4		/* b`ݒ */

	char	szBuf[255];
	WORD	opt[5];		/* IvV|[gf[^ */
	DWORD	rnv1[2];	/* ݒP */
	DWORD	rnv2[2];	/* ݒQ */
	DWORD	tmr;		/* ETMR */
	DWORD	reg;		/* ETMRWX^ */

	/* ͐M̐ݒ */
	if(IsDlgButtonChecked(hwnd, IDC_RAD_MLT1) == BST_CHECKED) {
		tct520_SelCtrMode(hDev, X_CH, MLT1_NO);
		tct520_SelCtrMode(hDev, Y_CH, MLT1_NO);
		if(gCh == M_CH)	{
			tct520_SelCtrMode(hDev, Z_CH, MLT1_NO);
			tct520_SelCtrMode(hDev, U_CH, MLT1_NO);
		}
	} else if(IsDlgButtonChecked(hwnd, IDC_RAD_MLT2) == BST_CHECKED) {
		tct520_SelCtrMode(hDev, X_CH, MLT2_NO);
		tct520_SelCtrMode(hDev, Y_CH, MLT2_NO);
		if(gCh == M_CH)	{
			tct520_SelCtrMode(hDev, Z_CH, MLT2_NO);
			tct520_SelCtrMode(hDev, U_CH, MLT2_NO);
		}
	} else if(IsDlgButtonChecked(hwnd, IDC_RAD_MLT4) == BST_CHECKED) {
		tct520_SelCtrMode(hDev, X_CH, MLT4_NO);
		tct520_SelCtrMode(hDev, Y_CH, MLT4_NO);
		if(gCh == M_CH)	{
			tct520_SelCtrMode(hDev, Z_CH, MLT4_NO);
			tct520_SelCtrMode(hDev, U_CH, MLT4_NO);
		}
	} else if(IsDlgButtonChecked(hwnd, IDC_RAD_UD) == BST_CHECKED) {
		tct520_SelCtrMode(hDev, X_CH, UPDN_NO);
		tct520_SelCtrMode(hDev, Y_CH, UPDN_NO);
		if(gCh == M_CH)	{
			tct520_SelCtrMode(hDev, Z_CH, UPDN_NO);
			tct520_SelCtrMode(hDev, U_CH, UPDN_NO);
		}
	} else if(IsDlgButtonChecked(hwnd, IDC_RAD_DIR) == BST_CHECKED) {
		tct520_SelCtrMode(hDev, X_CH, DIRC_NO);
		tct520_SelCtrMode(hDev, Y_CH, DIRC_NO);
		if(gCh == M_CH)	{
			tct520_SelCtrMode(hDev, Z_CH, DIRC_NO);
			tct520_SelCtrMode(hDev, U_CH, DIRC_NO);
		}
	}

	/* Read & Clearݒ */
	if(IsDlgButtonChecked(hwnd, IDC_CHK_AUTO) == BST_CHECKED) {
		tct520_SetAutoClr(hDev, X_CH, 1);
		tct520_SetAutoClr(hDev, Y_CH, 1);
		if(gCh == M_CH)	{
			tct520_SetAutoClr(hDev, Z_CH, 1);
			tct520_SetAutoClr(hDev, U_CH, 1);
		}
	} else {
		tct520_SetAutoClr(hDev, X_CH, 0);
		tct520_SetAutoClr(hDev, Y_CH, 0);
		if(gCh == M_CH)	{
			tct520_SetAutoClr(hDev, Z_CH, 0);
			tct520_SetAutoClr(hDev, U_CH, 0);
		}
	}

	/* Rp[^Ab`AJE^NAAETMR̐ݒ */
	/* WX^yуIvV|[g */
	ct520_rXYReg(hDev, 0xc7, &rnv1[XYCH]);		/* XYch RENV1 Ǎ */
	ct520_rXYReg(hDev, 0xc8, &rnv2[XYCH]);		/* XYch RENV2 Ǎ */
	if(gCh == M_CH)	{
		ct520_rZUReg(hDev, 0xc7, &rnv1[ZUCH]);	/* ZUch RENV1 Ǎ */
		ct520_rZUReg(hDev, 0xc8, &rnv2[ZUCH]);	/* ZUch RENV2 Ǎ */
	}
	ct520_rPortW(hDev, CMP_PORT, &opt[CMP]);	/* Rp[^ݒ|[gǍ */
	ct520_rPortW(hDev, TMR_PORT, &opt[TMR]);	/* ETMRo͐ݒ|[gǍ */
	ct520_rPortW(hDev, CIN_PORT, &opt[CIN]);	/* vo͐ݒ|[gǍ */
	ct520_rPortW(hDev, CLR_PORT, &opt[CLR]);	/* Z̓JE^NAǍ */
	ct520_rPortW(hDev, LTC_PORT, &opt[LTC]);	/* b`Ǎ */

	/* vo͐ݒ */
	/* XYOUT1o͐ݒ */
	if(IsDlgButtonChecked(hwnd, IDC_CHK_XYCMP) == BST_CHECKED) {
		/* rf[^ݒ */
		GetDlgItemText(hwnd, IDC_EDT_XYCMP, szBuf, 10l);	/* rf[^擾 */
		if(!(isNum(&szBuf[0]))) gCmp[XYCH] = atol(szBuf);	/* XYchRp[^rf[^ۑ */
		else					return	ILL_XYCP;
		/* rJE^ݒ */
		if(IsDlgButtonChecked(hwnd, IDC_RAD_XCTR) == BST_CHECKED)	rnv1[XYCH] &= ~0x01000000;
		if(IsDlgButtonChecked(hwnd, IDC_RAD_YCTR) == BST_CHECKED)	rnv1[XYCH] |=  0x01000000;
		/* CMP1ݒ RCMP1 = rJE^(JEgɖ֌W) */
		rnv2[XYCH] &= ~0x0000000f;
		rnv2[XYCH] |=  0x00000002;
		rnv2[XYCH] &= ~0x10000000;				/* vM */
		opt[CMP] |=  0x0001;					/* CMP1o͋ */			
		if(IsDlgButtonChecked(hwnd, IDC_RAD_XYW1) == BST_CHECKED) {	
			rnv2[XYCH]  &= ~0x00030000;			/* CCL̐M̓x */
			opt[CIN] &= ~0x0010;				/* vo͐M̓xo */		 
		} 
		if(IsDlgButtonChecked(hwnd, IDC_RAD_XYW2) == BST_CHECKED) {		
			rnv2[XYCH]  |=  0x00010000;			/* CCLM50usec */
			opt[CIN] |=  0x0010;				/* vo͐M104msec */ 
		}
	} else {					
		rnv2[XYCH]  |=  0x10000000;				/* vM}XN */
		opt[CMP] &= ~0x0001;					/* CMP1o̓}XN */
	}

	/* ZUOUT1o͐ݒ */
	if(IsDlgButtonChecked(hwnd, IDC_CHK_ZUCMP) == BST_CHECKED) {
		/* rf[^ݒ */
		GetDlgItemText(hwnd, IDC_EDT_ZUCMP, szBuf, 10l);	/* rf[^擾 */
		if(!(isNum(&szBuf[0]))) gCmp[ZUCH] = atol(szBuf);	/* ZUchRp[^rf[^ۑ */		
		else					return ILL_ZUCP;
		/* rJE^ݒ */
		if(IsDlgButtonChecked(hwnd, IDC_RAD_ZCTR) == BST_CHECKED)	rnv1[ZUCH] &= ~0x01000000;
		if(IsDlgButtonChecked(hwnd, IDC_RAD_UCTR) == BST_CHECKED)	rnv1[ZUCH] |=  0x01000000;
		/* CMP1ݒ RCMP1 = rJE^(JEgɖ֌W) */
		rnv2[ZUCH] &= ~0x0000000f;
		rnv2[ZUCH] |=  0x00000002;
		rnv2[ZUCH] &= ~0x10000000;				/* vM */
		opt[CMP]   |=  0x0010;					/* CMP1o͋ */			
		if(IsDlgButtonChecked(hwnd, IDC_RAD_ZUW1) == BST_CHECKED) {	
			rnv2[ZUCH]  &= ~0x00030000;			/* CCL̐M̓x */
			opt[CIN] &= ~0x0040;				/* vo͐M̓xo */		 
		} 
		if(IsDlgButtonChecked(hwnd, IDC_RAD_ZUW2) == BST_CHECKED) {		
			rnv2[ZUCH]  |=  0x00010000;			/* CCLM50usec */
			opt[CIN] |=  0x0040;				/* vo͐M104msec */ 
		}
	} else {					
		rnv2[ZUCH]  |=  0x10000000;				/* vM}XN */
		opt[CMP] &= ~0x0010;					/* CMP1o̓}XN */
	}
	
	/* JE^NAݒ */
	if(IsDlgButtonChecked(hwnd, IDC_CHK_XZCLR) == BST_CHECKED) {	
		opt[CLR] |=  0x0001;					/* XchZ̓JE^NAL */
		rnv1[XYCH]  &= ~0x00040000;				/* XchZ̓JE^NAL */		
	} else {
		opt[CLR] &= ~0x0001;					/* XchZ̓JE^NA */
		rnv1[XYCH]  |=  0x00040000;				/* XchZ̓JE^NA */		
	}

	if(IsDlgButtonChecked(hwnd, IDC_CHK_YZCLR) == BST_CHECKED) {	
		opt[CLR] |=  0x0002;					/* YchZ̓JE^NAL */	
		rnv1[XYCH]  &= ~0x00080000;				/* YchZ̓JE^NAL */	
	} else {
		opt[CLR] &= ~0x0002;					/* YchZ̓JE^NA */
		rnv1[XYCH]  |=  0x00080000;				/* YchZ̓JE^NA */		
	}

	if(IsDlgButtonChecked(hwnd, IDC_CHK_ZZCLR) == BST_CHECKED) {	
		opt[CLR] |=  0x0004;					/* ZchZ̓JE^NAL */
		rnv1[ZUCH]  &= ~0x00040000;				/* ZchZ̓JE^NAL */	
	} else {
		opt[CLR] &= ~0x0004;					/* ZchZ̓JE^NA */
		rnv1[ZUCH]  |=  0x00040000;				/* ZchZ̓JE^NA */		
	}

	if(IsDlgButtonChecked(hwnd, IDC_CHK_UZCLR) == BST_CHECKED) {	
		opt[CLR] |=  0x0008;					/* UchZ̓JE^NAL */		
		rnv1[ZUCH]  &= ~0x00080000;				/* UchZ̓JE^NAL */	
	} else {
		opt[CLR] &= ~0x0008;					/* UchZ̓JE^NA */
		rnv1[ZUCH]  |=  0x00080000;				/* UchZ̓JE^NA */		
	}

	/* XYCMP1ŃJE^NA/Ȃ */
	if(IsDlgButtonChecked(hwnd, IDC_CHK_XYCLR) == BST_CHECKED) {
		rnv2[XYCH] |=  0x00100000;							/* rJE^NA */
		/* rf[^ݒ */
		GetDlgItemText(hwnd, IDC_EDT_XYCMP, szBuf, 10l);	/* rf[^擾 */
		if(!(isNum(&szBuf[0]))) gCmp[XYCH] = atol(szBuf);	/* XYchRp[^rf[^ۑ */			
		else				return ILL_XYCP;		
		/* rJE^ݒ */
		if(IsDlgButtonChecked(hwnd, IDC_RAD_XCTR) == BST_CHECKED)	rnv1[XYCH] &= ~0x01000000;
		if(IsDlgButtonChecked(hwnd, IDC_RAD_YCTR) == BST_CHECKED)	rnv1[XYCH] |=  0x01000000;
		/* CMP1ݒ RCMP1 = rJE^(JEgɖ֌W) */
		rnv2[XYCH] &= ~0x0000000f;
		rnv2[XYCH] |=  0x00000002;
		rnv2[XYCH] &= ~0x10000000;					/* vM */
	} else { 
		rnv2[XYCH] &= ~0x00100000;					/* rJE^NAȂ */
		if(IsDlgButtonChecked(hwnd, IDC_CHK_XYCMP) == BST_UNCHECKED) {
			rnv2[XYCH] |=  0x10000000;				/* vM}XN */
		}
	}

	/* ZUCMP1ŃJE^NA/Ȃ */
	if(IsDlgButtonChecked(hwnd, IDC_CHK_ZUCLR) == BST_CHECKED) {
		rnv2[ZUCH] |=  0x00100000;							/* rJE^NA */
		/* rf[^ݒ */
		GetDlgItemText(hwnd, IDC_EDT_ZUCMP, szBuf, 10l);	/* rf[^擾 */
		if(!(isNum(&szBuf[0]))) gCmp[ZUCH] = atol(szBuf);	/* ZUchRp[^rf[^ۑ */			
		else				return ILL_ZUCP;
		/* rJE^ݒ */
		if(IsDlgButtonChecked(hwnd, IDC_RAD_ZCTR) == BST_CHECKED)	rnv1[ZUCH] &= ~0x01000000;
		if(IsDlgButtonChecked(hwnd, IDC_RAD_UCTR) == BST_CHECKED)	rnv1[ZUCH] |=  0x01000000;
		/* CMP1ݒ RCMP1 = rJE^(JEgɖ֌W) */
		rnv2[ZUCH] &= ~0x0000000f;
		rnv2[ZUCH] |=  0x00000002;
		rnv2[ZUCH] &= ~0x10000000;					/* vM */
	} else {
		rnv2[ZUCH] &= ~0x00100000;					/* rJE^NAȂ */
		if(IsDlgButtonChecked(hwnd, IDC_CHK_ZUCMP) == BST_UNCHECKED) {
			rnv2[ZUCH] |=  0x10000000;				/* vM}XN */
		}
	}

	/* b`ݒ */
	if(IsDlgButtonChecked(hwnd, IDC_CHK_XYLTC) == BST_CHECKED) {
		opt[LTC] |= 0x0001;									/* XYCMP1œb` */
		/* rf[^ݒ */
		GetDlgItemText(hwnd, IDC_EDT_XYCMP, szBuf, 10l);	/* rf[^擾 */
		if(!(isNum(&szBuf[0]))) gCmp[XYCH] = atol(szBuf);	/* XYchRp[^rf[^ۑ */			
		else				return ILL_XYCP;		
		/* rJE^ݒ */
		if(IsDlgButtonChecked(hwnd, IDC_RAD_XCTR) == BST_CHECKED)	rnv1[XYCH] &= ~0x01000000;
		if(IsDlgButtonChecked(hwnd, IDC_RAD_YCTR) == BST_CHECKED)	rnv1[XYCH] |=  0x01000000;
		/* CMP1ݒ RCMP1 = rJE^(JEgɖ֌W) */
		rnv2[XYCH] &= ~0x0000000f;
		rnv2[XYCH] |=  0x00000002;

		rnv1[XYCH]  &= ~0x10000000;				/* vM */	
	} else {
		if((IsDlgButtonChecked(hwnd, IDC_CHK_XYCLR) == BST_UNCHECKED) &&
		   (IsDlgButtonChecked(hwnd, IDC_CHK_XYCMP) == BST_UNCHECKED)) {
			rnv2[XYCH] |=  0x10000000;			/* vM}XN */
		}
		opt[LTC] &= ~0x0001;					/* XYCMP1œb` */
	}

	if(IsDlgButtonChecked(hwnd, IDC_CHK_ZULTC) == BST_CHECKED) {
		opt[LTC] |= 0x0002;									/* ZUCMP1œb` */
		/* rf[^ݒ */
		GetDlgItemText(hwnd, IDC_EDT_ZUCMP, szBuf, 10l);	/* rf[^擾 */
		if(!(isNum(&szBuf[0]))) gCmp[ZUCH] = atol(szBuf);	/* ZUchRp[^rf[^ۑ */	
		else				return ILL_ZUCP;		
		/* rJE^ݒ */
		if(IsDlgButtonChecked(hwnd, IDC_RAD_ZCTR) == BST_CHECKED)	rnv1[ZUCH] &= ~0x01000000;
		if(IsDlgButtonChecked(hwnd, IDC_RAD_UCTR) == BST_CHECKED)	rnv1[ZUCH] |=  0x01000000;
		/* CMP1ݒ RCMP1 = rJE^(JEgɖ֌W) */
		rnv2[ZUCH] &= ~0x0000000f;
		rnv2[ZUCH] |=  0x00000002;
		rnv1[ZUCH]  &= ~0x10000000;				/* vM */		
	} else {
		if((IsDlgButtonChecked(hwnd, IDC_CHK_ZUCLR) == BST_UNCHECKED) &&
		   (IsDlgButtonChecked(hwnd, IDC_CHK_ZUCMP) == BST_UNCHECKED)) {
			rnv2[ZUCH] |=  0x10000000;			/* vM}XN */
		}
		opt[LTC] &= ~0x0002;					/* ZUCMP1œb` */
	}
	if(IsDlgButtonChecked(hwnd, IDC_CHK_INLTC) == BST_CHECKED) {
		opt[LTC] |=  0x0004;					/* IN1ɂ铯b` */
	} else {
		opt[LTC] &= ~0x0004;					/* IN1ɂ铯b` */
	}
	if(IsDlgButtonChecked(hwnd, IDC_CHK_TMLTC) == BST_CHECKED) {
		opt[LTC] |= 0x0008;						/* XYETMRɂ铯b` */
		GetDlgItemText(hwnd, IDC_EDT_ETMR, szBuf, 16);	/* ETMR擾 */
		if(szBuf[0] == 0x00)	return	ILL_NULL;		
		tmr = atol(szBuf);			
	} else {
		opt[LTC] &= ~0x0008;					/* XYETMRɂ铯b` */
		tmr = 0;								/* ETMR~ */
	}
	if(IsDlgButtonChecked(hwnd, IDC_CHK_XZLTC) == BST_CHECKED) {
		opt[LTC] |=  0x0010;					/* XchZ͂ɂ铯b` */
	} else {
		opt[LTC] &= ~0x0010;					/* XchZ͂ɂ铯b` */
	}
	if(IsDlgButtonChecked(hwnd, IDC_CHK_YZLTC) == BST_CHECKED)  {
		opt[LTC] |=  0x0020;					/* YchZ͂ɂ铯b` */
	} else {
		opt[LTC] &= ~0x0020;					/* YchZ͂ɂ铯b` */
	}
	if(IsDlgButtonChecked(hwnd, IDC_CHK_ZZLTC) == BST_CHECKED) {
		opt[LTC] |=  0x0040;					/* ZchZ͂ɂ铯b` */
	} else {
		opt[LTC] &= ~0x0040;					/* ZchZ͂ɂ铯b` */
	}
	if(IsDlgButtonChecked(hwnd, IDC_CHK_UZLTC) == BST_CHECKED) {
		opt[LTC] |=  0x0080;					/* UchZ͂ɂ铯b` */
	} else {
		opt[LTC] &= ~0x0080;					/* UchZ͂ɂ铯b` */
	}

	/* ETMRo͐ݒ */
	if(IsDlgButtonChecked(hwnd, IDC_CHK_ETMR) == BST_CHECKED) {
		GetDlgItemText(hwnd, IDC_EDT_ETMR, szBuf, 16);		/* ETMR Cycle擾 */
		if(szBuf[0] == 0x00)	return ILL_NULL;
		
		tmr = atol(szBuf);			

		opt[TMR] |= 0x0001;				/* ETMRo͋ */
		opt[CIN] |= 0x0002;				/* vo͐ݒ(XYOUT2ETMRo) */
		
		/* ETMRvo͕ݒ */
		if(IsDlgButtonChecked(hwnd, IDC_RAD_TMW1) == BST_CHECKED) {
			/* 10usec */
			opt[TMR] &= ~0x0010;		/* gOo͂Ȃ     */
			opt[CIN] &= ~0x0020;		/* o̓pX 10usec */
		} 
		if(IsDlgButtonChecked(hwnd, IDC_RAD_TMW2) == BST_CHECKED) {
			/* XYOUT2o͕104msec̎ETMR */
			/* 105msecȉɐݒs */
			if(tmr < 106) 		return ILL_ETMR;
			/* 104msec */
			opt[TMR] &= ~0x0010;		/* gOo͂Ȃ     */
			opt[CIN] |=  0x0020;		/* o̓pX 104msec */
		}
		if(IsDlgButtonChecked(hwnd, IDC_RAD_TMW3) == BST_CHECKED) {
			/* duty50%gOo */
			opt[TMR] |=  0x0010;		/* duty50%gOo */
			opt[CIN] &= ~0x0020;		/* o̓pX 104msecɂȂ */
		}
	} else {
		opt[TMR] &= ~0x0001;			/* ETMRo͖ */
		opt[CIN] &= ~0x0002;			/* vo͐ݒ(XYOUT2CMP2) */
		if(IsDlgButtonChecked(hwnd, IDC_CHK_TMLTC) == BST_UNCHECKED) {
			tmr = 0;					/* ETMR~ */
		}
	}

	if(tmr)	gTmr = tmr;					/* ETMRۑ */
	reg = tmr * 100;					/* ETMRWX^f[^ */

	/* WX^yуIvV|[g */
	ct520_wXYReg(hDev, 0x82, gCmp[XYCH]);		/* XYch RCMP1  */
	ct520_wXYReg(hDev, 0x86, reg);				/* XYch ETMR   */
	ct520_wXYReg(hDev, 0x87, rnv1[XYCH]);		/* XYch RENV1   */
	ct520_wXYReg(hDev, 0x88, rnv2[XYCH]);		/* XYch RENV2   */
	if(gCh == M_CH)	{
		ct520_wZUReg(hDev, 0x82, gCmp[ZUCH]);	/* ZUch RCMP1  */
		ct520_wZUReg(hDev, 0x87, rnv1[ZUCH]);	/* ZUch RCMP1  */
		ct520_wZUReg(hDev, 0x88, rnv2[ZUCH]);	/* ZUch RCMP1  */
	}
	ct520_wPortW(hDev, CMP_PORT, opt[CMP]);		/* Rp[^ݒ|[g */
	ct520_wPortW(hDev, TMR_PORT, opt[TMR]);		/* ETMRo͐ݒ|[g */
	ct520_wPortW(hDev, CIN_PORT, opt[CIN]);		/* vo͐ݒ|[g */
	ct520_wPortW(hDev, CLR_PORT, opt[CLR]);		/* Z̓JE^NA */
	ct520_wPortW(hDev, LTC_PORT, opt[LTC]);		/* b` */
	return 0;
}

/****************************************************************/
/*	{[h̏												*/
/*		HPCI-CTR520F̏܂B					*/
/*		gpɍ킹ēKXf[^ύXĂB	*/
/****************************************************************/
WORD tct520_InitCtr(DWORD hDevID)
{
	WORD	ret;
	DWORD	reg;

/* 1. #1CCLWX^ݒ */
	/* 1.1 \tgEFAZbg : ĳؾĎw߂őSĂڼ޽͂Oر */
	ct520_wXYCmd(hDevID, 0x40);				/* ȍ~̊eڼ޽̏͊mF

	/* 1.2 #1CCL WX^P(͎dl,̑) */
#define		RENV1	0x0acc3012L	/* WX^Pݒl */
			/* b31   (0   ):ϒ[qo:_(ްގd:Œ) */
			/* b30-28( 000):Ϗo͎FȂ */
			/* b27   (1   ):ڰ4:YCTR */
			/* b26   ( 0  ):ڰ3:XCTR */
			/* b25   (  1 ):ڰ2:YCTR */
			/* b24   (   0):ڰ1:XCTR */
			/* b23-21(110 ):DSBnͶĒ~:  (ްގdl:Œ) */
			/* b20   (   0):LTCn͘_=贯(ްގdl:Œ) */
			/* b19   (1   ):YZͶر: */
			/* b18   ( 1  ):XZͶر: */
			/* b17-16(  00):YZ,XZ͸ر:贯 */
			/* b15   (0   ):YCTRǏo̎ر:Ȃ */
			/* b14   ( 0  ):XCTRǏo̎ر:Ȃ */
			/* b13   (  1 ):YCTR~ */
			/* b12   (   1):XCTR~ */
			/* b11-10(00  ):YCTRފԑI(`) */
			/* b 9- 8(  00):YCTRފԑJn(`) */
			/* b 7   (0   ):YCTR:޳ݶ */
			/* b 6   ( 0  ):YCTR=YA,YB */
			/* b 5- 3( 010):YA,YB=90߈ʑS{ */
			/* b 2- 0( 010):XA,XB=90߈ʑS{ */
	ct520_wXYReg(hDevID, 0x87, RENV1);
	ct520_rXYReg(hDevID, 0xc7, &reg);			/*  ƍǍ */
	if(reg != RENV1) 		return 1;

	/* 1.3 #1CCL WX^Q(ڰ,̑) */
#define		RENV2	0x1005ff00L	/* WX^Qݒl */
			/* b31-30(00  ):(CCLdl) */
			/* b29   (  0 ):XA,XB,YA,YB̨nm */
			/* b28   (   1):CMPOUT1,2o:Ͻ() */
			/* b27-24(0000):P0-3[q=ėp(ްގdl:Œ) */
			/* b23   (0   ):CMPOUT3,4[qo͘_=_ */
			/* b22   ( 0  ):CMPOUT1,2[qo͘_=_ */
			/* b21   (  0 ):CMPOUT2o͂"="r=Ȃ */
			/* b20   (   0):CMPOUT1o͂"="r=Ȃ */
			/* b19-18(01  ):CMPOUT3,4o͐Mٽ=ݼ50us */
			/* b17-16(  01):CMPOUT1,2o͐Mٽ=ݼ50us */
			/* b15-12(1111):CMPOUT4o͂̔r@=ɕs */
			/* b11- 8(1111):CMPOUT3o͂̔r@=ɕs */
			/* b 7- 4(0000):CMPOUT2o͂̔r@=RCMP1<r */
			/* b 3- 0(0000):CMPOUT1o͂̔r@=RCMP1<r */
	ct520_wXYReg(hDevID, 0x88, RENV2);
	ct520_rXYReg(hDevID, 0xc8, &reg);			/*  ƍǍ */
	if(reg != RENV2)			return 1;

	/* 1.4 #1CCL JE^P */
	ct520_wXYReg(hDevID, 0x80, 0);			/* JE^PO */
	ct520_rXYReg(hDevID, 0xc0, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	/* 1.5 #1CCL JE^Q */
	ct520_wXYReg(hDevID, 0x81, 0);			/* JE^QO */
	ct520_rXYReg(hDevID, 0xc1, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	/* 1.6 #1CCL rf[^WX^P */
#define		WIND_N	-5000L					/* ޺ڰ:RCMP1 */
	ct520_wXYReg(hDevID, 0x82, WIND_N);		/* rf[^WX^P= WIND_N */
	ct520_rXYReg(hDevID, 0xc2, &reg);			/*  ƍǍ */
	if(reg!=WIND_N)				return 1;

	/* 1.7 #1CCL rf[^WX^Q */
#define		WIND_P	 5000L					/* ޺ڰ:RCMP2 */
	ct520_wXYReg(hDevID, 0x83, WIND_P);		/* rf[^WX^Q= WIND_P */
	ct520_rXYReg(hDevID, 0xc3, &reg);			/*  ƍǍ */
	if(reg!=WIND_P) 			return 1;

	/* 1.8 #1CCL rf[^WX^R */
	ct520_wXYReg(hDevID, 0x84, 0);			/* rf[^WX^RO */
	ct520_rXYReg(hDevID, 0xc4, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	/* 1.9 #1CCL rf[^WX^S */
	ct520_wXYReg(hDevID, 0x85, 0);			/* rf[^WX^SO */
	ct520_rXYReg(hDevID, 0xc5, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	/* 1.10 #1CCL ETMRWX^ */
	ct520_wXYReg(hDevID, 0x86, 0);			/* ETMRWX^O */
	ct520_rXYReg(hDevID, 0xc6, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	/* 1.11 #1CCL vݒ背WX^ */
			/* b31-28(0000):sgp */
			/* b27   (0   ):sgp */
			/* b26   ( 0  ):(ITM):gpJnƎw莞Ԍoߖ */
			/* b25   (  0 ):YCTR:MaxMin蒆(=0x4a)ɑIތo(RENV1:b11-10) */
			/* b24   (   0):߼߰ēׯ(0x18)ݒɂ铯ׯ */
			/* b23   (0   ):YCTR -ް۰ */
			/* b22   ( 0  ):YCTR +ް۰ */
			/* b21   (  0 ):XCTR -ް۰ */
			/* b20   (   0):XCTR +ް۰ */
			/* b19   (0   ):YAYB͐Mُ픭(ω) */
			/* b18   ( 0  ):XAXB͐Mُ픭(ω) */
			/* b17   (  0 ):YCTR<>0 ==> YCTR=0 */
			/* b16   (   0):XCTR<>0 ==> XCTR=0 */
			/* b15-12(0000):sgp(\) */
			/* b11-10(00  ):sgp(\) */
			/* b 9   (  0 ):߼߰YZر(0x19:b1)ݒɂ鶳ر */
			/* b 8   (   0):߼߰XZر(0x19:b0)ݒɂ鶳ر */
			/* b 7   (0   ):CMPOUT4o͏  ==>s */
			/* b 6   ( 0  ):CMPOUT4o͏s==>   */
			/* b 5   (  0 ):CMPOUT3o͏  ==>s */
			/* b 4   (   0):CMPOUT3o͏s==>   */
			/* b 3   (0   ):CMPOUT2o͏  ==>s */
			/* b 2   ( 0  ):CMPOUT2o͏s==>   */
			/* b 1   (  0 ):CMPOUT1o͏  ==>s */
			/* b 0   (   0):CMPOUT1o͏s==>   */
	ct520_wXYReg(hDevID, 0x89, 0);			/*  all off */
	ct520_rXYReg(hDevID, 0xc9, &reg);			/*  ƍǍ */
	if(reg) 					return 1;

	if(gCh == M_CH) {		/* SȂ */
	/* 2. #2CCLWX^ݒ */
	/* 2.1 \tgEFAZbg : ĳؾĎw߂őSĂڼ޽͂Oر */
		ct520_wZUCmd(hDevID, 0x40);				/* ȍ~̊eڼ޽̏͊mF

		/* 2.2 #2CCL WX^P(͎dl,̑) */
		/* #1CCLƓl̐ݒ */
		ct520_wZUReg(hDevID, 0x87, RENV1);
		ct520_rZUReg(hDevID, 0xc7, &reg);			/*  ƍǍ */
		if(reg != RENV1) 		return 1;

		/* 2.3 #2CCL WX^Q(ڰ,̑) */
		/* #1CCLƓl̐ݒ */
		ct520_wZUReg(hDevID, 0x88, RENV2);
		ct520_rZUReg(hDevID, 0xc8, &reg);			/*  ƍǍ */
		if(reg != RENV2)			return 1;

		/* 2.4 #2CCL JE^P */
		ct520_wZUReg(hDevID, 0x80, 0);			/* JE^PO */
		ct520_rZUReg(hDevID, 0xc0, &reg);			/*  ƍǍ */
		if(reg) 					return 1;

		/* 2.5 #2CCL JE^Q */
		ct520_wZUReg(hDevID, 0x81, 0);			/* JE^QO */
		ct520_rZUReg(hDevID, 0xc1, &reg);			/*  ƍǍ */
		if(reg) 					return 1;

		/* 2.6 #2CCL rf[^WX^P */
		/* #1CCLƓl̐ݒ */
		ct520_wZUReg(hDevID, 0x82, WIND_N);		/* rf[^WX^P= WIND_N */
		ct520_rZUReg(hDevID, 0xc2, &reg);			/*  ƍǍ */
		if(reg!=WIND_N)				return 1;

		/* 2.7 #2CCL rf[^WX^Q */
		/* #1CCLƓl̐ݒ */
		ct520_wZUReg(hDevID, 0x83, WIND_P);		/* rf[^WX^Q= WIND_P */
		ct520_rZUReg(hDevID, 0xc3, &reg);			/*  ƍǍ */
		if(reg!=WIND_P) 			return 1;

		/* 2.8 #2CCL rf[^WX^R */
		ct520_wZUReg(hDevID, 0x84, 0);			/* rf[^WX^RO */
		ct520_rZUReg(hDevID, 0xc4, &reg);			/*  ƍǍ */
		if(reg) 					return 1;

		/* 2.9 #2CCL rf[^WX^S */
		ct520_wZUReg(hDevID, 0x85, 0);			/* rf[^WX^SO */
		ct520_rZUReg(hDevID, 0xc5, &reg);			/*  ƍǍ */
		if(reg) 					return 1;

		/* 2.10 #2CCL ETMRWX^ */
		ct520_wZUReg(hDevID, 0x86, 0);			/* ETMRWX^O */
		ct520_rZUReg(hDevID, 0xc6, &reg);			/*  ƍǍ */
		if(reg) 					return 1;

		/* 2.11 #2CCL vݒ背WX^ */
		ct520_wZUReg(hDevID, 0x89, 0);			/*  all off */
		ct520_rZUReg(hDevID, 0xc9, &reg);			/*  ƍǍ */
		if(reg) 					return 1;
	}

/* 3. o̓|[g & IvV|[gݒ */
	ret = tct520_InitOpt(hDevID);
	if(ret) 					return 1;	/* error */
	else						return 0;
}

/****************************************************************/
/*	o̓|[gƃIvV|[g̏						*/
/*		HPCI-CTR520F̃IvV|[g̏܂B	*/
/*		gpɍ킹ēKXf[^ύXĂB	*/
/****************************************************************/
WORD tct520_InitOpt(DWORD hDevID)
{
	BYTE	bdt;
	WORD	wdt;

/* o̓|[g & IvV|[gݒ */
	/* 1 ėpo̓|[gNA */
	ct520_wPortB(hDevID, OUT_PORT, 0);		/* write(0) */
	ct520_rPortB(hDevID, OUT_PORT, &bdt);		/*  ƍǍ */
	bdt &= 0x0f;							/* mask */
	if(bdt) 					return 1;	/* verify error */

	/* 2 CMPo͐ݒ|[gFo͂Ȃ */
	ct520_wPortW(hDevID, CMP_PORT, 0);		/* write(0) */
	ct520_rPortW(hDevID, CMP_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x00ff;							/* mask */
	if(wdt)						return 1;	/* verify error */

	/* 3 TMRo͐ݒ|[gFo͂Ȃ */
	ct520_wPortW(hDevID, TMR_PORT, 0);		/* write(0) */
	ct520_rPortW(hDevID, TMR_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x0033;							/* mask */
	if(wdt)						return 1;	/* verify error */

	/* 4 vo͐ݒ|[g(XYOUT1, ZUOUT1o͕104msec) */
	ct520_wPortW(hDevID, CIN_PORT, 0x30);	/* write */
	ct520_rPortW(hDevID, CIN_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x00ff;							/* mask */
	if(wdt != 0x30)				return 1;	/* verify error */

	/* 5 JE^NAݒ|[gݒFy͂ɂJE^NAȂ */
	ct520_wPortW(hDevID, CLR_PORT, 0);		/* write */
	ct520_rPortW(hDevID, CLR_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x000f;							/* mask */
	if(wdt) 					return 1;	/* verify error */

	/* 6 b`ݒ|[gݒFb`Ȃ */
	ct520_wPortW(hDevID, LTC_PORT, 0);		/* write */
	ct520_rPortW(hDevID, LTC_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x00ff;							/* mask */
	if(wdt) 					return 1;	/* verify error */

	/* 7 }XN() */
	ct520_wPortW(hDevID, INT_PORT, 0);		/* write */
	ct520_rPortW(hDevID, INT_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x0007;							/* mask */
	if(wdt) 					return 1;	/* verify error */

	/* 8 }XN(PCI) */
	ct520_wPortW(hDevID, PCI_PORT, 0);		/* write */
	ct520_rPortW(hDevID, PCI_PORT, &wdt);		/*  ƍǍ */
	wdt &= 0x0001;							/* mask */
	if(wdt) 					return 1;	/* verify error */
	else						return 0;
}

/****************************************************/
/* JE^͌`̑I							*/
/*   hdev FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych )				*/
/*   md   FJE^͌`(O`T)				*/
/*			 0:x1, 1:x2, 2:x4, 3:U/D, 5:ٽ	*/
/*		ڼ޽P: Ych=b5-b3, Xch=b2-b0			*/
/****************************************************/
DWORD tct520_SelCtrMode(DWORD hDevID, WORD ch, WORD md)
{
	DWORD	reg;

	md = md;

	if(ch < Z_CH) {
		ct520_rXYReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case X_CH: reg &= ~0x00000007L;	reg |= md;		break;	/* b2-b0 */
		  case Y_CH: reg &= ~0x00000038L;	reg |= md << 3;	break;	/* b5-b3 */
		}
		ct520_wXYReg(hDevID, 0x87, reg);		/* WX^P */
	} else if(ch < M_CH) {
		ct520_rZUReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case Z_CH: reg &= ~0x00000007L;	reg |= md;		break;	/* b2-b0 */
		  case U_CH: reg &= ~0x00000038L;	reg |= md << 3;	break;	/* b5-b3 */
		}
		ct520_wZUReg(hDevID, 0x87, reg);		/* WX^P */
	} 
	return 0;
}

/****************************************************/
/* JE^ǏõJE^NAݒ				*/
/*   @\ FJE^Ǐo, JE^NA܂B*/
/*   hdev FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych )				*/
/*   sel  FJE^NA(1) / Ȃ(0)		*/
/*		ڼ޽P: Ych=b15, Xch=b14				*/
/****************************************************/
DWORD tct520_SetAutoClr(DWORD hDevID, WORD ch, WORD sel)
{
	DWORD	reg;

	if(ch < Z_CH) {
		ct520_rXYReg(hDevID, 0xc7, &reg);			/* WX^P */
		switch(ch) {
		  case X_CH: if(sel) reg |=  0x00004000L;	/*  b14=1 */
					 else	 reg &= ~0x00004000L;	/*  b14=0 */
					 break;
		  case Y_CH: if(sel) reg |=  0x00008000L;	/*  b15=1 */
					 else	 reg &= ~0x00008000L;	/*  b15=0 */
					 break;
		}
		ct520_wXYReg(hDevID, 0x87,  reg);			/* WX^P */
	} else if(ch < M_CH) {
		ct520_rZUReg(hDevID, 0xc7, &reg);			/* WX^P */
		switch(ch) {
		  case Z_CH: if(sel) reg |=  0x00004000L;	/*  b14=1 */
					 else	 reg &= ~0x00004000L;	/*  b14=0 */
					 break;
		  case U_CH: if(sel) reg |=  0x00008000L;	/*  b15=1 */
					 else	 reg &= ~0x00008000L;	/*  b15=0 */
					 break;
		}
		ct520_wZUReg(hDevID, 0x87,  reg);			/* WX^P */
	}
	return 0;
}

/****************************************************/
/* JEgX^[g									*/
/*   @\ FJEgJn܂B					*/
/*   hdev FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych )				*/
/*		ڼ޽P: Ych:b13=0, Xch:b12=0			*/
/****************************************************/
DWORD tct520_StrtCtr(DWORD hDevID, WORD ch)
{
	DWORD	reg;

	if(ch < Z_CH) {
		ct520_rXYReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case X_CH: reg &= ~0x00001000L;	break;	/*  b12=0 */
		  case Y_CH: reg &= ~0x00002000L;	break;	/*  b13=0 */
		}
		ct520_wXYReg(hDevID, 0x87,  reg);		/* WX^P */
	} else if(ch < M_CH) {
		ct520_rZUReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case Z_CH: reg &= ~0x00001000L;	break;	/*  b12=0 */
		  case U_CH: reg &= ~0x00002000L;	break;	/*  b13=0 */
		}
		ct520_wZUReg(hDevID, 0x87,  reg);		/* WX^P */
	}
	return 0;
}

/****************************************************/
/* JEgXgbv									*/
/*   @\ FJEg~܂B					*/
/*   hdev FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych )				*/
/*		ڼ޽P: Ych=b13, Xch=b12				*/
/****************************************************/
DWORD tct520_StopCtr(DWORD hDevID, WORD ch)
{
	DWORD	reg;

	if(ch < Z_CH) {
		ct520_rXYReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case X_CH: reg |=  0x00001000L;	break;	/*  b12=1 */
		  case Y_CH: reg |=  0x00002000L;	break;	/*  b13=1 */
		}
		ct520_wXYReg(hDevID, 0x87,  reg);		/* WX^P */
	} else if(ch < M_CH) {
		ct520_rZUReg(hDevID, 0xc7, &reg);		/* WX^P */
		switch(ch) {
		  case Z_CH: reg |=  0x00001000L;	break;	/*  b12=1 */
		  case U_CH: reg |=  0x00002000L;	break;	/*  b13=1 */
		}
		ct520_wZUReg(hDevID, 0x87,  reg);		/* WX^P */	
	}
	return 0;
}

/****************************************************/
/* JE^Ǎ										*/
/*   @\ FJEgǍ݂܂B					*/
/*   hdev FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych )				*/
/*   ctr  FJE^̒l							*/
/*    Ǎ  Xch=0xc0, Ych=0xc1					*/
/****************************************************/
DWORD tct520_ReadCtr(DWORD hDevID, WORD ch, long* ctr)
{
	DWORD	reg;

	switch(ch) {
	case X_CH:	ct520_rXYReg(hDevID, 0xc0, &reg);	break;
	case Y_CH:	ct520_rXYReg(hDevID, 0xc1, &reg);	break;
	case Z_CH:	ct520_rZUReg(hDevID, 0xc0, &reg);	break;
	case U_CH:	ct520_rZUReg(hDevID, 0xc1, &reg);	break;
	}

	*ctr = (long)reg;
	return 0;
}

/****************************************************/
/* b`f[^Ǎ									*/
/*   @\ Fb`f[^Ǎ݂܂B				*/
/*   hdev FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych )				*/
/*   ltc  Fb`f[^̒l						*/
/*    Ǎ  Xch=0xca, Ych=0xcb					*/
/****************************************************/
DWORD tct520_ReadLtc(DWORD hDevID, WORD ch, long* ltc)
{
	DWORD	reg;

	switch(ch) {
	case X_CH:	ct520_rXYReg(hDevID, 0xca, &reg);	break;
	case Y_CH:	ct520_rXYReg(hDevID, 0xcb, &reg);	break;
	case Z_CH:	ct520_rZUReg(hDevID, 0xca, &reg);	break;
	case U_CH:	ct520_rZUReg(hDevID, 0xcb, &reg);	break;
	}

	*ltc = (long)reg;
	return 0;
}

/****************************************************/
/* JE^NA									*/
/*   @\ FJE^NA(=0)܂B			*/
/*   hdev FfoCXnh						*/
/*   ch   F`l(0:Xch, 1:Ych )				*/
/*      Xch=0x01, Ych=0x02					*/
/****************************************************/
DWORD tct520_ClrCtr(DWORD hDevID, WORD ch)
{
	switch(ch) {
		case X_CH:	ct520_wXYCmd(hDevID, 0x01);	break;
		case Y_CH:	ct520_wXYCmd(hDevID, 0x02);	break;
		case Z_CH:	ct520_wZUCmd(hDevID, 0x01);	break;
		case U_CH:	ct520_wZUCmd(hDevID, 0x02);	break;
	}
	return 0;
}

/****************************************************/
/* b`R}h									*/
/* @\  Fb`܂B							*/
/* hDevIDFfoCXnh							*/
/* ch    F`l(0:Xch, 1:Ych, 2:Zch, 3:Uch)	*/
/****************************************************/
DWORD tct520_SoftLtc(DWORD hDevID, WORD ch)
{
	switch(ch) {
		case X_CH:	ct520_wXYCmd(hDevID, 0x10);	break;
		case Y_CH:	ct520_wXYCmd(hDevID, 0x20);	break;
		case Z_CH:	ct520_wZUCmd(hDevID, 0x10);	break;
		case U_CH:	ct520_wZUCmd(hDevID, 0x20);	break;
	}
	return 0;
}

/* ėpo												*/
/* @\  FJE^Ǐo, JE^NA܂B		*/
/* hDevIDFfoCXnh								*/
/* wBit  Fėpo̓|[gԍ							*/
DWORD tct520_Outp(DWORD hDevID, WORD wBit)
{
	WORD	dt;

	ct520_rPortW(hDevID, OUT_PORT, &dt);
	if(dt & (0x0001 << wBit))	dt &= ~(0x0001 << wBit);
	else						dt |=  (0x0001 << wBit);
	ct520_wPortW(hDevID, OUT_PORT,  dt);
	return 0;
}

/* 񂪐lǂ̔f */
long isNum(char* szBuf)
{
	int	len, n;

	len = strlen(szBuf);
	if(!len)								return 1;

	for(n = 0; n < len; n++) {
		if(!(isdigit((int)szBuf[n]))) {
			if(!n) {
				if(szBuf[0] == '-')	{
					if(szBuf[1] == 0x00)	return 1;
				} else {
											return 1;
				}
			} else {
											return 1;
			}
		}
	}

	return 0;
}