'********************************************
'  HPCI-CTR520 series
'  Driver I/F DLL function for VB.NET2003
'      file name:hictr520.vb
'      date     :2010/06/11
'      version  :1.0.0
'********************************************
Option Strict Off
Option Explicit On

Module hictr520

	' 萔`
	Public Const INVALID_BUS_NUMBER As Integer = -1 ' ȃoXԍ
	Public Const INVALID_DEV_NUMBER As Integer = -1 ' ȃfoCXԍ
	Public Const INVALID_IO_ADDRESS As Integer = -1 '  I/O AhX
	Public Const INVALID_IRQ_NUMBER As Integer = -1 '  IRQ ԍ
	Public Const INVALID_HPC_NUMBER As Integer = -1 ' ȊǗԍ
	Public Const INVALID_BOARD_ID As Integer = -1 ' ȃ{[hID

	' foCX\
	Public Structure HPCDEVICEINFO
		Dim nBusNumber As Integer ' oXԍ
		Dim nDeviceNumber As Integer ' foCXԍ
		Dim dwIoPortAddress As Integer ' I/O|[gAhX
		Dim dwIrqNo As Integer ' IRQԍ
		Dim dwNumber As Integer ' Ǘԍ(Windows 95/98/Meł͖)
		Dim dwBoardID As Integer ' {[hID
	End Structure

	' DLL֐`
	'{[h̎擾(FfoCX̌)
	Declare Function ct520_GetDeviceCount Lib "hictr520.dll" (ByRef HpcDevNum As Integer) As Integer

	'foCX̎擾(FfoCX̌AfoCX񃊃Xg̐擪AhX)
	Declare Function ct520_GetDeviceInfo Lib "hictr520.dll" (ByRef HpcDevNum As Integer, ByRef HpcDevInfo As HPCDEVICEINFO) As Integer

	'foCX̃I[v(FfoCX̃AhX)
	Declare Function ct520_OpenDevice Lib "hictr520.dll" (ByRef hDevID As Integer, ByRef HpcDevInfo As HPCDEVICEINFO) As Integer

	'foCXN[Y(FfoCXnh)
	Declare Function ct520_CloseDevice Lib "hictr520.dll" (ByVal hDevID As Integer) As Integer

	'Xe[^XǍ(FfoCXnhAf[^i[)
	Declare Function ct520_rXYSts Lib "hictr520.dll" (ByVal hDevID As Integer, ByRef wSts As Short) As Integer
	Declare Function ct520_rZUSts Lib "hictr520.dll" (ByVal hDevID As Integer, ByRef wSts As Short) As Integer

	'R}h(FfoCXnhApf[^)
	Declare Function ct520_wXYCmd Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal cmd As Short) As Integer
	Declare Function ct520_wZUCmd Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal cmd As Short) As Integer

	'[hWX^Ǎ(FfoCXnhAf[^i[)
	Declare Function ct520_rXYReg Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal cmd As Short, ByRef reg As Integer) As Integer
	Declare Function ct520_rZUReg Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal cmd As Short, ByRef reg As Integer) As Integer

	'CgWX^(FfoCXnhApf[^)
	Declare Function ct520_wXYReg Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal cmd As Short, ByVal reg As Integer) As Integer
	Declare Function ct520_wZUReg Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal cmd As Short, ByVal reg As Integer) As Integer

	'IvV|[gPoCgǍ(FfoCXnhAf[^i[)
	Declare Function ct520_rPortB Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal offset As Byte, ByRef byData As Byte) As Integer
	'IvV|[gQoCgǍ(FfoCXnhAf[^i[)
	Declare Function ct520_rPortW Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal offset As Byte, ByRef wData As Short) As Integer

	'IvV|[gPoCg(FfoCXnhApf[^)
	Declare Function ct520_wPortB Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal offset As Byte, ByVal byData As Byte) As Integer
	'IvV|[gQoCg1(FfoCXnhApf[^)
	Declare Function ct520_wPortW Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal offset As Byte, ByVal wData As Short) As Integer

	'o̓obt@Ǎ(FfoCXnhAf[^i[)
	Declare Function ct520_rXYBuf Lib "hictr520.dll" (ByVal hDevID As Integer, ByRef reg As Integer) As Integer
	Declare Function ct520_rZUBuf Lib "hictr520.dll" (ByVal hDevID As Integer, ByRef reg As Integer) As Integer

	'o̓obt@(FfoCXnhApf[^)
	Declare Function ct520_wXYBuf Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal reg As Integer) As Integer
	Declare Function ct520_wZUBuf Lib "hictr520.dll" (ByVal hDevID As Integer, ByVal reg As Integer) As Integer
End Module