/************************************/
/*  HPCI-CTR520F series sample(Vc)	*/
/*	    file name:h_ltc.c			*/
/*      date     :2003/02/20		*/
/*      version  :1.0.0.0 			*/
/************************************/

#include	<windows.h>
#include	"resource.h"
#include	"hictr520.h"
#include	"spct5200.h"

void	DlgLtcLoad  (HWND);
void	DlgLtcUnload(HWND);
void	OpenLtcDev  (HWND);		/* foCXI[v */
void	CloseLtcDev (HWND);		/* foCXN[Y */
void	TmrReadLtc  (HWND);		/* JE^Ǎ^C} */
void	SetLtcData  (HWND);		/* b`̐ݒ */

/*	foCX֌W̃_CAO{bNX  */
BOOL CALLBACK DlgLtcProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	LPARAM	dummy;
	long	reg;
	char	szBuf[255];
	WORD	sts;
	WORD	wdt;

	dummy = lParam;

	/* _CAO{bNX */
	switch(message) {
		/*  */
		case WM_SHOWWINDOW:	DlgLtcLoad(hwnd);					break;

		/* {^NbN̏ */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* foCXI[v */
				case IDC_BTN_OPEN:	OpenLtcDev(hwnd);			break;

				/* foCXN[Y */
				case IDC_BTN_CLOS:	CloseLtcDev(hwnd);			break;

				case IDC_BTN_XREAD:	
					sct520_ReadCtr(hDev, X_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
					
					sct520_ReadLtc(hDev, X_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_XLTC, szBuf);
																break;
				case IDC_BTN_YREAD:	
					sct520_ReadCtr(hDev, Y_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);

					sct520_ReadLtc(hDev, Y_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_YLTC, szBuf);
																break;
				case IDC_BTN_XCLR:	
					sct520_ClrCtr (hDev, X_CH);		
					sct520_ReadCtr(hDev, X_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
																break;
				case IDC_BTN_YCLR:
					sct520_ClrCtr (hDev, Y_CH);		
					sct520_ReadCtr(hDev, Y_CH, &reg);
					/* \ */
					wsprintf(szBuf, "%ld ", reg);
					SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);
																break;
				case IDC_BTN_XSTA:
					/* Xe[^XǍ */
					ct520_rXYSts(hDev, &sts);
					if(sts & 0x20) { 
					/* Ych~Ȃ */
						SetLtcData(hwnd);
					}
					
					/* JEgX^[g */
					sct520_StrtCtr(hDev, X_CH);	
					
					/* ʕ\(쒆̓JEg͌`Cb`ύXs) */
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP), TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_0004), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_0005), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLLT), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZIN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZIN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_ETMR), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_IN1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_CMP1), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM1), FALSE);
															break;
				case IDC_BTN_YSTA:
					/* Xe[^XǍ */
					ct520_rXYSts(hDev, &sts);
					if(sts & 0x10) { 
					/* Xch~Ȃ */
						SetLtcData(hwnd);
					}	
					
					/* JEgX^[g */
					sct520_StrtCtr(hDev, Y_CH);	
					
					/* ʕ\(쒆̓JEg͌`Cb`ύXs) */
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP), TRUE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_0004), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_0005), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_STA_SLLT), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZIN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZIN), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_ETMR), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_IN1),  FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_CHK_CMP1), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM1), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR), FALSE);
																break;
				case IDC_BTN_XSTP:
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA), TRUE);

					/* Xe[^XǍ */
					ct520_rXYSts(hDev, &sts);
					if(sts & 0x20) { 
					/* Ych~Ȃ */
						/* Cxg^C}Xgbv */
						ct520_wXYReg(hDev, 0x86, 0);
						
						/* b` */
						ct520_rPortW(hDev, LTC_PORT, &wdt);
						wdt &= 0xff00;
						ct520_wPortW(hDev, LTC_PORT, wdt);
					}	

					sct520_StopCtr(hDev, X_CH);		/* JEgXgbv */					
																break;
				case IDC_BTN_YSTP:
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP), FALSE);
					EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA), TRUE);

					/* Xe[^XǍ */
					ct520_rXYSts(hDev, &sts);
					if(sts & 0x10) { 
					/* Xch~Ȃ */
						/* Cxg^C}Xgbv */
						ct520_wXYReg(hDev, 0x86, 0);
						
						/* b` */
						ct520_rPortW(hDev, LTC_PORT, &wdt);
						wdt &= 0xff00;
						ct520_wPortW(hDev, LTC_PORT, wdt);
					}	
					sct520_StopCtr(hDev, Y_CH);		/* JEgXgbv */
																break;
				case IDC_RAD_MLT1:	
					sct520_SelCtrMode(hDev, X_CH, MLT1_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT1_NO);
																break;
				case IDC_RAD_MLT2:
					sct520_SelCtrMode(hDev, X_CH, MLT2_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT2_NO);
																break;
				case IDC_RAD_MLT4:
					sct520_SelCtrMode(hDev, X_CH, MLT4_NO);
					sct520_SelCtrMode(hDev, Y_CH, MLT4_NO);
																break;
				case IDC_RAD_UPDN:
					sct520_SelCtrMode(hDev, X_CH, UPDN_NO);
					sct520_SelCtrMode(hDev, Y_CH, UPDN_NO);
																break;
				case IDC_RAD_DIRC:
					sct520_SelCtrMode(hDev, X_CH, DIRC_NO);
					sct520_SelCtrMode(hDev, Y_CH, DIRC_NO);
																break;
				case IDC_RAD_MANU:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_MANU) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), TRUE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), TRUE);
					}
																break;
				case IDC_RAD_AUTO:
					if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
						EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
					}
																break;
				case IDC_CHK_AUTO:	
					if(IsDlgButtonChecked(hwnd, IDC_CHK_AUTO) == BST_CHECKED) {
						sct520_SetAutoClr(hDev, X_CH, 1);
						sct520_SetAutoClr(hDev, Y_CH, 1);
					} else {
						sct520_SetAutoClr(hDev, X_CH, 0);
						sct520_SetAutoClr(hDev, Y_CH, 0);
					}
																break;
			}
																break;	
		/* ^C} */
		case WM_TIMER:
			switch(LOWORD(wParam)) {
				case IDM_TMR_READ:	TmrReadLtc(hwnd);			break;
			}
																break;		
		/* I */
		case WM_CLOSE:	DlgLtcUnload(hwnd);						break;

		/* I */
		case WM_DESTROY:hDlg = NULL;							break;
	}
	return 0;
}

	
/* foCXI[v */
void OpenLtcDev(HWND hwnd)
{
    char	szBuf[255];
	DWORD	ret;

	if(hDev == -1) {
        //{[hI[v
        ret = sct520_OpenID(&hDev, gBrdID);
		if(ret & 0x1000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", 
							"{[h}ĂȂAhCoCXg[ĂȂ̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		} else if(ret & 0x2000) {
			wsprintf(szBuf, "%s\n%s", "{[h擾s!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
        } else if(ret & 0x4000) {
			wsprintf(szBuf, "%s%ld%s", "w肵{[hhc ", gBrdID, "̃{[h}Ă܂");
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
            return;
		} else if(ret & 0x8000) {
			wsprintf(szBuf, "%s\n%s", "foCXI[vs!", "VXes̃G[");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			return;
		}
        
        // {[h̏
		ret = sct520_InitCtr(hDev);
		if(ret) {
			wsprintf(szBuf, "JE^[s!");	
			MessageBox(hwnd, szBuf, "ErrorMessage", MB_OK);
			DlgLtcUnload(hwnd);
			return;
		}

		/* {^\ */
		EnableWindow(GetDlgItem(hwnd, IDC_STA_XCH),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_YCH),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0001),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0002),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0003),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0004),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0005),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XCLR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YCLR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLLT),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZIN),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZIN),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ETMR),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_IN1),   TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_CMP1),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  TRUE);

		EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN),  FALSE);	/* foCXI[v{^gps */
		EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS),  TRUE);	/* foCXN[Y{^gp */

		/* WI{^`FbN */
		CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_CHECKED);
		CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_CHECKED);

		/* GfBbg{bNX̕\ */
		SetDlgItemText(hwnd, IDC_EDT_RCM1, "1000");
		SendDlgItemMessage(hwnd, IDC_EDT_RCM1, EM_SETLIMITTEXT, 9l, 0l);

		SetDlgItemText(hwnd, IDC_EDT_ETMR, "1000");
		SendDlgItemMessage(hwnd, IDC_EDT_ETMR, EM_SETLIMITTEXT, 5l, 0l);
		
		SetTimer(hwnd, IDM_TMR_READ, 100, NULL);		/* ^C}Jn(100msec) */
	}
}

/* foCXN[Y */
void CloseLtcDev(HWND hwnd)
{
	DWORD	ret;

	if(hDev == -1)	return;
	
	KillTimer(hwnd, IDM_TMR_READ);						/* ^C}I */

	/* ʕ\ */
	CheckDlgButton(hwnd, IDC_RAD_MLT1, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_MLT2, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_MLT4, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_UPDN, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_DIRC, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_RAD_MANU, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_RAD_AUTO, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_CHK_AUTO, BST_UNCHECKED);

	CheckDlgButton(hwnd, IDC_CHK_XZIN, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_YZIN, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_ETMR, BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_IN1,  BST_UNCHECKED);
	CheckDlgButton(hwnd, IDC_CHK_CMP1, BST_UNCHECKED);

	SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);
	SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL);

	SetDlgItemText(hwnd, IDC_STA_XCTR, "");
	SetDlgItemText(hwnd, IDC_STA_YCTR, "");
	SetDlgItemText(hwnd, IDC_STA_XLTC, "");
	SetDlgItemText(hwnd, IDC_STA_YLTC, "");

	EnableWindow(GetDlgItem(hwnd, IDC_STA_XCH),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_YCH),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0001),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0002),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0003),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0004),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_0005),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XREAD), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YREAD), FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YCLR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTA),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTA),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_XSTP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_YSTP),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_STA_SLLT),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZIN),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZIN),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_ETMR),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_IN1),   FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_CHK_CMP1),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM1),  FALSE);
	EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR),  FALSE);

	EnableWindow(GetDlgItem(hwnd, IDC_BTN_OPEN),  TRUE);	/* foCXI[v{^gp */
	EnableWindow(GetDlgItem(hwnd, IDC_BTN_CLOS),  FALSE);	/* foCXN[Y{^gps */
	
	/* GfBbg{bNX̕\ */
	SetDlgItemText(hwnd, IDC_EDT_RCM1, "");
	SetDlgItemText(hwnd, IDC_EDT_ETMR, "");

	ret = ct520_CloseDevice(hDev);
	
	/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	hDev = (DWORD)-1;
}

/* ʏ */
void DlgLtcLoad(HWND hwnd)
{
	HDC		hDC;
	
	/* w肳ꂽEBhẼNCAg̈ɑ΂foCXReLXg̃nh擾 */
	hDC = GetDC(hwnd);

	/* foCXReLXg */
	ReleaseDC(hwnd, hDC);

	/* rbg}bṽ[h */
	hWht  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_WHITE));
	hGrn  = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_GREEN));

	hDev = (DWORD)-1;
}

/*	e_CAO鏈 */
void DlgLtcUnload(HWND hwnd)
{	
	if(hDev != -1) {
		KillTimer(hwnd, IDM_TMR_READ);	/* ^C}[I */
		ct520_CloseDevice(hDev);		/* foCXN[Y */
		hDev = (DWORD)-1;				/* foCXN[YςȂhDev=-1(foCXI[v^N[YԔf̈) */
	}

	DestroyWindow(hwnd);				/* _CAO{bNX */
	hDlg = NULL;						/* _CAO{bNX̃nh */
	ShowWindow(hInx, SW_SHOWDEFAULT);	/* C̃EBhE\ */
}

/* JEglCb`f[^CXe[^XǍ */
void TmrReadLtc(HWND hwnd)
{
	char	szBuf[255];
	WORD	sts;
	long	reg;

	/* Xe[^XǍ */
	ct520_rXYSts(hDev, &sts);
	if((sts & 0x10) && (sts & 0x20)) {
		/* ~̎̓JEg͌`I */
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLOP), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLRD), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT1), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT2), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MLT4), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_UPDN), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_DIRC), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_MANU), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_RAD_AUTO), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_AUTO), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0004), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_0005), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_STA_SLLT), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_XZIN), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_YZIN), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_ETMR), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_IN1),  TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CHK_CMP1), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_ETMR), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_EDT_RCM1), TRUE);
	}
	
	if(IsDlgButtonChecked(hwnd, IDC_RAD_AUTO) == BST_CHECKED) {
		/* JEglǍ */
		sct520_ReadCtr(hDev, X_CH, &reg);
		/* \ */
		wsprintf(szBuf, "%ld ", reg);
		SetDlgItemText(hwnd, IDC_STA_XCTR, szBuf);
				
		/* JEglǍ */
		sct520_ReadCtr(hDev, Y_CH, &reg);
		/* \ */
		wsprintf(szBuf, "%ld ", reg);
		SetDlgItemText(hwnd, IDC_STA_YCTR, szBuf);

		/* b`f[^Ǎ */
		sct520_ReadLtc(hDev, X_CH, &reg);
		/* \ */
		wsprintf(szBuf, "%ld ", reg);
		SetDlgItemText(hwnd, IDC_STA_XLTC, szBuf);
				
		/* b`f[^Ǎ */
		sct520_ReadLtc(hDev, Y_CH, &reg);
		/* \ */
		wsprintf(szBuf, "%ld ", reg);
		SetDlgItemText(hwnd, IDC_STA_YLTC, szBuf);
	}

	/* Xe[^X\ */
	if(sts & 0x10) {	/* wbsqJEg~ */
		SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	} else {			/* wbsqJEg */
		SendDlgItemMessage(hwnd, IDC_STA_XRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	}

	if(sts & 0x20) {	/* xbsqJEg~ */
		SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hWht);
	} else {			/* xbsqJEg */
		SendDlgItemMessage(hwnd, IDC_STA_YRUN, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hGrn);
	}
}

/* b`ݒ */
void SetLtcData(HWND hwnd)
{
	long	reg;
	char	szBuf[255];
	WORD	cmpp;
	WORD	tmrp;
	WORD	cinp;
	WORD	ltcp;
	DWORD	rnv1;
	DWORD	rnv2;
	
	ct520_rXYReg(hDev, 0xc7, &rnv1);		/* ݒPǍ */
	ct520_rXYReg(hDev, 0xc8, &rnv2);		/* ݒQǍ */
	ct520_rPortW(hDev, CMP_PORT,  &cmpp);	/* Rp[^o͐ݒ|[gǍ */
	ct520_rPortW(hDev, TMR_PORT,  &tmrp);	/* Cxg^C}o͐ݒ|[gǍ */
	ct520_rPortW(hDev, CIN_PORT,  &cinp);	/* vo͐ݒ|[gǍ */
	ct520_rPortW(hDev, LTC_PORT,  &ltcp);	/* b`ݒ|[gǍ */

	if(IsDlgButtonChecked(hwnd, IDC_CHK_CMP1) == BST_CHECKED) {
		/* Rp[^rf[^ݒ(XYRCMP1) */
		GetDlgItemText(hwnd, IDC_EDT_RCM1, szBuf, 10l);		/* RCMP1f[^擾 */
		reg = atol(szBuf);
		ct520_wXYReg(hDev, 0x82,  reg);						/* RCMP1f[^ */
		
		/* Rp[^rJE^ݒ(XCTR) */
		rnv1 &= ~0x01000000;

		rnv2 &= ~0x0000000f;								/* Rp[^ݒ */
		rnv2 |=  0x00000002;								/* Rp[^(XCTR = XYRCMP1) */
		rnv2 &= ~0x10000000;								/* CMPOUT1,CMPOUT2M */

		/* XYOUT1̏o͂CMPOUT1ɐݒ */
		/* Rp[^ݒ|[gݒ */
		cmpp |=  0x0001;									/* CMPOUT1M */

		/* vo͐ݒ */
		cinp &= ~0x0001;									/* XTOUT1CMPOUT1Mo */
	} else {
		rnv2 |=  0x10000000;								/* CMPOUT1,CMPOUT2M}XN */
		cmpp &= ~0x0001;									/* CMPOUT1M}XN */
	}
	
	/* b`ݒ */
	ltcp &= ~0x00ff;
	if(IsDlgButtonChecked(hwnd, IDC_CHK_XZIN) == BST_CHECKED) ltcp |= 0x0010;
	if(IsDlgButtonChecked(hwnd, IDC_CHK_YZIN) == BST_CHECKED) ltcp |= 0x0020;
	if(IsDlgButtonChecked(hwnd, IDC_CHK_ETMR) == BST_CHECKED) ltcp |= 0x0008;
	if(IsDlgButtonChecked(hwnd, IDC_CHK_IN1)  == BST_CHECKED) ltcp |= 0x0004;
	if(IsDlgButtonChecked(hwnd, IDC_CHK_CMP1) == BST_CHECKED) ltcp |= 0x0001;

	/* WX^EIvV|[g */
	ct520_wXYReg(hDev, 0x87, rnv1);			/* ݒP */
	ct520_wXYReg(hDev, 0x88, rnv2);			/* ݒQ */
	ct520_wPortW(hDev, CMP_PORT,  cmpp);	/* Rp[^o͐ݒ|[g */
	ct520_wPortW(hDev, TMR_PORT,  tmrp);	/* Cxg^C}o͐ݒ|[g */
	ct520_wPortW(hDev, CIN_PORT,  cinp);	/* vo͐ݒ|[g */
	ct520_wPortW(hDev, LTC_PORT,  ltcp);	/* b`ݒ|[g */
	
	if(IsDlgButtonChecked(hwnd, IDC_CHK_ETMR) == BST_CHECKED) {
		/* Cxg^C}擾 */
		GetDlgItemText(hwnd, IDC_EDT_ETMR, szBuf, 10l);
		reg = atol(szBuf);
		reg *= 100;

		/* Cxg^C}X^[g */
		ct520_wXYReg(hDev, 0x86, reg);
	}
}




