/************************************/
/*  HPCI-CTR520F series sample(Vc)	*/
/*	    file name:index.c			*/
/*      date     :2010/06/08		*/
/*      version  :1.1.0.0 			*/
/************************************/

#include	<windows.h>
#include	"resource.h"
#include	"hictr520.h"
#include	"spct5200.h"

/* JnEI */
void	FormLoad(HWND);		/* vOJn */

/*	又  */
int APIENTRY WinMain(HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lqszArgs, int nWinMode)
{
	HWND		hwnd;
	MSG			msg;
	WNDCLASSEX	wc;
	char        szAppName[] = "MainDlg", *dummy;
	
	dummy = lqszArgs;	

	if (!hPrevInst)	{
		/* EBhENX` */
		wc.style		 =	CS_HREDRAW | CS_VREDRAW;			/* EBhE̎(TCYύXĕ`) */
		wc.lpfnWndProc	 =	(WNDPROC)WndProc;					/* EChE֐̃AhX */
		wc.cbClsExtra	 =	0;									/* ̑̃NX */
		wc.cbWndExtra	 =	DLGWINDOWEXTRA;						/* ̑̃EBhE */
		wc.hInstance	 =	hThisInst;							/* ̃CX^X̃nh */
		wc.hIcon		 =	LoadIcon(NULL, IDI_APPLICATION);	/* WACR̃nh */
		wc.hCursor		 =	LoadCursor(NULL, IDC_ARROW);		/* }EXJ[\̃nh */
		wc.hbrBackground =	(HBRUSH)(COLOR_BTNFACE + 1);		/* EBhE̔wiF({^̕\ʂ̉e) */
		wc.lpszMenuName	 =	NULL;								/* Cj[̖O */
		wc.lpszClassName =	szAppName;							/* EBhENX̖O */
		wc.cbSize		 =	sizeof(WNDCLASSEX);					/* WNDCLASSEX\̂̃TCYݒ */
		wc.hIconSm		 =	LoadIcon(NULL, IDI_WINLOGO);		/* X[ACR */		
		if (!RegisterClassEx(&wc)) return 0;					/* EBhENXo^ */
	}

	hInst = hThisInst;		/* ݂̃CX^Xnhۑ */	

	/* EBhENX̓o^ł̂ŁCC̃_CAO{bNX𐶐 */
 	hwnd = CreateDialog(hInst, "IDD_DLGINX", 0, (DLGPROC)WndProc);
	if(hwnd)	hInx = hwnd;
	else		return 0;

	/* EBhE\ */
	ShowWindow  (hwnd, nWinMode);
	UpdateWindow(hwnd);

	/* bZ[W[v𐶐 */
	while (GetMessage(&msg, NULL, 0, 0)) {
		if (!IsDialogMessage(hwnd, &msg)) {
			TranslateMessage(&msg);			/* L[{[hp\ɂ */
			DispatchMessage (&msg);			/* Windowsɖ߂ */
		}
	}
	return msg.wParam;
}

/*	Windows ĂяoāCbZ[WL[       */
/*  bZ[Ẅn󂯂鏈(C̃EBhE) */
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	char	szBuf[16];
	DWORD	brdid;
		
	switch (message) {
		/*  */
		case WM_INITDIALOG:
			FormLoad(hwnd);
			break;

		/* {^NbN̏ */
		case WM_COMMAND:
			if((LOWORD(wParam) == IDC_RAD_CTR) ||
			   (LOWORD(wParam) == IDC_RAD_LTC) ||
			   (LOWORD(wParam) == IDC_RAD_CMP) ||
			   (LOWORD(wParam) == IDC_RAD_TMR) ||
			   (LOWORD(wParam) == IDC_RAD_CLR) ||
			   (LOWORD(wParam) == IDC_RAD_DIO) ||
			   (LOWORD(wParam) == IDC_RAD_M_M) ||
			   (LOWORD(wParam) == IDC_RAD_WDT)) {
				GetDlgItemText(hwnd, IDC_EDT_BDID, szBuf, 3);
				brdid = atol(szBuf);
				if(brdid > 15) {
					MessageBox(hwnd, "{[hhc͂O`PT܂ł̒lłD", "", MB_OK);
					break;
				} else {
					gBrdID = brdid;
				}
			}

			switch (LOWORD(wParam)) {
			case IDC_BTN_OK:
				if(IsDlgButtonChecked(hwnd, IDC_RAD_CTR) == BST_CHECKED) {
					hDlg = CreateDialog(hInst, "IDD_DLGCTR", hwnd, (DLGPROC)DlgCtrProc);
				} else if(IsDlgButtonChecked(hwnd, IDC_RAD_LTC) == BST_CHECKED) {
					hDlg = CreateDialog(hInst, "IDD_DLGLTC", hwnd, (DLGPROC)DlgLtcProc);
				} else if(IsDlgButtonChecked(hwnd, IDC_RAD_CMP) == BST_CHECKED) {
					hDlg = CreateDialog(hInst, "IDD_DLGCMP", hwnd, (DLGPROC)DlgCmpProc);
				} else if(IsDlgButtonChecked(hwnd, IDC_RAD_TMR) == BST_CHECKED) {
					hDlg = CreateDialog(hInst, "IDD_DLGTMR", hwnd, (DLGPROC)DlgTmrProc);
				} else if(IsDlgButtonChecked(hwnd, IDC_RAD_CLR) == BST_CHECKED) {
					hDlg = CreateDialog(hInst, "IDD_DLGZCL", hwnd, (DLGPROC)DlgZclProc);
				} else if(IsDlgButtonChecked(hwnd, IDC_RAD_DIO) == BST_CHECKED) {
					hDlg = CreateDialog(hInst, "IDD_DLGDIO", hwnd, (DLGPROC)DlgDioProc);
				} else if(IsDlgButtonChecked(hwnd, IDC_RAD_M_M) == BST_CHECKED) {
					hDlg = CreateDialog(hInst, "IDD_DLGM_M", hwnd, (DLGPROC)DlgMaxMinProc);
				} else if(IsDlgButtonChecked(hwnd, IDC_RAD_WDT) == BST_CHECKED) {
					hDlg = CreateDialog(hInst, "IDD_DLGWDT", hwnd, (DLGPROC)DlgWdtProc);
				} else if(IsDlgButtonChecked(hwnd, IDC_RAD_END) == BST_CHECKED) {
					DestroyWindow(hwnd);
					break;
				}
				ShowWindow(hInx, SW_HIDE);
				break;
			}
			break;

		/* I */
		case WM_CLOSE:
			/* _CAO{bNX */
			DestroyWindow(hwnd);
			break;

		/* vOI */
		case WM_DESTROY:
			PostQuitMessage(0);
			break;

		/* LȊÕbZ[WWindows ɏ */
		default:
			return DefWindowProc(hwnd, message, wParam, lParam);
	}
	return 0;
}

/* EBhȄ */
void FormLoad(HWND hwnd)
{
	HDC		hDC;
	int		h, w;	/* ʑŜ̕,  */	
	RECT	rct;	/* ʕ\ ʒu, 傫...XN[P */
	char	szBuf[16];
	
	/* ʍW擾 */
	w = GetSystemMetrics(SM_CXSCREEN);	/* ʑŜ̕ */
	h = GetSystemMetrics(SM_CYSCREEN);	/* ʑŜ̍ */

	/* EBhE̋E`̐@擾 */
	GetWindowRect(hwnd, &rct);
	rct.right  = rct.right  - rct.left;
	rct.bottom = rct.bottom - rct.top;

	/*  EBhE𒆉Ɉړ */
	rct.top  = (h - rct.bottom) / 2 - 15;
	rct.left = (w - rct.right ) / 2;
	MoveWindow(hwnd, rct.left, rct.top, rct.right, rct.bottom, TRUE);

	/* w肳ꂽEBhẼNCAg̈ɑ΂foCXReLXg̃nh擾 */
	hDC = GetDC(hwnd);

	/* foCXReLXg */
	ReleaseDC(hwnd, hDC);

	/* rbg}bṽ[h */
	hWht = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_WHITE));
	hGrn = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_GREEN));	

	CheckDlgButton(hwnd, IDC_RAD_CTR, BST_CHECKED);

	SendDlgItemMessage(hwnd, IDC_EDT_BDID, EM_SETLIMITTEXT, 2l, 0l);
	_ltoa(BRD_ID, szBuf, 10);
	SetDlgItemText(hwnd, IDC_EDT_BDID,	szBuf);
	SetFocus(GetDlgItem(hwnd, IDC_EDT_BDID));
}