//***********************************************************
//  HPCI-CTR520F series
//  Sample Program for C#.NET2003
//      file name:Common.cs
//      date     :2010/06/11
//      version  :1.00
//***********************************************************

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace spct5204
{
	/// <summary>
	/// Common ̊Tv̐łB
	/// </summary>
	public class Common
	{
		// Tuʔԍ
		public const short H1_CTR = 1;	// ʏ̃JEg
		public const short H2_LTC = 2;	// b`
		public const short H3_CMP = 3;	// Rp[^
		public const short H4_TMR = 4;	// Cxg^C}
		public const short H5_ZCL = 5;	// y͂ɂJE^NA
		public const short H6_DIO = 6;	// ėpo
		public const short H7_MM  = 7;	// ől|ŏlv
		public const short H8_WDT = 8;	// M@̌v

		// [NpIuWFNg
		public static System.Windows.Forms.Button			wCmdOpen;
		public static System.Windows.Forms.Button			wCmdClose;
		public static System.Windows.Forms.Label[]			wLabel			= new System.Windows.Forms.Label[7];
		public static System.Windows.Forms.GroupBox[]		wGroupBox		= new System.Windows.Forms.GroupBox[7];
		public static System.Windows.Forms.Label[]			wStatus			= new System.Windows.Forms.Label[2];

		public static System.Windows.Forms.Button[]			wCmdRead		= new System.Windows.Forms.Button[2];
		public static System.Windows.Forms.Button[]			wCmdClear		= new System.Windows.Forms.Button[2];
		public static System.Windows.Forms.Button[]			wCmdStart		= new System.Windows.Forms.Button[2];
		public static System.Windows.Forms.Button[]			wCmdStop		= new System.Windows.Forms.Button[2];
		public static System.Windows.Forms.RadioButton[]	wOptInput		= new System.Windows.Forms.RadioButton[6];
		public static System.Windows.Forms.RadioButton[]	wOptRead		= new System.Windows.Forms.RadioButton[2];
		public static System.Windows.Forms.RadioButton[]	wOptWidth		= new System.Windows.Forms.RadioButton[3];
		public static System.Windows.Forms.RadioButton[]	wOptOperation	= new System.Windows.Forms.RadioButton[7];
		public static System.Windows.Forms.CheckBox			wChkReadClear;

		public static System.Windows.Forms.Label[]			wLblCtr			= new System.Windows.Forms.Label[2];
		public static System.Windows.Forms.Label[]			wLblLtch		= new System.Windows.Forms.Label[5];
		public static System.Windows.Forms.Label[]			wLblMax			= new System.Windows.Forms.Label[2];
		public static System.Windows.Forms.Label[]			wLblMin			= new System.Windows.Forms.Label[2];

		public static System.Windows.Forms.CheckBox[]		wChkLtch		= new System.Windows.Forms.CheckBox[7];
		public static System.Windows.Forms.CheckBox[]		wChkZclr		= new System.Windows.Forms.CheckBox[2];
		public static System.Windows.Forms.TextBox			wTxtRcmp;
		public static System.Windows.Forms.TextBox			wTxtTmr;
		public static System.Windows.Forms.TextBox			wTxtInterval;

		public static System.Windows.Forms.Button			wCmdStrtTmr;
		public static System.Windows.Forms.Button			wCmdStopTmr;
		public static System.Windows.Forms.Button[]			wCmdStrtMM		= new System.Windows.Forms.Button[2];
		public static System.Windows.Forms.Button[]			wCmdStopMM		= new System.Windows.Forms.Button[2];
		public static System.Windows.Forms.Button[]			wCmdInitMM		= new System.Windows.Forms.Button[2];

		public Common()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		//-----------------------------------------------
		// tH[ʃ\bh
		//-----------------------------------------------
		public static void CommonFormLoad(short FormNo)
		{
			short n;

			//--------------------------------------
			// ʉ
			//--------------------------------------

			wCmdOpen.Enabled = true;
			wCmdClose.Enabled = false;

			wLabel[0].Enabled = false;
			wLabel[1].Enabled = false;
			wLabel[2].Enabled = false;
			wLabel[3].Enabled = false;

			wGroupBox[0].Enabled = false;
			wGroupBox[1].Enabled = false;

			wStatus[0].Enabled = false;
			wStatus[1].Enabled = false;

			wCmdRead[0].Enabled = false;
			wCmdRead[1].Enabled = false;
			wCmdClear[0].Enabled = false;
			wCmdClear[1].Enabled = false;
			wCmdStart[0].Enabled = false;
			wCmdStart[1].Enabled = false;
			wCmdStop[0].Enabled = false;
			wCmdStop[1].Enabled = false;

			wOptInput[spct5204.MLT1_NO].Enabled = false;
			wOptInput[spct5204.MLT1_NO].Checked = false;
			wOptInput[spct5204.MLT2_NO].Enabled = false;
			wOptInput[spct5204.MLT2_NO].Checked = false;
			wOptInput[spct5204.MLT4_NO].Enabled = false;
			wOptInput[spct5204.MLT4_NO].Checked = false;
			wOptInput[spct5204.UPDN_NO].Enabled = false;
			wOptInput[spct5204.UPDN_NO].Checked = false;
			wOptInput[spct5204.DIRC_NO].Enabled = false;
			wOptInput[spct5204.DIRC_NO].Checked = false;

			for ( n=0; n<2; n++ )
			{
				wOptRead[n].Enabled = false;
				wOptRead[n].Checked = false;
			}

			wChkReadClear.Enabled = false;
			wChkReadClear.Checked = false;

			//--------------------------------------
			// ʉ
			//--------------------------------------

			// iH2_LTCjb`
			if ( FormNo == H2_LTC )
			{
				wLabel[4].Enabled = false;
				wLabel[5].Enabled = false;
				wLabel[6].Enabled = false;

				wGroupBox[2].Enabled = false;

				wTxtRcmp.BackColor = System.Drawing.SystemColors.Control;
				wTxtRcmp.Enabled = false;
				wTxtRcmp.Text = "";
				wTxtTmr.BackColor = System.Drawing.SystemColors.Control;
				wTxtTmr.Enabled = false;
				wTxtTmr.Text = "";
				for ( n=0; n<5; n++ )
				{
					wChkLtch[n].Enabled = false;
					wChkLtch[n].Checked = false;
				}
			}

			// iH4_TMRjCxg^C}
			if ( FormNo == H4_TMR )
			{
				wLabel[4].Enabled = false;

				wTxtInterval.BackColor = System.Drawing.SystemColors.Control;
				wTxtInterval.Enabled = false;
				wTxtInterval.Text = "";
				wCmdStrtTmr.Enabled = false;
				wCmdStopTmr.Enabled = false;

				for ( n=0; n<7; n++ )
				{
					wOptOperation[n].Enabled = false;
					wOptOperation[n].Checked = false;
				}
			}

			// iH5_ZCLjy͂ł̃JE^NA
			if ( FormNo == H5_ZCL )
			{
				for ( n=0; n<2; n++ )
				{
					wChkZclr[n].Enabled = false;
					wChkZclr[n].Checked = false;
				}
			}

			// iH7_MMjől|ŏlv
			if ( FormNo == H7_MM )
			{
				wLabel[4].Enabled = false;
				wLabel[5].Enabled = false;

				for ( n=0; n<2; n++ )
				{
					wLblMax[n].Enabled = false;
					wLblMin[n].Enabled = false;
					wCmdStrtMM[n].Enabled = false;
					wCmdStopMM[n].Enabled = false;
					wCmdInitMM[n].Enabled = false;
				}
			}
		}

		//-----------------------------------------------
		// tH[Iʃ\bh
		//-----------------------------------------------
		public static void CommonFormClose(h0_index menuFrm)
		{
			uint ret;

			if ( spct5204.hDev != spct5204.NO_DEVICE_HNDL ) 
			{
				ret = hictr520.ct520_CloseDevice(spct5204.hDev);
				spct5204.hDev = spct5204.NO_DEVICE_HNDL;
			}

			menuFrm.TxtBrdID.Text = spct5204.gBrdID.ToString();
			menuFrm.IDC_RAD_CTR.Checked = true;
			menuFrm.Show();
		}

		//-----------------------------------------------
		// [Open Device]{^ʃ\bh
		//-----------------------------------------------
		public static void CommonCmdOpen(short FormNo)
		{
			uint ret;
			short n;

			// {[hI[v
			ret = OpenDevice();
			if ( ret != 0 ) return;

			// x
			wLabel[0].Enabled = true;
			wLabel[1].Enabled = true;
			wLabel[2].Enabled = true;
			wLabel[3].Enabled = true;

			// O[v{bNX
			wGroupBox[0].Enabled = true;
			wGroupBox[1].Enabled = true;

			// ʃRg[
			wChkReadClear.Enabled = true;

			wCmdOpen.Enabled = false;
			wCmdClose.Enabled = true;

			wStatus[0].Enabled = true;
			wStatus[1].Enabled = true;
			wCmdRead[0].Enabled = true;
			wCmdRead[1].Enabled = true;
			wCmdStart[0].Enabled = true;
			wCmdStart[1].Enabled = true;
			wCmdClear[0].Enabled = true;
			wCmdClear[1].Enabled = true;
	
			wOptInput[spct5204.MLT1_NO].Enabled = true;
			wOptInput[spct5204.MLT2_NO].Enabled = true;
			wOptInput[spct5204.MLT4_NO].Enabled = true;
			wOptInput[spct5204.UPDN_NO].Enabled = true;
			wOptInput[spct5204.DIRC_NO].Enabled = true;

			wOptInput[spct5204.MLT4_NO].Checked = true;

			for ( n=0; n<2; n++ )
			{
				wOptRead[n].Enabled = true;
			}
			wOptRead[1].Checked = true;

			//--------------------------------------
			// ʉ
			//--------------------------------------

			// iH2_LTCjb`
			if ( FormNo == H2_LTC )
			{
				wGroupBox[2].Enabled = true;

				wLabel[4].Enabled = true;
				wLabel[5].Enabled = true;
				wLabel[6].Enabled = true;

				wLblLtch[0].Text = "0";
				wLblLtch[1].Text = "0";
				wTxtRcmp.BackColor = System.Drawing.Color.White;
				wTxtRcmp.Enabled = true;
				wTxtRcmp.Text = "1000";
				wTxtTmr.BackColor = System.Drawing.Color.White;
				wTxtTmr.Enabled = true;
				wTxtTmr.Text = "1000";
				for ( n=0; n<5; n++ )
				{
					wChkLtch[n].Enabled = true;
				}
			}

			// iH4_TMRjCxg^C}
			if ( FormNo == H4_TMR )
			{
				wLabel[4].Enabled = true;

				wGroupBox[2].Enabled = true;
				wGroupBox[3].Enabled = true;
				wGroupBox[4].Enabled = true;

				wTxtInterval.BackColor = System.Drawing.Color.White;
				wTxtInterval.Enabled = true;
				wTxtInterval.Text = "1000";
				wCmdStrtTmr.Enabled = true;
				wCmdStopTmr.Enabled = false;
				for ( n=0; n<3; n++ )
				{
					wOptWidth[n].Enabled = true;
				}
				for ( n=0; n<7; n++ )
				{
					wOptOperation[n].Enabled = true;
				}
				wOptWidth[0].Checked = true;
				wOptOperation[0].Checked = true;
			}

			// iH5_ZCLjy͂ł̃JE^NA
			if ( FormNo == H5_ZCL )
			{
				for ( n=0; n<2; n++ )
				{
					wChkZclr[n].Enabled = true;
				}
			}

			// iH7_MMjől|ŏlv
			if ( FormNo == H7_MM )
			{
				wLabel[4].Enabled = true;
				wLabel[5].Enabled = true;

				for ( n=0; n<2; n++ )
				{
					wLblMax[n].Enabled = true;
					wLblMin[n].Enabled = true;
					wCmdStrtMM[n].Enabled = true;
					wCmdStopMM[n].Enabled = true;
					wCmdInitMM[n].Enabled = true;
					wLblCtr[n].Text = "0";
					wLblMax[n].Text = "0";
					wLblMin[n].Text = "0";
				}
			}
		}

		//-----------------------------------------------
		// {[hI[v
		//-----------------------------------------------
		public static uint OpenDevice()
		{
			uint ret;

			if (spct5204.hDev == spct5204.NO_DEVICE_HNDL)
			{
				// {[hI[v
				ret = spct5204.sct520_OpenID(ref spct5204.hDev, ref spct5204.gBrdID);
				if (0x1000 == (ret & 0x1000))
				{
					MessageBox.Show("{[h擾s!\n" + 
						"{[h}ĂȂAhCoCXg[ĂȂ̃G[",
						"", MessageBoxButtons.OK, MessageBoxIcon.Error);
					return( 1 );
				}
				else if (0x2000 == (ret & 0x2000))
				{
					MessageBox.Show("foCX擾s!\n" + 
						"VXes̃G[", 
						"", MessageBoxButtons.OK, MessageBoxIcon.Error);
					return( 1 );
				}
				else if (0x4000 == (ret & 0x4000))
				{
					MessageBox.Show("w肵{[hID = " + spct5204.gBrdID + "̃{[h}Ă܂!",
						"", MessageBoxButtons.OK, MessageBoxIcon.Error);
					return( 1 );
				}
				else if (0x8000 == (ret & 0x8000))
				{
					MessageBox.Show("foCXI[vs!\n" +
						"VXes̃G[", 
						"", MessageBoxButtons.OK, MessageBoxIcon.Error);
					return( 1 );
				}
			}

			// {[h̏
			ret = spct5204.sct520_InitCtr(ref spct5204.hDev);
			if (ret != 0)
			{
				MessageBox.Show("JE^[s!", 
					"", MessageBoxButtons.OK, MessageBoxIcon.Error);
				ret = hictr520.ct520_CloseDevice(spct5204.hDev);
				spct5204.hDev = spct5204.NO_DEVICE_HNDL;
				return( ret );
			}
			return( 0 );
		}			

		//-----------------------------------------------
		// [Close Device]{^ʃ\bh
		//-----------------------------------------------
		public static void CommonCmdClose(short FormNo)
		{
			short n;

			//--------------------------------------
			// ʉ
			//--------------------------------------

			wLabel[0].Enabled = false;
			wLabel[1].Enabled = false;
			wLabel[2].Enabled = false;
			wLabel[3].Enabled = false;

			wGroupBox[0].Enabled = false;
			wGroupBox[1].Enabled = false;

			wChkReadClear.Enabled = false;
			wChkReadClear.Checked = false;

			wCmdOpen.Enabled = true;
			wCmdClose.Enabled = false;

			wStatus[0].Enabled = false;
			wStatus[1].Enabled = false;
			wStatus[0].BackColor = System.Drawing.SystemColors.Control;
			wStatus[1].BackColor = System.Drawing.SystemColors.Control;
			wCmdRead[0].Enabled = false;
			wCmdRead[1].Enabled = false;
			wCmdClear[0].Enabled = false;
			wCmdClear[1].Enabled = false;
			wCmdStart[0].Enabled = false;
			wCmdStart[1].Enabled = false;
			wCmdStop[0].Enabled = false;
			wCmdStop[1].Enabled = false;

			wOptInput[spct5204.MLT1_NO].Enabled = false;
			wOptInput[spct5204.MLT1_NO].Checked = false;
			wOptInput[spct5204.MLT2_NO].Enabled = false;
			wOptInput[spct5204.MLT2_NO].Checked = false;
			wOptInput[spct5204.MLT4_NO].Enabled = false;
			wOptInput[spct5204.MLT4_NO].Checked = false;
			wOptInput[spct5204.UPDN_NO].Enabled = false;
			wOptInput[spct5204.UPDN_NO].Checked = false;
			wOptInput[spct5204.DIRC_NO].Enabled = false;
			wOptInput[spct5204.DIRC_NO].Checked = false;

			for ( n=0; n<2; n++ )
			{
				wOptRead[n].Enabled = false;
				wOptRead[n].Checked = false;
			}

			//--------------------------------------
			// ʉ
			//--------------------------------------

			// iH2_LTCjb`
			if ( FormNo == H2_LTC )
			{
				wGroupBox[2].Enabled = false;

				wLabel[4].Enabled = false;
				wLabel[5].Enabled = false;
				wLabel[6].Enabled = false;

				wTxtRcmp.BackColor = System.Drawing.SystemColors.Control;
				wTxtRcmp.Enabled = false;
				wTxtRcmp.Text = "";
				wTxtTmr.BackColor = System.Drawing.SystemColors.Control;
				wTxtTmr.Enabled = false;
				wTxtTmr.Text = "";
				for ( n=0; n<5; n++ )
				{
					wChkLtch[n].Enabled = false;
					wChkLtch[n].Checked = false;
				}
			}

			// iH4_TMRjCxg^C}
			if ( FormNo == H4_TMR )
			{
				wLabel[4].Enabled = false;
				wGroupBox[2].Enabled = false;
				wGroupBox[3].Enabled = false;
				wGroupBox[4].Enabled = false;

				wTxtInterval.BackColor = System.Drawing.SystemColors.Control;
				wTxtInterval.Enabled = false;
				wTxtInterval.Text = "";
				wCmdStrtTmr.Enabled = false;
				wCmdStopTmr.Enabled = false;

				for ( n=0; n<3; n++ )
				{
 					wOptWidth[n].Enabled = false;
					wOptWidth[n].Checked = false;
				}
				for ( n=0; n<7; n++ )
				{
					wOptOperation[n].Enabled = false;
					wOptOperation[n].Checked = false;
				}
			}

			// iH5_ZCLjy͂ł̃JE^NA
			if ( FormNo == H5_ZCL )
			{
				for ( n=0; n<2; n++ )
				{
					wChkZclr[n].Enabled = false;
					wChkZclr[n].Checked = false;
				}
			}

			// iH7_MMjől|ŏlv
			if ( FormNo == H7_MM )
			{
				wLabel[4].Enabled = false;
				wLabel[5].Enabled = false;

				for ( n=0; n<2; n++ )
				{
					wLblMax[n].Enabled = false;
					wLblMin[n].Enabled = false;
					wCmdStrtMM[n].Enabled = false;
					wCmdStopMM[n].Enabled = false;
					wCmdInitMM[n].Enabled = false;
				}
			}
		}

		//-----------------------------------------------
		// [Read Data]{^ʃ\bh
		//-----------------------------------------------
		public static void CommonCmdReadData(object sender, short FormNo)
		{
			int		w_reg;
			uint	reg = 0;
			ushort	Index;

			for ( Index=0; Index<2; Index++ )
			{
				if ( sender.Equals(wCmdRead[Index]) )	break;
			}

			spct5204.sct520_ReadCtr(ref spct5204.hDev, ref Index, ref reg);
			w_reg = (int)reg;
			wLblCtr[Index].Text = w_reg.ToString("D");

			// ʉ
			if ( FormNo == H2_LTC )
			{
				spct5204.sct520_ReadLtc(ref spct5204.hDev, ref Index, ref reg);
				w_reg = (int)reg;
				wLblLtch[Index].Text = w_reg.ToString("D");
			}

			if ( FormNo == H4_TMR )
			{
				spct5204.sct520_ReadLtc(ref spct5204.hDev, ref Index, ref reg);
				w_reg = (int)reg;
				wLblLtch[Index].Text = w_reg.ToString("D");
			}

			if ( FormNo == H7_MM )
			{
				spct5204.sct520_ReadMax(ref spct5204.hDev, ref Index, ref reg);
				w_reg = (int)reg;
				wLblMax[Index].Text = w_reg.ToString("D");
				spct5204.sct520_ReadMin(ref spct5204.hDev, ref Index, ref reg);
				w_reg = (int)reg;
				wLblMin[Index].Text = w_reg.ToString("D");
			}
		}

		//-----------------------------------------------
		// [Clear]{^ʃ\bh
		//-----------------------------------------------
		public static void CommonCmdClear(object sender)
		{
			int		w_reg;
			uint	reg = 0;
			ushort	Index;

			for ( Index=0; Index<2; Index++ )
			{
				if ( sender.Equals(wCmdClear[Index]) )	break;
			}

			spct5204.sct520_ClrCtr(ref spct5204.hDev, ref Index);
			spct5204.sct520_ReadCtr(ref spct5204.hDev, ref Index, ref reg);
			w_reg = (int)reg;
			wLblCtr[Index].Text = w_reg.ToString("D");
		}

		//-----------------------------------------------
		// [Start]{^ʃ\bh
		//-----------------------------------------------
		public static void CommonCmdStart(object sender, short FormNo)
		{
			uint	ret;
			ushort	sts = 0;
			ushort	Index;
			ushort	x_ch = spct5204.X_CH;
			ushort	y_ch = spct5204.Y_CH;
			ushort	n;
			ushort	n0=0, n1=1;

			for ( Index=0; Index<2; Index++ )
			{
				if ( sender.Equals(wCmdStart[Index]) )	break;
			}

			if( FormNo == H2_LTC )
			{
				ret = hictr520.ct520_rXYSts(spct5204.hDev, ref sts);
				if ( Index == spct5204.X_CH )
				{
					if ( 0x20 == (sts & 0x20))
					{
						ret = SetLtcData();
						if ( ret != 0 )
						{
							return;
						}
					}
				}
				if ( Index == spct5204.Y_CH )
				{
					if ( 0x10 == (sts & 0x10))
					{
						ret = SetLtcData();
						if ( ret != 0 )
						{
							return;
						}
					}
				}
			}

			for ( n=0; n<5; n++ )
			{
				if ( n == 4 )	n = spct5204.DIRC_NO;
				if ( wOptInput[n].Checked == true )
				{
					spct5204.sct520_SelCtrMode(ref spct5204.hDev, ref x_ch, ref n);
					spct5204.sct520_SelCtrMode(ref spct5204.hDev, ref y_ch, ref n);
				}
			}

			if (wChkReadClear.Checked == true)
			{
				spct5204.sct520_SetAutoClr(ref spct5204.hDev, ref x_ch, ref n1);
				spct5204.sct520_SetAutoClr(ref spct5204.hDev, ref y_ch, ref n1);
			}
			else
			{
				spct5204.sct520_SetAutoClr(ref spct5204.hDev, ref x_ch, ref n0);
				spct5204.sct520_SetAutoClr(ref spct5204.hDev, ref y_ch, ref n0);
			}

			// 쒆̎̓JEg͌`Is
			wGroupBox[0].Enabled = false;
			wGroupBox[1].Enabled = false;
			if ( FormNo == H4_TMR )
			{
				wGroupBox[2].Enabled = false;
				wGroupBox[3].Enabled = false;
				wGroupBox[4].Enabled = false;
			}
			if ( FormNo == H2_LTC )
			{
				wGroupBox[2].Enabled = false;
				wLabel[5].Enabled = false;
				wLabel[6].Enabled = false;

				wTxtRcmp.BackColor = System.Drawing.SystemColors.Control;
				wTxtRcmp.Enabled = false;
				wTxtTmr.BackColor = System.Drawing.SystemColors.Control;
				wTxtTmr.Enabled = false;
			}

			wOptInput[spct5204.MLT1_NO].Enabled = false;
			wOptInput[spct5204.MLT2_NO].Enabled = false;
			wOptInput[spct5204.MLT4_NO].Enabled = false;
			wOptInput[spct5204.UPDN_NO].Enabled = false;
			wOptInput[spct5204.DIRC_NO].Enabled = false;

			if ( FormNo == H2_LTC )
			{
				for ( n=0; n<5; n++ )
				{
					wChkLtch[n].Enabled = false;
				}
			}

			for ( n=0; n<2; n++ )
			{
				wOptRead[n].Enabled = false;
			}
			wChkReadClear.Enabled = false;

			spct5204.sct520_StrtCtr(ref spct5204.hDev, ref Index);
			wCmdStart[Index].Enabled = false;
			wCmdStop[Index].Enabled = true;
		}

		//-----------------------------------------------
		// [Stop]{^ʃ\bh
		//-----------------------------------------------
		public static void CommonCmdStop(object sender, short FormNo)
		{
			ushort	Index;
			ushort	wdt = 0;
			ushort	sts = 0;
			uint	ret;

			for ( Index=0; Index<2; Index++ )
			{
				if ( sender.Equals(wCmdStop[Index]) )	break;
			}

			// iH2_LTCjb`
			if ( FormNo == H2_LTC )
			{
				ret = hictr520.ct520_rXYSts(spct5204.hDev, ref sts);
				if ( Index == spct5204.X_CH )
				{
					if ( 0x20 == (sts & 0x20))
					{
						// b`
						ret = hictr520.ct520_rPortW(spct5204.hDev, spct5204.LTC_PORT, ref wdt);
						wdt = (ushort)(wdt & (ushort)(0xFF00));
						ret = hictr520.ct520_wPortW(spct5204.hDev, spct5204.LTC_PORT, wdt);
					}
				}
				if ( Index == spct5204.Y_CH )
				{
					if ( 0x10 == (sts & 0x10))
					{
						// b`
						ret = hictr520.ct520_rPortW(spct5204.hDev, spct5204.LTC_PORT, ref wdt);
						wdt = (ushort)(wdt & (ushort)(0xFF00));
						ret = hictr520.ct520_wPortW(spct5204.hDev, spct5204.LTC_PORT, wdt);
					}
				}
			}

			spct5204.sct520_StopCtr(ref spct5204.hDev, ref Index);
			wCmdStart[Index].Enabled = true;
			wCmdStop[Index].Enabled = false;
		}

		//-----------------------------------------------
		// [MANU/AUTO]WI{^ʃ\bh
		//-----------------------------------------------
		public static void CommonOptRead(object sender)
		{
			ushort Index;

			for ( Index=0; Index<2; Index++ )
			{
				if ( sender.Equals(wOptRead[Index]) )	break;
			}

			if ( wOptRead[0].Checked == true )
			{
				wCmdRead[0].Enabled = true;
				wCmdRead[1].Enabled = true;
			}
			else
			{
				wCmdRead[0].Enabled = false;
				wCmdRead[1].Enabled = false;
			}
		}

		//-----------------------------------------------
		// ^C}Cxgʃ\bh
		//-----------------------------------------------
		public static void CommonTimSts(short FormNo)
		{
			ushort	sts = 0;
			ushort	n;
			uint	reg = 0;
			int		w_reg;
			uint	ret;

			// Xe[^XǍ
			ret = hictr520.ct520_rXYSts(spct5204.hDev, ref sts);
			if (0x10 == (sts & 0x10))
			{
				if (0x20 == (sts & 0x20))
				{
					// ~̎̓JEg͌`I
					wGroupBox[0].Enabled = true;
					wGroupBox[1].Enabled = true;

					wOptInput[spct5204.MLT1_NO].Enabled = true;
					wOptInput[spct5204.MLT2_NO].Enabled = true;
					wOptInput[spct5204.MLT4_NO].Enabled = true;
					wOptInput[spct5204.UPDN_NO].Enabled = true;
					wOptInput[spct5204.DIRC_NO].Enabled = true;

					if ( FormNo == H2_LTC )
					{
						wLabel[5].Enabled = true;
						wLabel[6].Enabled = true;

						wGroupBox[2].Enabled = true;

						wTxtRcmp.BackColor = System.Drawing.Color.White;
						wTxtRcmp.Enabled = true;
						wTxtTmr.BackColor = System.Drawing.Color.White;
						wTxtTmr.Enabled = true;

						for ( n=0; n<5; n++ )
						{
							wChkLtch[n].Enabled = true;
						}
					}

					if ( FormNo == H4_TMR )
					{
						wGroupBox[3].Enabled = true;
						wGroupBox[4].Enabled = true;
					}

					for ( n=0; n<2; n++ )
					{
						wOptRead[n].Enabled = true;
					}
					wChkReadClear.Enabled = true;
				}
			}

			if ( wOptRead[1].Checked == true )
			{
				for ( n=spct5204.X_CH; n<=spct5204.Y_CH; n++ )
				{
					spct5204.sct520_ReadCtr(ref spct5204.hDev, ref n, ref reg);	// JEglǍ
					w_reg = (int)reg;
					wLblCtr[n].Text = w_reg.ToString("D");
					if ( FormNo == H2_LTC )
					{
						spct5204.sct520_ReadLtc(ref spct5204.hDev, ref n, ref reg);
						w_reg = (int)reg;
						wLblLtch[n].Text = w_reg.ToString("D");
					}
					if ( FormNo == H4_TMR )
					{
						spct5204.sct520_ReadLtc(ref spct5204.hDev, ref n, ref reg);
						w_reg = (int)reg;
						wLblLtch[n].Text = w_reg.ToString("D");
					}
					if ( FormNo == H7_MM )
					{
						spct5204.sct520_ReadMax(ref spct5204.hDev, ref n, ref reg);	// őlǍ
						w_reg = (int)reg;
						wLblMax[n].Text = w_reg.ToString("D");
						spct5204.sct520_ReadMin(ref spct5204.hDev, ref n, ref reg);	// ŏlǍ
						w_reg = (int)reg;
						wLblMin[n].Text = w_reg.ToString("D");
					}
				}
			}

			// Xe[^X\
			if ( 0x10 == (sts & 0x10))
			{
				wStatus[0].BackColor = System.Drawing.Color.White;
			}
			else
			{
				wStatus[0].BackColor = System.Drawing.Color.Lime;
			}

			if ( 0x20 == (sts & 0x20))
			{
				wStatus[1].BackColor = System.Drawing.Color.White;
			}
			else
			{
				wStatus[1].BackColor = System.Drawing.Color.Lime;
			}
		}

		//-----------------------------------------------
		// iH2_LTCjb`ݒ
		//-----------------------------------------------
		public static uint SetLtcData()
		{
			int		w_reg;
			uint	reg = 0;
			uint	ret = 0;

			ushort	cmpp = 0;		// Rp|^o͐ݒ|[gf[^
			ushort	tmrp = 0;		// Cxg^C}o͐ݒ|[gf[^
			ushort	cinp = 0;		// vo͐ݒ|[gf[^
			ushort	ltcp = 0;		// b`ݒ|[gf[^
			uint	rnv1 = 0;		// ݒPWX^f[^
			uint	rnv2 = 0;		// ݒQWX^f[^

			ret = hictr520.ct520_rXYReg(spct5204.hDev, 0xC7, ref rnv1);					// ݒPǍ
			ret = hictr520.ct520_rXYReg(spct5204.hDev, 0xC8, ref rnv2);					// ݒQǍ
			ret = hictr520.ct520_rPortW(spct5204.hDev, spct5204.CMP_PORT, ref cmpp);	// Rp[^o͐ݒ|[gǍ
			ret = hictr520.ct520_rPortW(spct5204.hDev, spct5204.TMR_PORT, ref tmrp);	// Cxg^C}o͐ݒ|[gǍ
			ret = hictr520.ct520_rPortW(spct5204.hDev, spct5204.CIN_PORT, ref cinp);	// vo͐ݒ|[gǍ
			ret = hictr520.ct520_rPortW(spct5204.hDev, spct5204.LTC_PORT, ref ltcp);	// b`ݒ|[gǍ

			if (wChkLtch[4].Checked == true)
			{
				// Rp[^rf[^ݒ(XYRCMP1)
				try
				{
//					reg = uint.Parse(wTxtRcmp.Text);
					w_reg = int.Parse(wTxtRcmp.Text);
					reg = (uint)w_reg;
					ret = hictr520.ct520_wXYReg(spct5204.hDev, 0x82, reg);	// RCMP1f[^
				}
				catch
				{
					return( 1 );
				}

				rnv1 = unchecked(rnv1 & (uint)(~0x1000000));		// Rp[^rJE^ݒ(XCTR)
				rnv2 = unchecked(rnv2 & (uint)(~0xF));				// Rp[^ݒ
				rnv2 = unchecked(rnv2 | (uint)(0x2));				// Rp[^(XCTR = XYRCMP1)
				rnv2 = unchecked(rnv2 & (uint)(~0x10000000));		// CMPOUT1,CMPOUT2M

				// XYOUT1̏o͂CMPOUT1ɐݒ
				// Rp[^ݒ|[gݒ
				cmpp = (ushort)(cmpp | (ushort)(0x1));				// CMPOUT1M

				// vo͐ݒ
				cinp = (ushort)(cinp & unchecked((ushort)(~0x1)));	// XTOUT1CMPOUT1Mo
			}
			else
			{		
				rnv2 = rnv2 | 0x10000000;							// CMPOUT1,CMPOUT2M}XN
				cmpp = (ushort)(cmpp & unchecked((ushort)(~0x1)));	// CMPOUT1M}XN
			}

			// b`ݒ
			ltcp = (ushort)(ltcp & unchecked((ushort)(~0xFF)));
			if (wChkLtch[0].Checked == true)
			{
				ltcp = (ushort)(ltcp | (ushort)(0x10));				// wy͂œb`
			}
			if (wChkLtch[1].Checked == true)
			{
				ltcp = (ushort)(ltcp | (ushort)(0x20));				// xy͂œb`
			}
			if (wChkLtch[2].Checked == true)
			{
				ltcp = (ushort)(ltcp | (ushort)(0x08));				// Cxg^C}o͂œb`
			}
			if (wChkLtch[3].Checked == true)
			{
				ltcp = (ushort)(ltcp | (ushort)(0x04));				// hmPœb`
			}
			if (wChkLtch[4].Checked == true)
			{
				ltcp = (ushort)(ltcp | (ushort)(0x01));				// voXYOUT1œb`
			}

			// WX^EIvV|[g
			ret = hictr520.ct520_wXYReg(spct5204.hDev, 0x87, rnv1);					// ݒP
			ret = hictr520.ct520_wXYReg(spct5204.hDev, 0x88, rnv2);					// ݒQ
			ret = hictr520.ct520_wPortW(spct5204.hDev, spct5204.CMP_PORT, cmpp);	// Rp[^o͐ݒ|[g
			ret = hictr520.ct520_wPortW(spct5204.hDev, spct5204.TMR_PORT, tmrp);	// Cxg^C}o͐ݒ|[g
			ret = hictr520.ct520_wPortW(spct5204.hDev, spct5204.CIN_PORT, cinp);	// vo͐ݒ|[g
			ret = hictr520.ct520_wPortW(spct5204.hDev, spct5204.LTC_PORT, ltcp);	// b`ݒ|[g

			if (wChkLtch[2].Checked == true)
			{
				try
				{
					reg = uint.Parse(wTxtTmr.Text);
					reg = reg * 100;
					ret = hictr520.ct520_wXYReg(spct5204.hDev, 0x86, reg);	// Cxg^C}X^[g
				}
				catch
				{
					return( 1 );
				}
			}
			return( 0 );	// I
		}

		//-----------------------------------------------
		// iH4_TMRjCxg^C}̐ݒƃX^[g
		//-----------------------------------------------
		public static uint SetTmrData()
		{
			short	n;
			ushort	tmrp = 0;
			ushort	cinp = 0;
			uint	dwdt = 0;
			uint	rnv1 = 0;
			uint	etmr = 0;
			uint	ret;

			// WX^EIvV|[gǍ
			ret = hictr520.ct520_rXYReg(spct5204.hDev, 0xC7, ref rnv1);					// ݒPǍ
			ret = hictr520.ct520_rPortW(spct5204.hDev, spct5204.TMR_PORT, ref tmrp);	// Cxg^C}ݒ|[gǍ
			ret = hictr520.ct520_rPortW(spct5204.hDev, spct5204.CIN_PORT, ref cinp);	// vo͐ݒ|[gǍ

			// XYOUT2o͕ݒ
			if ( Common.wOptWidth[0].Checked == true)	// 10sec
			{
				tmrp = (ushort)(tmrp & unchecked((ushort)(~0x10)));			// gOȂ
				tmrp = (ushort)(tmrp | (ushort)(0x01));						// Cxg^C}M
				cinp = (ushort)(cinp & unchecked((ushort)(~0x20)));			// 104msecȂ
				cinp = (ushort)(cinp | (ushort)(0x02));						// XYOUT2̓Cxg^C}Mo
			}
			else if ( Common.wOptWidth[1].Checked == true)		// 104msec
			{
				tmrp = (ushort)(tmrp & unchecked((ushort)(~0x10)));			// gOȂ
				tmrp = (ushort)(tmrp | (ushort)(0x01));						// Cxg^C}M
				cinp = (ushort)(cinp | (ushort)(0x20));						// 104msec
				cinp = (ushort)(cinp | (ushort)(0x02));						// XYOUT2̓Cxg^C}Mo
			}
			else if ( Common.wOptWidth[2].Checked == true)		// duty50%gOo
			{
				tmrp = (ushort)(tmrp | (ushort)(0x10));						// gO
				tmrp = (ushort)(tmrp | (ushort)(0x01));						// Cxg^C}M
				cinp = (ushort)(cinp & unchecked((ushort)(~0x20)));			// 104msecȂ
				cinp = (ushort)(cinp | (ushort)(0x02));						// XYOUT2̓Cxg^C}Mo
			}

			// Cxg^C}ȍ͎
			for ( n=0; n<7; n++ )
			{
				if ( Common.wOptOperation[n].Checked == true)
				{
					dwdt = (uint)((uint)n * (uint)0x10000000);
					break;
				}
			}

			// ݒP bit28`30
			rnv1 = rnv1 & unchecked((uint)(~0x70000000));
			rnv1 = rnv1 | dwdt;

			// Cxg^C}擾
			try
			{
				etmr = uint.Parse(wTxtInterval.Text);
			}
			catch
			{
				return( 1 );
			}

			if ( Common.wOptWidth[1].Checked == true )
			{
				// XYOUT2o͕104msec̎̓Cxg^C}
				// 105msecȉɐݒs
				if ( etmr < 106 )
				{
					return( spct5204.ILL_PARAM );
				}
			}

			etmr = etmr * 100;		// WX^ݒlFetmr(msec) * 100

			// WX^EIvV|[g
			ret = hictr520.ct520_wXYReg(spct5204.hDev, 0x87, rnv1);		// ݒP
			ret = hictr520.ct520_wPortW(spct5204.hDev, spct5204.TMR_PORT, tmrp);	// Cxg^C}ݒ|[g
			ret = hictr520.ct520_wPortW(spct5204.hDev, spct5204.CIN_PORT, cinp);	// vo͐ݒ|[g
			ret = hictr520.ct520_wXYReg(spct5204.hDev, 0x86, etmr);		// Cxg^C}X^[g

			return( 0 );
		}
	}
}

