/********************************************/
/*  HPCI-CTR520F series						*/
/*  Driver I/F DLL Function for Windows		*/
/*	    file name:hictr520.h				*/
/*      date     :2003/02/20				*/
/*      version  :1.0.0.0 					*/
/********************************************/

#define INVALID_BUS_NUMBER	0xffffffff	// ȃoXԍ
#define INVALID_DEV_NUMBER	0xffffffff	// ȃfoCXԍ
#define INVALID_IO_ADDRESS	0xffffffff	//  I/O AhX
#define INVALID_IRQ_NUMBER	0xffffffff	//  IRQ ԍ
#define INVALID_HPC_NUMBER	0xffffffff	// ȊǗԍ
#define INVALID_BOARD_ID	0xffffffff	// ȃ{[hID

/* Structure */
typedef struct _HPCDEVICEINFO {		// foCX
	DWORD			nBusNumber;			// oXԍ
	DWORD			nDeviceNumber;		// foCXԍ
	DWORD			dwIoPortAddress;	// I/O |[gAhX
	DWORD			dwIrqNo;			// IRQ ԍ
	DWORD			dwNumber;			// Ǘԍ(Windows 95/98/Meł͖)
	DWORD			dwBoardID;			// {[hID			
} HPCDEVICEINFO, * PHPCDEVICEINFO;

/* Functions */
#ifdef __cplusplus
extern "C"
{
#endif

// foCX̎擾(FfoCX̃AhX)
__declspec(dllimport) DWORD WINAPI ct520_GetDeviceCount(DWORD*);

// foCX̎擾(FfoCX̌AfoCX񃊃Xg̐擪AhX)
__declspec(dllimport) DWORD WINAPI ct520_GetDeviceInfo(DWORD*, HPCDEVICEINFO*);

// foCXI[v(FfoCXnh̃AhXAfoCX̃AhX)
__declspec(dllimport) DWORD WINAPI ct520_OpenDevice(DWORD*, HPCDEVICEINFO*);

// foCXN[Y(FfoCXnh)
__declspec(dllimport) DWORD WINAPI ct520_CloseDevice(DWORD);

// wxchXe[^XǍ(FfoCXnhAf[^i[)		
__declspec(dllimport) DWORD WINAPI ct520_rXYSts(DWORD, WORD*);

// ytchXe[^XǍ(FfoCXnhAf[^i[)		
__declspec(dllimport) DWORD WINAPI ct520_rZUSts(DWORD, WORD*);

// wxchR}h(FfoCXnhAR}h)
__declspec(dllimport) DWORD WINAPI ct520_wXYCmd(DWORD, WORD);

// ytchR}h(FfoCXnhAR}h)
__declspec(dllimport) DWORD WINAPI ct520_wZUCmd(DWORD, WORD);

// wxchWX^Ǎ(FfoCXnhAR}hAf[^i[)
__declspec(dllimport) DWORD WINAPI ct520_rXYReg(DWORD, WORD, DWORD*);

// ytchWX^Ǎ(FfoCXnhAR}hAf[^i[)
__declspec(dllimport) DWORD WINAPI ct520_rZUReg(DWORD, WORD, DWORD*);

// wxchWX^(FfoCXnhAR}hAf[^)
__declspec(dllimport) DWORD WINAPI ct520_wXYReg(DWORD, WORD, DWORD);

// ytchWX^(FfoCXnhAR}hAf[^)
__declspec(dllimport) DWORD WINAPI ct520_wZUReg(DWORD, WORD, DWORD);

// IvV|[gPoCgǍ(FfoCXnhAItZbgAhXAf[^i[)
__declspec(dllimport) DWORD WINAPI ct520_rPortB(DWORD, BYTE, BYTE*);

// IvV|[gQoCgǍ(FfoCXnhAItZbgAhXAf[^i[)
__declspec(dllimport) DWORD WINAPI ct520_rPortW(DWORD, BYTE, WORD*);
	
// IvV|[gPoCg(FfoCXnhAItZbgAhXAf[^)
__declspec(dllimport) DWORD WINAPI ct520_wPortB(DWORD, BYTE, BYTE);

// IvV|[gQoCg(FfoCXnhAItZbgAhXAf[^)
__declspec(dllimport) DWORD WINAPI ct520_wPortW(DWORD, BYTE, WORD);

// wxcho̓obt@Ǎ(FfoCXnhAf[^i[)
__declspec(dllimport) DWORD WINAPI ct520_rXYBuf(DWORD, DWORD*);

// ytcho̓obt@Ǎ(FfoCXnhAf[^i[)
__declspec(dllimport) DWORD WINAPI ct520_rZUBuf(DWORD, DWORD*);

// wxcho̓obt@(FfoCXnhAf[^)
__declspec(dllimport) DWORD WINAPI ct520_wXYBuf(DWORD, DWORD);

// ytcho̓obt@(FfoCXnhAf[^)
__declspec(dllimport) DWORD WINAPI ct520_wZUBuf(DWORD, DWORD);

#ifdef __cplusplus
}
#endif
